! $Id: parameters.MSSM.omega.f90,v 1.3 2004/07/23 11:41:58 kilian Exp $
!
! Copyright (C) 2000 by Thorsten Ohl <ohl@hep.tu-darmstadt.de>
! and others
!
! O'Mega is free software; you can redistribute it and/or modify it
! under the terms of the GNU General Public License as published by
! the Free Software Foundation; either version 2, or (at your option)
! any later version.
!
! O'Mega is distributed in the hope that it will be useful, but
! WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, write to the Free Software
! Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
module omega_parameters_whizard
  use omega_kinds !NODEP!
  use omega_constants !NODEP!
  use omega_parameters_mssm !NODEP!
  use parameters
  implicit none
  private
  public :: import_from_whizard 
contains
  subroutine import_from_whizard (par)
   type(parameter_set), intent(in) :: par    
   real(kind=omega_prec) :: e, g, sinthw, costhw, qelep, qeup, qedwn, v
    mass(1:36) = 0
    width(1:36) = 0
    mass(3) = par%ms
    mass(4) = par%mc
    mass(5) = par%mb
    mass(6) = par%mtop
    width(6) = par%wtop
    mass(11) = par%me
    mass(13) = par%mmu
    mass(15) = par%mtau
    mass(23) = par%mZ
    width(23) = par%wZ
    mass(24) = par%mW
    width(24) = par%wW
    mass(25) = par%mh
    width(25) = par%wh
    mass(26) =  xi0 * mass(23)
    width(26) =  0
    mass(27) =  xipm * mass(24)
    width(27) =  0
    mass(35) = par%mHH
    width(35) = par%wHH
    mass(36) = par%mHA
    width(36) = par%wHA
    mass(37) = par%mHpm
    width(37) = par%wHpm
    mass(41) = par%msd1
    width(41) = par%wsd1
    mass(42) = par%msu1
    width(42) = par%wsu1
    mass(43) = par%mss1
    width(43) = par%wss1
    mass(44) = par%msc1
    width(44) = par%wsc1
    mass(45) = par%msb1
    width(45) = par%wsb1
    mass(46) = par%mstop1
    width(46) = par%wstop1
    mass(47) = par%msd2
    width(47) = par%wsd2
    mass(48) = par%msu2
    width(48) = par%wsu2
    mass(49) = par%mss2
    width(49) = par%wss2
    mass(50) = par%msc2
    width(50) = par%wsc2
    mass(51) = par%msb2
    width(51) = par%wsb2
    mass(52) = par%mstop2
    width(52) = par%wstop2
    mass(53) = par%mse1
    width(53) = par%wse1
    mass(54) = par%msne
    width(54) = par%wsne
    mass(55) = par%msmu1
    width(55) = par%wsmu1
    mass(56) = par%msnmu
    width(56) = par%wsnmu
    mass(57) = par%mstau1
    width(57) = par%wstau1
    mass(58) = par%msntau
    width(58) = par%wsntau
    mass(59) = par%mse2
    width(59) = par%wse2
    mass(61) = par%msmu2
    width(61) = par%wsmu2
    mass(63) = par%mstau2
    width(63) = par%wstau2
    mass(64) = par%mgg
    width(64) = par%wgg
    mass(65) = par%mneu1   
    width(65) = par%wneu1
    mass(66) = par%mneu2   
    width(66) = par%wneu2
    mass(67) = par%mneu3   
    width(67) = par%wneu3
    mass(68) = par%mneu4   
    width(68) = par%wneu4
    mass(69) = par%mch1   
    width(69) = par%wch1
    mass(70) = par%mch2   
    width(70) = par%wch2
    sigch1   = par%sigc1 
    sigch2   = par%sigc2
    sign1    = par%sig1
    sign2    = par%sig2
    sign3    = par%sig3
    sign4    = par%sig4
    vckm_11  = par%Vud
    vckm_12  = par%Vus
    vckm_13  = par%Vub
    vckm_21  = par%Vcd
    vckm_22  = par%Vcs
    vckm_23  = par%Vcb
    vckm_31  = par%Vtd
    vckm_32  = par%Vts
    vckm_33  = par%Vtb
    v = 2 * par%mW * par%sw / par%ee
    e = par%ee
    as = par%gg**2 / 4 / pi
    tanb = par%tanb_h
    tana = - tan(par%al_h)
    select case (sign1)
       case (1)
          eta1 = (1.0_omega_prec,0.0_omega_prec)
       case (-1)
          eta1 = (0.0_omega_prec,1.0_omega_prec)
       case default 
          print *, 'sign1', sign1
          stop "parameters_MSSM: No definite sign neutralino1"
    end select
    select case (sign2)
       case (1)
          eta2 = (1.0_omega_prec,0.0_omega_prec)
       case (-1)
          eta2 = (0.0_omega_prec,1.0_omega_prec)
       case default 
          print *, 'sign2', sign2
          stop "parameters_MSSM: No definite sign neutralino2"
    end select
    select case (sign3)
       case (1)
          eta3 = (1.0_omega_prec,0.0_omega_prec)
       case (-1)
          eta3 = (0.0_omega_prec,1.0_omega_prec)
       case default 
          print *, 'sign3', sign3
          stop "parameters_MSSM: No definite sign neutralino3"
    end select
    select case (sign4)
       case (1)
          eta4 = (1.0_omega_prec,0.0_omega_prec)
       case (-1)
          eta4 = (0.0_omega_prec,1.0_omega_prec)
       case default 
          print *, 'sign4', sign4
          stop "parameters_MSSM: No definite sign neutralino4"
    end select
    sinthw = par%sw
    sin2thw = sinthw**2
    costhw = par%cw
    qelep = - 1.0_omega_prec
    qeup = 2.0_omega_prec / 3.0_omega_prec
    qedwn = - 1.0_omega_prec / 3.0_omega_prec
!  real(kind=omega_prec), public, save :: gs = 0_omega_prec, &
!    sind = 0_omega_prec, cosd = 1_omega_prec, sinckm12 = 0.223_omega_prec, &
!    sinckm13 = 0.004_omega_prec, sinckm23 = 0.04_omega_prec, &
!    tana = 30_omega_prec, tanb = 30_omega_prec 
!  complex(kind=omega_prec), public, save :: eidelta, cosckm23, cosckm13, &
!    cosckm12, vckm_33, vckm_32, vckm_31, vckm_23, vckm_22, vckm_21, vckm_13, &
!    vckm_12, vckm_11, gpzww, gppww, gzzww, gw4, igwww, igzww, iqw, igs
    call setup_parameters1
    call setup_parameters2
    call setup_parameters3
    call setup_parameters4
    call setup_parameters5
    call setup_parameters6
    call setup_parameters7
    call setup_parameters8
    call setup_parameters9
    call setup_parameters10
    call setup_parameters11
    call setup_parameters12
    call setup_parameters13
contains
    ! derived parameters:
     !length: 4964
     !Num_Sub: 42
 subroutine setup_parameters1 ()
    ! e = sqrt ((4.0_omega_prec * PI * alpha)) *** This is predefined! ***
    g = (e / sinthw)
    gz = (g / costhw)
    gs = sqrt ((4.0_omega_prec * PI * as)) 
    gss = (gs**2)
    imago = cmplx (0.0_omega_prec, 1.0_omega_prec, kind=omega_prec)
    ! vev = ((2.0_omega_prec * mass(24)) / g)   *** This is predefined! *** 
    q_lep  = (- 1.0_omega_prec) 
    q_up   = (2.0_omega_prec / 3.0_omega_prec)
    q_down = (- 1.0_omega_prec / 3.0_omega_prec)    
    qlep = - e * qelep   !!! This is the negative particle charge !!! 
    qup = - e * qeup     !!! This is the negative particle charge !!! 
    qdwn = - e * qedwn   !!! This is the negative particle charge !!! 
    qchar = ( - e)       !!! This is the negative particle charge !!! 
    ! qlep = ((-1.0_omega_prec) * e)
    ! qup = ((2.0_omega_prec / 3.0_omega_prec) * e)
    ! qdwn = (((-1.0_omega_prec) / 3.0_omega_prec) * e)
    gcc = (g / (2.0_omega_prec * sqrt (2.0_omega_prec)))
    igs = (imago * gs)
    gssq = (gs / sqrt (2.0_omega_prec))
    iqw = imago * e
    igzww = imago * g * costhw
    gw4 = (g**2)
    gzzww = ((g**2) * (costhw**2))
    gppww = (e**2)
    gpzww = (e * g * costhw) 
    ! vckm_11 = (cosckm12 * cosckm13)
    ! vckm_12 = (sinckm12 * cosckm13)
    ! vckm_13 = (sinckm13 * conjg (eidelta))
    ! vckm_21 = ( - ((sinckm12 * cosckm23) +  &
    !   (cosckm12 * sinckm23 * sinckm13 * eidelta)))
    ! vckm_22 = ((cosckm12 * cosckm23) -  &
    !   (sinckm12 * sinckm23 * sinckm13 * eidelta))
    ! vckm_23 = (sinckm23 * cosckm13)
    ! vckm_31 = ((sinckm12 * sinckm23) -  &
    !   (cosckm12 * cosckm23 * sinckm13 * eidelta))
    ! vckm_32 = ( - ((cosckm12 * sinckm23) +  &
    !   (sinckm12 * cosckm23 * sinckm13 * eidelta)))
    ! vckm_33 = (cosckm23 * cosckm13)
    sinal = -sin (par%al_h)
    cosal = cos (par%al_h)
    sinbe = (tanb / sqrt ((1.0_omega_prec + (tanb**2))))
    cosbe = (1.0_omega_prec / sqrt ((1.0_omega_prec + (tanb**2))))
    !!! cosckm12 = sqrt ((1.0_omega_prec - (sinckm12**2)))
    !!! cosckm13 = sqrt ((1.0_omega_prec - (sinckm13**2)))
    !!! cosckm23 = sqrt ((1.0_omega_prec - (sinckm23**2)))
    eidelta = (cosd + (imago * sind))
    cos2be = ((cosbe**2) - (sinbe**2))
    cos2al = ((cosal**2) - (sinal**2))
    sin2be = (2.0_omega_prec * cosbe * sinbe)
    sin2al = (2.0_omega_prec * cosal * sinal)
    sin4al = (2.0_omega_prec * cos2al * sin2al)
    sin4be = (2.0_omega_prec * cos2be * sin2be)
    cos4be = ((cos2be**2) - (sin2be**2))
    cosapb = ((cosal * cosbe) - (sinal * sinbe))
    cosamb = ((cosal * cosbe) + (sinal * sinbe))
    sinapb = ((cosal * sinbe) + (sinal * cosbe))
    sinamb = ((cosal * sinbe) - (sinal * cosbe))
    sin2am2b = (2.0_omega_prec * sinamb * cosamb)
    cos2am2b = ((cosamb**2) - (sinamb**2))
    !!! costhsl1 = 1.0_omega_prec   !!! These are obsolete
    !!! costhsl2 = 1.0_omega_prec   !!! These are obsolete
    !!! costhsl3 = 1.0_omega_prec   !!! These are obsolete
    !!! costhsd1 = 1.0_omega_prec   !!! These are obsolete
    !!! costhsd2 = 1.0_omega_prec   !!! These are obsolete
    !!! costhsd3 = 1.0_omega_prec   !!! These are obsolete
    !!! costhsu1 = 1.0_omega_prec   !!! These are obsolete
    !!! costhsu2 = 1.0_omega_prec   !!! These are obsolete
    !!! costhsu3 = 1.0_omega_prec   !!! These are obsolete
    !!! sinthsl1 = 0.0_omega_prec   !!! These are obsolete
    !!! sinthsl2 = 0.0_omega_prec   !!! These are obsolete
    !!! sinthsl3 = 0.0_omega_prec   !!! These are obsolete
    !!! sinthsd1 = 0.0_omega_prec   !!! These are obsolete
    !!! sinthsd2 = 0.0_omega_prec   !!! These are obsolete
    !!! sinthsd3 = 0.0_omega_prec   !!! These are obsolete
    !!! sinthsu1 = 0.0_omega_prec   !!! These are obsolete
    !!! sinthsu2 = 0.0_omega_prec   !!! These are obsolete
    !!! sinthsu3 = 0.0_omega_prec   !!! These are obsolete
    mn_11 = eta1 * par%mn_11
    mn_12 = eta1 * par%mn_12
    mn_13 = eta1 * par%mn_13
    mn_14 = eta1 * par%mn_14
    mn_21 = eta2 * par%mn_21
    mn_22 = eta2 * par%mn_22
    mn_23 = eta2 * par%mn_23
    mn_24 = eta2 * par%mn_24
    mn_31 = eta3 * par%mn_31
    mn_32 = eta3 * par%mn_32
    mn_33 = eta3 * par%mn_33
    mn_34 = eta3 * par%mn_34
    mn_41 = eta4 * par%mn_41
    mn_42 = eta4 * par%mn_42
    mn_43 = eta4 * par%mn_43
    mn_44 = eta4 * par%mn_44
    mu_11 = par%mu_11                !!! Rotat. matrix containing phi_R
    mu_12 = par%mu_12                !!! Rotat. matrix containing phi_R
    mu_21 = par%mu_21                !!! Rotat. matrix containing phi_R
    mu_22 = par%mu_22                !!! Rotat. matrix containing phi_R
    mv_11 = sigch1 * par%mv_11       !!! Rotat. matrix containing phi_L
    mv_12 = sigch1 * par%mv_12       !!! Rotat. matrix containing phi_L
    mv_21 = sigch2 * par%mv_21       !!! Rotat. matrix containing phi_L
    mv_22 = sigch2 * par%mv_22       !!! Rotat. matrix containing phi_L
    al_1 = 0
    au_1 = 0
    ad_1 = 0
    al_2 = 0
    au_2 = 0
    ad_2 = 0
    al_3 = par%Ae
    au_3 = par%Au
    ad_3 = par%Ad
    mu = par%mu_h
    mix_sl111 = 1.0_omega_prec
    mix_sl112 = 0.0_omega_prec
    mix_sl122 = 1.0_omega_prec
    mix_sl121 = 0.0_omega_prec
    mix_sl211 = 1.0_omega_prec
    mix_sl212 = 0.0_omega_prec
    mix_sl222 = 1.0_omega_prec
    mix_sl221 = 0.0_omega_prec
    mix_su111 = 1.0_omega_prec
    mix_su112 = 0.0_omega_prec
    mix_su122 = 1.0_omega_prec
    mix_su121 = 0.0_omega_prec
    mix_su211 = 1.0_omega_prec
    mix_su212 = 0.0_omega_prec
    mix_su222 = 1.0_omega_prec
    mix_su221 = 0.0_omega_prec
    mix_sd111 = 1.0_omega_prec
    mix_sd112 = 0.0_omega_prec
    mix_sd122 = 1.0_omega_prec
    mix_sd121 = 0.0_omega_prec
    mix_sd211 = 1.0_omega_prec
    mix_sd212 = 0.0_omega_prec
    mix_sd222 = 1.0_omega_prec
    mix_sd221 = 0.0_omega_prec
    mix_sl311 = cos(par%th_tau)
    mix_sl312 = sin(par%th_tau)
    mix_sl322 = cos(par%th_tau)
    mix_sl321 = - sin(par%th_tau)
    mix_su311 = cos(par%th_top)
    mix_su312 = sin(par%th_top)
    mix_su322 = cos(par%th_top)
    mix_su321 = - sin(par%th_top)
    mix_sd311 = cos(par%th_bot)
    mix_sd312 = sin(par%th_bot)
    mix_sd322 = cos(par%th_bot)
    mix_sd321 = - sin(par%th_bot)
    !!! mix_sl111 = costhsl1        !!! These are obsolete !
    !!! mix_sl112 = sinthsl1        !!! These are obsolete !
    !!! mix_sl121 = ( - sinthsl1)   !!! These are obsolete !
    !!! mix_sl122 = costhsl1        !!! These are obsolete !
    !!! mix_sl211 = costhsl2        !!! These are obsolete !
    !!! mix_sl212 = sinthsl2        !!! These are obsolete !
    !!! mix_sl221 = ( - sinthsl2)   !!! These are obsolete !
    !!! mix_sl222 = costhsl2        !!! These are obsolete !
    !!! mix_sl311 = costhsl3        !!! These are obsolete !
    !!! mix_sl312 = sinthsl3        !!! These are obsolete !
    !!! mix_sl321 = ( - sinthsl3)   !!! These are obsolete !
    !!! mix_sl322 = costhsl3        !!! These are obsolete !
    !!! mix_su111 = costhsu1        !!! These are obsolete !
    !!! mix_su112 = sinthsu1        !!! These are obsolete !
    !!! mix_su121 = ( - sinthsu1)   !!! These are obsolete !
    !!! mix_su122 = costhsu1        !!! These are obsolete !
    !!! mix_su211 = costhsu2        !!! These are obsolete !
    !!! mix_su212 = sinthsu2        !!! These are obsolete !
    !!! mix_su221 = ( - sinthsu2)   !!! These are obsolete !
    !!! mix_su222 = costhsu2        !!! These are obsolete !
    !!! mix_su311 = costhsu3        !!! These are obsolete !
    !!! mix_su312 = sinthsu3        !!! These are obsolete !
    !!! mix_su321 = ( - sinthsu3)   !!! These are obsolete !
    !!! mix_su322 = costhsu3        !!! These are obsolete !
    !!! mix_sd111 = costhsd1        !!! These are obsolete !
    !!! mix_sd112 = sinthsd1        !!! These are obsolete !
    !!! mix_sd121 = ( - sinthsd1)   !!! These are obsolete !
    !!! mix_sd122 = costhsd1        !!! These are obsolete !
    !!! mix_sd211 = costhsd2        !!! These are obsolete !
    !!! mix_sd212 = sinthsd2        !!! These are obsolete !
    !!! mix_sd221 = ( - sinthsd2)   !!! These are obsolete !
    !!! mix_sd222 = costhsd2        !!! These are obsolete !
    !!! mix_sd311 = costhsd3        !!! These are obsolete !
    !!! mix_sd312 = sinthsd3        !!! These are obsolete !
    !!! mix_sd321 = ( - sinthsd3)   !!! These are obsolete !
    !!! mix_sd322 = costhsd3        !!! These are obsolete !
    gh3_1 = ((mass(23) * (gz / 2.0_omega_prec) * cos2be * cosapb) -  &
      (mass(24) * g * cosamb))
    gh3_2 = ((mass(24) * g * sinamb) - ( &
      (gz / 2.0_omega_prec) * mass(23) * cos2be * sinapb))
    gh3_3 = ((gz / 2.0_omega_prec) * mass(23) * ( &
      (2.0_omega_prec * sin2al * cosapb) + (cos2al * sinapb)))
    gh3_4 = ( - ( &
      (3.0_omega_prec / 2.0_omega_prec) * gz * mass(23) * cos2al * cosapb))
    gh3_5 = ( - ( &
      (3.0_omega_prec / 2.0_omega_prec) * gz * mass(23) * cos2al * sinapb))
    gh3_6 = ((gz / 2.0_omega_prec) * mass(23) * ((cos2al * cosapb) -  &
      (2.0_omega_prec * sin2al * sinapb)))
    gh3_7 = ((gz / 2.0_omega_prec) * mass(23) * cos2be * cosapb)
    gh3_8 = ( - ((gz / 2.0_omega_prec) * mass(23) * cos2be * sinapb))
    gh4_1 = ( - (((gz**2) / 2.0_omega_prec) * (cos2be**2)))
 end subroutine setup_parameters1
 subroutine setup_parameters2 ()
    gh4_2 = ((((gz**2) / 4.0_omega_prec) * cos2al * cos2be) - (( &
      (g**2) / 2.0_omega_prec) * (cosamb**2)))
    gh4_3 = ( - ((((gz**2) / 4.0_omega_prec) * cos2al * cos2be) + (( &
      (g**2) / 2.0_omega_prec) * (sinamb**2))))
    gh4_4 = ((((g**2) / 2.0_omega_prec) * cosamb * sinamb) - (( &
      (gz**2) / 4.0_omega_prec) * sin2al * cos2be))
    gh4_5 = ( - (((gz**2) / 4.0_omega_prec) * (cos2be**2)))
    gh4_6 = ( - ((3.0_omega_prec / 4.0_omega_prec) * (gz**2) * (cos2al**2)))
    gh4_7 = (((gz**2) / 4.0_omega_prec) * (1.0_omega_prec - (3.0_omega_prec *  &
      (sin2al**2))))
    gh4_8 = ( - ((3.0_omega_prec / 8.0_omega_prec) * (gz**2) * sin4al))
    gh4_9 = (((gz**2) / 4.0_omega_prec) * cos2al * cos2be)
    gh4_10 = ( - (((gz**2) / 4.0_omega_prec) * sin2al * cos2be))
    gh4_11 = ( - ((3.0_omega_prec / 4.0_omega_prec) * (gz**2) * (cos2be**2)))
    ghaw = ( - (imago * (g / 2.0_omega_prec)))
    gh1az = (imago *  &
      (gz / 2.0_omega_prec) * cosamb)
    gh2az = (imago *  &
      (gz / 2.0_omega_prec) * sinamb)
    gh1ww = ( - (g * mass(24) * sinamb))
    gh2ww = (g * mass(24) * cosamb)
    ghh1w = ((g / 2.0_omega_prec) * cosamb)
    ghh2w = ((g / 2.0_omega_prec) * sinamb)
    gh1zz = ( - (gz * mass(23) * sinamb))
    gh2zz = (gz * mass(23) * cosamb)
    ghhz = ((gz / 2.0_omega_prec) * (1.0_omega_prec -  &
      (2.0_omega_prec * sin2thw)))
    ghhp = e
    gaazz = ((gz**2) / 2.0_omega_prec)
    gh1h1zz = gaazz
    gh2h2zz = gaazz
    ghphmzz = (gaazz * (((2.0_omega_prec * (costhw**2)) - 1.0_omega_prec)**2))
    ghphmpp = (2.0_omega_prec * (e**2))
    ghphmpz = (e * gz * ((2.0_omega_prec * (costhw**2)) - 1.0_omega_prec))
    ghh1wz = ( - ( &
      (1.0_omega_prec / 2.0_omega_prec) * g * gz * sin2thw * cosamb))
    ghh2wz = ( - ( &
      (1.0_omega_prec / 2.0_omega_prec) * g * gz * sin2thw * sinamb))
    ghh1wp = (e * (g / 2.0_omega_prec) * cosamb)
    ghh2wp = (e * (g / 2.0_omega_prec) * sinamb)
    gaaww = ((g**2) / 2.0_omega_prec)
    gh1h1ww = gaaww
    gh2h2ww = gaaww
    ghhww = gaaww
    ghawz = (imago * g * gz *  &
      (1.0_omega_prec / 2.0_omega_prec) * sin2thw)
    ghawp = ( - (imago * e * g *  &
      (1.0_omega_prec / 2.0_omega_prec)))
    g_yuk6_1 = (gcc * (mass(11) / mass(24)) * tanb)
    g_yuk7_1 = ( - ((g / 2.0_omega_prec) * (mass(11) / mass(24)) *  &
      (cosal / cosbe)))
    g_yuk8_1 = ((g / 2.0_omega_prec) * (mass(11) / mass(24)) * (sinal / cosbe))
    g_yuk9_1 = (imago *  &
      (g / 2.0_omega_prec) * (mass(11) / mass(24)) * tanb)
    g_yuk10_1 = ( - ((g / 2.0_omega_prec) * (mass(2) / mass(24)) *  &
      (sinal / sinbe)))
    g_yuk11_1 = ( - ((g / 2.0_omega_prec) * (mass(2) / mass(24)) *  &
      (cosal / sinbe)))
    g_yuk12_1 = (imago *  &
      (g / 2.0_omega_prec) * (mass(2) / mass(24)) * (1.0_omega_prec / tanb))
    g_yuk13_1 = ( - ((g / 2.0_omega_prec) * (mass(1) / mass(24)) *  &
      (cosal / cosbe)))
    g_yuk14_1 = ((g / 2.0_omega_prec) * (mass(1) / mass(24)) * (sinal / cosbe))
    g_yuk15_1 = (imago *  &
      (g / 2.0_omega_prec) * (mass(1) / mass(24)) * tanb)
    g_yuk6_2 = (gcc * (mass(13) / mass(24)) * tanb)
    g_yuk7_2 = ( - ((g / 2.0_omega_prec) * (mass(13) / mass(24)) *  &
      (cosal / cosbe)))
    g_yuk8_2 = ((g / 2.0_omega_prec) * (mass(13) / mass(24)) * (sinal / cosbe))
    g_yuk9_2 = (imago *  &
      (g / 2.0_omega_prec) * (mass(13) / mass(24)) * tanb)
    g_yuk10_2 = ( - ((g / 2.0_omega_prec) * (mass(4) / mass(24)) *  &
      (sinal / sinbe)))
    g_yuk11_2 = ( - ((g / 2.0_omega_prec) * (mass(4) / mass(24)) *  &
      (cosal / sinbe)))
    g_yuk12_2 = (imago *  &
      (g / 2.0_omega_prec) * (mass(4) / mass(24)) * (1.0_omega_prec / tanb))
    g_yuk13_2 = ( - ((g / 2.0_omega_prec) * (mass(3) / mass(24)) *  &
      (cosal / cosbe)))
    g_yuk14_2 = ((g / 2.0_omega_prec) * (mass(3) / mass(24)) * (sinal / cosbe))
    g_yuk15_2 = (imago *  &
      (g / 2.0_omega_prec) * (mass(3) / mass(24)) * tanb)
    g_yuk6_3 = (gcc * (mass(15) / mass(24)) * tanb)
    g_yuk7_3 = ( - ((g / 2.0_omega_prec) * (mass(15) / mass(24)) *  &
      (cosal / cosbe)))
    g_yuk8_3 = ((g / 2.0_omega_prec) * (mass(15) / mass(24)) * (sinal / cosbe))
    g_yuk9_3 = (imago *  &
      (g / 2.0_omega_prec) * (mass(15) / mass(24)) * tanb)
    g_yuk10_3 = ( - ((g / 2.0_omega_prec) * (mass(6) / mass(24)) *  &
      (sinal / sinbe)))
    g_yuk11_3 = ( - ((g / 2.0_omega_prec) * (mass(6) / mass(24)) *  &
      (cosal / sinbe)))
    g_yuk12_3 = (imago *  &
      (g / 2.0_omega_prec) * (mass(6) / mass(24)) * (1.0_omega_prec / tanb))
    g_yuk13_3 = ( - ((g / 2.0_omega_prec) * (mass(5) / mass(24)) *  &
      (cosal / cosbe)))
    g_yuk14_3 = ((g / 2.0_omega_prec) * (mass(5) / mass(24)) * (sinal / cosbe))
    g_yuk15_3 = (imago *  &
      (g / 2.0_omega_prec) * (mass(5) / mass(24)) * tanb)
    gccq_1_1 = (gcc * vckm_11)
    gccq_1_1_c = (gcc * conjg (vckm_11))
    gccq_1_2 = (gcc * vckm_12)
    gccq_1_2_c = (gcc * conjg (vckm_12))
    gccq_1_3 = (gcc * vckm_13)
    gccq_1_3_c = (gcc * conjg (vckm_13))
    gccq_2_1 = (gcc * vckm_21)
    gccq_2_1_c = (gcc * conjg (vckm_21))
    gccq_2_2 = (gcc * vckm_22)
    gccq_2_2_c = (gcc * conjg (vckm_22))
    gccq_2_3 = (gcc * vckm_23)
    gccq_2_3_c = (gcc * conjg (vckm_23))
    gccq_3_1 = (gcc * vckm_31)
    gccq_3_1_c = (gcc * conjg (vckm_31))
    gccq_3_2 = (gcc * vckm_32)
    gccq_3_2_c = (gcc * conjg (vckm_32))
    gccq_3_3 = (gcc * vckm_33)
    gccq_3_3_c = (gcc * conjg (vckm_33))
    gs1ws1_1_1 = ( - (gcc * 2.0_omega_prec * vckm_11 *  &
      conjg (mix_su111) * mix_sd111))
    gs2ws2_1_1 = ( - (gcc * 2.0_omega_prec * vckm_11 *  &
      conjg (mix_su121) * mix_sd121))
    gs1ws2_1_1 = ( - (gcc * 2.0_omega_prec * vckm_11 *  &
      conjg (mix_su111) * mix_sd121))
    gs2ws1_1_1 = ( - (gcc * 2.0_omega_prec * vckm_11 *  &
      conjg (mix_su121) * mix_sd111))
    gs1ws1_1_1_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_11) * mix_su111 *  &
      conjg (mix_sd111)))
    gs2ws2_1_1_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_11) * mix_su121 *  &
      conjg (mix_sd121)))
    gs1ws2_1_1_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_11) * mix_su111 *  &
      conjg (mix_sd121)))
    gs2ws1_1_1_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_11) * mix_su121 *  &
      conjg (mix_sd111)))
    gs1ws1_1_2 = ( - (gcc * 2.0_omega_prec * vckm_12 *  &
      conjg (mix_su111) * mix_sd211))
    gs2ws2_1_2 = ( - (gcc * 2.0_omega_prec * vckm_12 *  &
      conjg (mix_su121) * mix_sd221))
    gs1ws2_1_2 = ( - (gcc * 2.0_omega_prec * vckm_12 *  &
      conjg (mix_su111) * mix_sd221))
    gs2ws1_1_2 = ( - (gcc * 2.0_omega_prec * vckm_12 *  &
      conjg (mix_su121) * mix_sd211))
    gs1ws1_1_2_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_12) * mix_su111 *  &
      conjg (mix_sd211)))
    gs2ws2_1_2_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_12) * mix_su121 *  &
      conjg (mix_sd221)))
    gs1ws2_1_2_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_12) * mix_su111 *  &
      conjg (mix_sd221)))
    gs2ws1_1_2_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_12) * mix_su121 *  &
      conjg (mix_sd211)))
    gs1ws1_1_3 = ( - (gcc * 2.0_omega_prec * vckm_13 *  &
      conjg (mix_su111) * mix_sd311))
    gs2ws2_1_3 = ( - (gcc * 2.0_omega_prec * vckm_13 *  &
      conjg (mix_su121) * mix_sd321))
    gs1ws2_1_3 = ( - (gcc * 2.0_omega_prec * vckm_13 *  &
      conjg (mix_su111) * mix_sd321))
    gs2ws1_1_3 = ( - (gcc * 2.0_omega_prec * vckm_13 *  &
      conjg (mix_su121) * mix_sd311))
    gs1ws1_1_3_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_13) * mix_su111 *  &
      conjg (mix_sd311)))
    gs2ws2_1_3_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_13) * mix_su121 *  &
      conjg (mix_sd321)))
    gs1ws2_1_3_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_13) * mix_su111 *  &
      conjg (mix_sd321)))
    gs2ws1_1_3_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_13) * mix_su121 *  &
      conjg (mix_sd311)))
    gs1ws1_2_1 = ( - (gcc * 2.0_omega_prec * vckm_21 *  &
      conjg (mix_su211) * mix_sd111))
    gs2ws2_2_1 = ( - (gcc * 2.0_omega_prec * vckm_21 *  &
      conjg (mix_su221) * mix_sd121))
    gs1ws2_2_1 = ( - (gcc * 2.0_omega_prec * vckm_21 *  &
      conjg (mix_su211) * mix_sd121))
    gs2ws1_2_1 = ( - (gcc * 2.0_omega_prec * vckm_21 *  &
      conjg (mix_su221) * mix_sd111))
    gs1ws1_2_1_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_21) * mix_su211 *  &
      conjg (mix_sd111)))
    gs2ws2_2_1_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_21) * mix_su221 *  &
      conjg (mix_sd121)))
    gs1ws2_2_1_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_21) * mix_su211 *  &
      conjg (mix_sd121)))
    gs2ws1_2_1_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_21) * mix_su221 *  &
      conjg (mix_sd111)))
    gs1ws1_2_2 = ( - (gcc * 2.0_omega_prec * vckm_22 *  &
      conjg (mix_su211) * mix_sd211))
    gs2ws2_2_2 = ( - (gcc * 2.0_omega_prec * vckm_22 *  &
      conjg (mix_su221) * mix_sd221))
    gs1ws2_2_2 = ( - (gcc * 2.0_omega_prec * vckm_22 *  &
      conjg (mix_su211) * mix_sd221))
    gs2ws1_2_2 = ( - (gcc * 2.0_omega_prec * vckm_22 *  &
      conjg (mix_su221) * mix_sd211))
    gs1ws1_2_2_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_22) * mix_su211 *  &
      conjg (mix_sd211)))
    gs2ws2_2_2_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_22) * mix_su221 *  &
      conjg (mix_sd221)))
    gs1ws2_2_2_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_22) * mix_su211 *  &
      conjg (mix_sd221)))
    gs2ws1_2_2_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_22) * mix_su221 *  &
      conjg (mix_sd211)))
    gs1ws1_2_3 = ( - (gcc * 2.0_omega_prec * vckm_23 *  &
      conjg (mix_su211) * mix_sd311))
    gs2ws2_2_3 = ( - (gcc * 2.0_omega_prec * vckm_23 *  &
      conjg (mix_su221) * mix_sd321))
    gs1ws2_2_3 = ( - (gcc * 2.0_omega_prec * vckm_23 *  &
      conjg (mix_su211) * mix_sd321))
    gs2ws1_2_3 = ( - (gcc * 2.0_omega_prec * vckm_23 *  &
      conjg (mix_su221) * mix_sd311))
    gs1ws1_2_3_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_23) * mix_su211 *  &
      conjg (mix_sd311)))
    gs2ws2_2_3_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_23) * mix_su221 *  &
      conjg (mix_sd321)))
    gs1ws2_2_3_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_23) * mix_su211 *  &
      conjg (mix_sd321)))
    gs2ws1_2_3_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_23) * mix_su221 *  &
      conjg (mix_sd311)))
    gs1ws1_3_1 = ( - (gcc * 2.0_omega_prec * vckm_31 *  &
      conjg (mix_su311) * mix_sd111))
    gs2ws2_3_1 = ( - (gcc * 2.0_omega_prec * vckm_31 *  &
      conjg (mix_su321) * mix_sd121))
 end subroutine setup_parameters2
 subroutine setup_parameters3 ()
    gs1ws2_3_1 = ( - (gcc * 2.0_omega_prec * vckm_31 *  &
      conjg (mix_su311) * mix_sd121))
    gs2ws1_3_1 = ( - (gcc * 2.0_omega_prec * vckm_31 *  &
      conjg (mix_su321) * mix_sd111))
    gs1ws1_3_1_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_31) * mix_su311 *  &
      conjg (mix_sd111)))
    gs2ws2_3_1_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_31) * mix_su321 *  &
      conjg (mix_sd121)))
    gs1ws2_3_1_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_31) * mix_su311 *  &
      conjg (mix_sd121)))
    gs2ws1_3_1_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_31) * mix_su321 *  &
      conjg (mix_sd111)))
    gs1ws1_3_2 = ( - (gcc * 2.0_omega_prec * vckm_32 *  &
      conjg (mix_su311) * mix_sd211))
    gs2ws2_3_2 = ( - (gcc * 2.0_omega_prec * vckm_32 *  &
      conjg (mix_su321) * mix_sd221))
    gs1ws2_3_2 = ( - (gcc * 2.0_omega_prec * vckm_32 *  &
      conjg (mix_su311) * mix_sd221))
    gs2ws1_3_2 = ( - (gcc * 2.0_omega_prec * vckm_32 *  &
      conjg (mix_su321) * mix_sd211))
    gs1ws1_3_2_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_32) * mix_su311 *  &
      conjg (mix_sd211)))
    gs2ws2_3_2_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_32) * mix_su321 *  &
      conjg (mix_sd221)))
    gs1ws2_3_2_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_32) * mix_su311 *  &
      conjg (mix_sd221)))
    gs2ws1_3_2_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_32) * mix_su321 *  &
      conjg (mix_sd211)))
    gs1ws1_3_3 = ( - (gcc * 2.0_omega_prec * vckm_33 *  &
      conjg (mix_su311) * mix_sd311))
    gs2ws2_3_3 = ( - (gcc * 2.0_omega_prec * vckm_33 *  &
      conjg (mix_su321) * mix_sd321))
    gs1ws2_3_3 = ( - (gcc * 2.0_omega_prec * vckm_33 *  &
      conjg (mix_su311) * mix_sd321))
    gs2ws1_3_3 = ( - (gcc * 2.0_omega_prec * vckm_33 *  &
      conjg (mix_su321) * mix_sd311))
    gs1ws1_3_3_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_33) * mix_su311 *  &
      conjg (mix_sd311)))
    gs2ws2_3_3_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_33) * mix_su321 *  &
      conjg (mix_sd321)))
    gs1ws2_3_3_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_33) * mix_su311 *  &
      conjg (mix_sd321)))
    gs2ws1_3_3_c = ( - (gcc * 2.0_omega_prec * conjg (vckm_33) * mix_su321 *  &
      conjg (mix_sd311)))
    gsl1zsl1_1 = ((gz / 2.0_omega_prec) * ((2.0_omega_prec * sin2thw) -  &
      (mix_sl111 * conjg (mix_sl111))))
    gsl2zsl2_1 = ((gz / 2.0_omega_prec) * ((2.0_omega_prec * sin2thw) -  &
      (mix_sl121 * conjg (mix_sl121))))
    gsl1zsl2_1 = ((( - gz) / 2.0_omega_prec) * conjg (mix_sl111) * mix_sl121)
    gsl2zsl1_1 = conjg (gsl1zsl2_1)
    gsn1zsn1_1 = (gz / 2.0_omega_prec)
    gsu1zsu1_1 = ((gz / 2.0_omega_prec) * ((mix_su111 * conjg (mix_su111)) - ( &
      (4.0_omega_prec / 3.0_omega_prec) * sin2thw)))
    gsu2zsu2_1 = ((gz / 2.0_omega_prec) * ((mix_su121 * conjg (mix_su121)) - ( &
      (4.0_omega_prec / 3.0_omega_prec) * sin2thw)))
    gsu1zsu2_1 = ((gz / 2.0_omega_prec) * conjg (mix_su111) * mix_su121)
    gsu2zsu1_1 = conjg (gsu1zsu2_1)
    gsd1zsd1_1 = ((gz / 2.0_omega_prec) * (( &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw) - (mix_sd111 *  &
      conjg (mix_sd111))))
    gsd2zsd2_1 = ((gz / 2.0_omega_prec) * (( &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw) - (mix_sd121 *  &
      conjg (mix_sd121))))
    gsd1zsd2_1 = ((( - gz) / 2.0_omega_prec) * conjg (mix_sd111) * mix_sd121)
    gsd2zsd1_1 = conjg (gsd1zsd2_1)
    gsl1_1snw = (gcc * 2.0_omega_prec * mix_sl111)
    gsl2_1snw = (gcc * 2.0_omega_prec * mix_sl121)
    gsl1_1snw_c = (gcc * 2.0_omega_prec * conjg (mix_sl111))
    gsl2_1snw_c = (gcc * 2.0_omega_prec * conjg (mix_sl121))
    gsl1zsl1_2 = ((gz / 2.0_omega_prec) * ((2.0_omega_prec * sin2thw) -  &
      (mix_sl211 * conjg (mix_sl211))))
    gsl2zsl2_2 = ((gz / 2.0_omega_prec) * ((2.0_omega_prec * sin2thw) -  &
      (mix_sl221 * conjg (mix_sl221))))
    gsl1zsl2_2 = ((( - gz) / 2.0_omega_prec) * conjg (mix_sl211) * mix_sl221)
    gsl2zsl1_2 = conjg (gsl1zsl2_2)
    gsn1zsn1_2 = (gz / 2.0_omega_prec)
    gsu1zsu1_2 = ((gz / 2.0_omega_prec) * ((mix_su211 * conjg (mix_su211)) - ( &
      (4.0_omega_prec / 3.0_omega_prec) * sin2thw)))
    gsu2zsu2_2 = ((gz / 2.0_omega_prec) * ((mix_su221 * conjg (mix_su221)) - ( &
      (4.0_omega_prec / 3.0_omega_prec) * sin2thw)))
    gsu1zsu2_2 = ((gz / 2.0_omega_prec) * conjg (mix_su211) * mix_su221)
    gsu2zsu1_2 = conjg (gsu1zsu2_2)
    gsd1zsd1_2 = ((gz / 2.0_omega_prec) * (( &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw) - (mix_sd211 *  &
      conjg (mix_sd211))))
    gsd2zsd2_2 = ((gz / 2.0_omega_prec) * (( &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw) - (mix_sd221 *  &
      conjg (mix_sd221))))
    gsd1zsd2_2 = ((( - gz) / 2.0_omega_prec) * conjg (mix_sd211) * mix_sd221)
    gsd2zsd1_2 = conjg (gsd1zsd2_2)
    gsl1_2snw = (gcc * 2.0_omega_prec * mix_sl211)
    gsl2_2snw = (gcc * 2.0_omega_prec * mix_sl221)
    gsl1_2snw_c = (gcc * 2.0_omega_prec * conjg (mix_sl211))
    gsl2_2snw_c = (gcc * 2.0_omega_prec * conjg (mix_sl221))
    gsl1zsl1_3 = ((gz / 2.0_omega_prec) * ((2.0_omega_prec * sin2thw) -  &
      (mix_sl311 * conjg (mix_sl311))))
    gsl2zsl2_3 = ((gz / 2.0_omega_prec) * ((2.0_omega_prec * sin2thw) -  &
      (mix_sl321 * conjg (mix_sl321))))
    gsl1zsl2_3 = ((( - gz) / 2.0_omega_prec) * conjg (mix_sl311) * mix_sl321)
    gsl2zsl1_3 = conjg (gsl1zsl2_3)
    gsn1zsn1_3 = (gz / 2.0_omega_prec)
    gsu1zsu1_3 = ((gz / 2.0_omega_prec) * ((mix_su311 * conjg (mix_su311)) - ( &
      (4.0_omega_prec / 3.0_omega_prec) * sin2thw)))
    gsu2zsu2_3 = ((gz / 2.0_omega_prec) * ((mix_su321 * conjg (mix_su321)) - ( &
      (4.0_omega_prec / 3.0_omega_prec) * sin2thw)))
    gsu1zsu2_3 = ((gz / 2.0_omega_prec) * conjg (mix_su311) * mix_su321)
    gsu2zsu1_3 = conjg (gsu1zsu2_3)
    gsd1zsd1_3 = ((gz / 2.0_omega_prec) * (( &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw) - (mix_sd311 *  &
      conjg (mix_sd311))))
    gsd2zsd2_3 = ((gz / 2.0_omega_prec) * (( &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw) - (mix_sd321 *  &
      conjg (mix_sd321))))
    gsd1zsd2_3 = ((( - gz) / 2.0_omega_prec) * conjg (mix_sd311) * mix_sd321)
    gsd2zsd1_3 = conjg (gsd1zsd2_3)
    gsl1_3snw = (gcc * 2.0_omega_prec * mix_sl311)
    gsl2_3snw = (gcc * 2.0_omega_prec * mix_sl321)
    gsl1_3snw_c = (gcc * 2.0_omega_prec * conjg (mix_sl311))
    gsl2_3snw_c = (gcc * 2.0_omega_prec * conjg (mix_sl321))
    gppslsl = (2.0_omega_prec * (e**2))
    gppsusu = ((8.0_omega_prec / 9.0_omega_prec) * (e**2))
    gppsdsd = ((2.0_omega_prec / 9.0_omega_prec) * (e**2))
    gzzsl1sl1_1 = (((gz**2) / 2.0_omega_prec) * (((1.0_omega_prec -  &
      (4.0_omega_prec * sin2thw)) * (mix_sl111 * conjg (mix_sl111))) +  &
      (4.0_omega_prec * (sin2thw**2))))
    gzzsl2sl2_1 = (((gz**2) / 2.0_omega_prec) * (((1.0_omega_prec -  &
      (4.0_omega_prec * sin2thw)) * (mix_sl121 * conjg (mix_sl121))) +  &
      (4.0_omega_prec * (sin2thw**2))))
    gzzsl1sl2_1 = (((gz**2) / 2.0_omega_prec) * (1.0_omega_prec -  &
      (4.0_omega_prec * sin2thw)) * mix_sl111 * conjg (mix_sl121))
    gzzsl2sl1_1 = (((gz**2) / 2.0_omega_prec) * (1.0_omega_prec -  &
      (4.0_omega_prec * sin2thw)) * mix_sl121 * conjg (mix_sl111))
    gzzsn1sn1_1 = ((gz**2) / 2.0_omega_prec)
    gzzsu1su1_1 = (((gz**2) / 2.0_omega_prec) * (((1.0_omega_prec - ( &
      (8.0_omega_prec / 3.0_omega_prec) * sin2thw)) * (mix_su111 *  &
      conjg (mix_su111))) + ((sin2thw**2) *  &
      (16.0_omega_prec / 9.0_omega_prec))))
    gzzsu2su2_1 = (((gz**2) / 2.0_omega_prec) * (((1.0_omega_prec - ( &
      (8.0_omega_prec / 3.0_omega_prec) * sin2thw)) * (mix_su121 *  &
      conjg (mix_su121))) + ((sin2thw**2) *  &
      (16.0_omega_prec / 9.0_omega_prec))))
    gzzsu1su2_1 = (((gz**2) / 2.0_omega_prec) * (1.0_omega_prec - (sin2thw *  &
      (8.0_omega_prec / 3.0_omega_prec))) * mix_su111 * conjg (mix_su121))
    gzzsu2su1_1 = (((gz**2) / 2.0_omega_prec) * (1.0_omega_prec - (sin2thw *  &
      (8.0_omega_prec / 3.0_omega_prec))) * mix_su121 * conjg (mix_su111))
    gzzsd1sd1_1 = (((gz**2) / 2.0_omega_prec) * (((1.0_omega_prec - (sin2thw *  &
      (4.0_omega_prec / 3.0_omega_prec))) * (mix_sd111 * conjg (mix_sd111))) +  &
      ((sin2thw**2) * (4.0_omega_prec / 9.0_omega_prec))))
    gzzsd2sd2_1 = (((gz**2) / 2.0_omega_prec) * (((1.0_omega_prec - (sin2thw *  &
      (4.0_omega_prec / 3.0_omega_prec))) * (mix_sd121 * conjg (mix_sd121))) +  &
      ((sin2thw**2) * (4.0_omega_prec / 9.0_omega_prec))))
    gzzsd1sd2_1 = (((gz**2) / 2.0_omega_prec) * (1.0_omega_prec - (sin2thw *  &
      (4.0_omega_prec / 3.0_omega_prec))) * mix_sd111 * conjg (mix_sd121))
    gzzsd2sd1_1 = (((gz**2) / 2.0_omega_prec) * (1.0_omega_prec - (sin2thw *  &
      (4.0_omega_prec / 3.0_omega_prec))) * mix_sd121 * conjg (mix_sd112))
    gzpsl1sl1_1 = (e * gz * ((mix_sl111 * conjg (mix_sl111)) -  &
      (2.0_omega_prec * sin2thw)))
    gzpsl2sl2_1 = (e * gz * ((mix_sl121 * conjg (mix_sl121)) -  &
      (2.0_omega_prec * sin2thw)))
    gzpsl1sl2_1 = (e * gz * mix_sl111 * conjg (mix_sl121))
    gzpsl2sl1_1 = (e * gz * mix_sl121 * conjg (mix_sl111))
    gzpsu1su1_1 = (e * gz * (2.0_omega_prec / 3.0_omega_prec) * ((mix_su111 *  &
      conjg (mix_su111)) - (sin2thw * (4.0_omega_prec / 3.0_omega_prec))))
    gzpsu2su2_1 = (e * gz * (2.0_omega_prec / 3.0_omega_prec) * ((mix_su121 *  &
      conjg (mix_su121)) - (sin2thw * (4.0_omega_prec / 3.0_omega_prec))))
    gzpsu1su2_1 = (e * gz * (2.0_omega_prec / 3.0_omega_prec) * mix_su111 *  &
      conjg (mix_su121))
    gzpsu2su1_1 = (e * gz * (2.0_omega_prec / 3.0_omega_prec) * mix_su121 *  &
      conjg (mix_su111))
    gzpsd1sd1_1 = (e * gz * (1.0_omega_prec / 3.0_omega_prec) * ((mix_sd111 *  &
      conjg (mix_sd111)) - (sin2thw * (2.0_omega_prec / 3.0_omega_prec))))
    gzpsd2sd2_1 = (e * gz * (1.0_omega_prec / 3.0_omega_prec) * ((mix_sd121 *  &
      conjg (mix_sd121)) - (sin2thw * (2.0_omega_prec / 3.0_omega_prec))))
    gzpsd1sd2_1 = (e * gz * (1.0_omega_prec / 3.0_omega_prec) * mix_sd111 *  &
      conjg (mix_sd121))
    gzpsd2sd1_1 = (e * gz * (1.0_omega_prec / 3.0_omega_prec) * mix_sd121 *  &
      conjg (mix_sd111))
    gwwsl1sl1_1 = (((g**2) / 2.0_omega_prec) * (mix_sl111 * conjg (mix_sl111)))
    gwwsl2sl2_1 = (((g**2) / 2.0_omega_prec) * (mix_sl121 * conjg (mix_sl121)))
    gwwsl1sl2_1 = (((g**2) / 2.0_omega_prec) * mix_sl111 * conjg (mix_sl121))
    gwwsl2sl1_1 = (((g**2) / 2.0_omega_prec) * mix_sl121 * conjg (mix_sl111))
    gwwsn1sn1_1 = ((g**2) / 2.0_omega_prec)
    gwwsu1su1_1 = (((g**2) / 2.0_omega_prec) * (mix_su111 * conjg (mix_su111)))
    gwwsu2su2_1 = (((g**2) / 2.0_omega_prec) * (mix_su121 * conjg (mix_su121)))
    gwwsu1su2_1 = (((g**2) / 2.0_omega_prec) * mix_su111 * conjg (mix_su121))
    gwwsu2su1_1 = (((g**2) / 2.0_omega_prec) * mix_su121 * conjg (mix_su111))
    gwwsd1sd1_1 = (((g**2) / 2.0_omega_prec) * (mix_sd111 * conjg (mix_sd111)))
    gwwsd2sd2_1 = (((g**2) / 2.0_omega_prec) * (mix_sd121 * conjg (mix_sd121)))
    gwwsd1sd2_1 = (((g**2) / 2.0_omega_prec) * mix_sd111 * conjg (mix_sd121))
    gwwsd2sd1_1 = (((g**2) / 2.0_omega_prec) * mix_sd121 * conjg (mix_sd111))
    gpwsl1sn_1 = ( - (e * 2.0_omega_prec * gcc * mix_sl111))
    gpwsl2sn_1 = ( - (e * 2.0_omega_prec * gcc * mix_sl121))
    gpwsl1sn_1_c = ( - (e * 2.0_omega_prec * gcc * conjg (mix_sl111)))
    gpwsl2sn_1_c = ( - (e * 2.0_omega_prec * gcc * conjg (mix_sl121)))
    gwzsl1sn_1 = (gcc * gz * 2.0_omega_prec * sin2thw * mix_sl111)
 end subroutine setup_parameters3
 subroutine setup_parameters4 ()
    gwzsl2sn_1 = (gcc * gz * 2.0_omega_prec * sin2thw * mix_sl121)
    gwzsl1sn_1_c = (gcc * gz * 2.0_omega_prec * sin2thw * conjg (mix_sl111))
    gwzsl2sn_1_c = (gcc * gz * 2.0_omega_prec * sin2thw * conjg (mix_sl121))
    gzzsl1sl1_2 = (((gz**2) / 2.0_omega_prec) * (((1.0_omega_prec -  &
      (4.0_omega_prec * sin2thw)) * (mix_sl211 * conjg (mix_sl211))) +  &
      (4.0_omega_prec * (sin2thw**2))))
    gzzsl2sl2_2 = (((gz**2) / 2.0_omega_prec) * (((1.0_omega_prec -  &
      (4.0_omega_prec * sin2thw)) * (mix_sl221 * conjg (mix_sl221))) +  &
      (4.0_omega_prec * (sin2thw**2))))
    gzzsl1sl2_2 = (((gz**2) / 2.0_omega_prec) * (1.0_omega_prec -  &
      (4.0_omega_prec * sin2thw)) * mix_sl211 * conjg (mix_sl221))
    gzzsl2sl1_2 = (((gz**2) / 2.0_omega_prec) * (1.0_omega_prec -  &
      (4.0_omega_prec * sin2thw)) * mix_sl221 * conjg (mix_sl211))
    gzzsn1sn1_2 = ((gz**2) / 2.0_omega_prec)
    gzzsu1su1_2 = (((gz**2) / 2.0_omega_prec) * (((1.0_omega_prec - ( &
      (8.0_omega_prec / 3.0_omega_prec) * sin2thw)) * (mix_su211 *  &
      conjg (mix_su211))) + ((sin2thw**2) *  &
      (16.0_omega_prec / 9.0_omega_prec))))
    gzzsu2su2_2 = (((gz**2) / 2.0_omega_prec) * (((1.0_omega_prec - ( &
      (8.0_omega_prec / 3.0_omega_prec) * sin2thw)) * (mix_su221 *  &
      conjg (mix_su221))) + ((sin2thw**2) *  &
      (16.0_omega_prec / 9.0_omega_prec))))
    gzzsu1su2_2 = (((gz**2) / 2.0_omega_prec) * (1.0_omega_prec - (sin2thw *  &
      (8.0_omega_prec / 3.0_omega_prec))) * mix_su211 * conjg (mix_su221))
    gzzsu2su1_2 = (((gz**2) / 2.0_omega_prec) * (1.0_omega_prec - (sin2thw *  &
      (8.0_omega_prec / 3.0_omega_prec))) * mix_su221 * conjg (mix_su211))
    gzzsd1sd1_2 = (((gz**2) / 2.0_omega_prec) * (((1.0_omega_prec - (sin2thw *  &
      (4.0_omega_prec / 3.0_omega_prec))) * (mix_sd211 * conjg (mix_sd211))) +  &
      ((sin2thw**2) * (4.0_omega_prec / 9.0_omega_prec))))
    gzzsd2sd2_2 = (((gz**2) / 2.0_omega_prec) * (((1.0_omega_prec - (sin2thw *  &
      (4.0_omega_prec / 3.0_omega_prec))) * (mix_sd221 * conjg (mix_sd221))) +  &
      ((sin2thw**2) * (4.0_omega_prec / 9.0_omega_prec))))
    gzzsd1sd2_2 = (((gz**2) / 2.0_omega_prec) * (1.0_omega_prec - (sin2thw *  &
      (4.0_omega_prec / 3.0_omega_prec))) * mix_sd211 * conjg (mix_sd221))
    gzzsd2sd1_2 = (((gz**2) / 2.0_omega_prec) * (1.0_omega_prec - (sin2thw *  &
      (4.0_omega_prec / 3.0_omega_prec))) * mix_sd221 * conjg (mix_sd212))
    gzpsl1sl1_2 = (e * gz * ((mix_sl211 * conjg (mix_sl211)) -  &
      (2.0_omega_prec * sin2thw)))
    gzpsl2sl2_2 = (e * gz * ((mix_sl221 * conjg (mix_sl221)) -  &
      (2.0_omega_prec * sin2thw)))
    gzpsl1sl2_2 = (e * gz * mix_sl211 * conjg (mix_sl221))
    gzpsl2sl1_2 = (e * gz * mix_sl221 * conjg (mix_sl211))
    gzpsu1su1_2 = (e * gz * (2.0_omega_prec / 3.0_omega_prec) * ((mix_su211 *  &
      conjg (mix_su211)) - (sin2thw * (4.0_omega_prec / 3.0_omega_prec))))
    gzpsu2su2_2 = (e * gz * (2.0_omega_prec / 3.0_omega_prec) * ((mix_su221 *  &
      conjg (mix_su221)) - (sin2thw * (4.0_omega_prec / 3.0_omega_prec))))
    gzpsu1su2_2 = (e * gz * (2.0_omega_prec / 3.0_omega_prec) * mix_su211 *  &
      conjg (mix_su221))
    gzpsu2su1_2 = (e * gz * (2.0_omega_prec / 3.0_omega_prec) * mix_su221 *  &
      conjg (mix_su211))
    gzpsd1sd1_2 = (e * gz * (1.0_omega_prec / 3.0_omega_prec) * ((mix_sd211 *  &
      conjg (mix_sd211)) - (sin2thw * (2.0_omega_prec / 3.0_omega_prec))))
    gzpsd2sd2_2 = (e * gz * (1.0_omega_prec / 3.0_omega_prec) * ((mix_sd221 *  &
      conjg (mix_sd221)) - (sin2thw * (2.0_omega_prec / 3.0_omega_prec))))
    gzpsd1sd2_2 = (e * gz * (1.0_omega_prec / 3.0_omega_prec) * mix_sd211 *  &
      conjg (mix_sd221))
    gzpsd2sd1_2 = (e * gz * (1.0_omega_prec / 3.0_omega_prec) * mix_sd221 *  &
      conjg (mix_sd211))
    gwwsl1sl1_2 = (((g**2) / 2.0_omega_prec) * (mix_sl211 * conjg (mix_sl211)))
    gwwsl2sl2_2 = (((g**2) / 2.0_omega_prec) * (mix_sl221 * conjg (mix_sl221)))
    gwwsl1sl2_2 = (((g**2) / 2.0_omega_prec) * mix_sl211 * conjg (mix_sl221))
    gwwsl2sl1_2 = (((g**2) / 2.0_omega_prec) * mix_sl221 * conjg (mix_sl211))
    gwwsn1sn1_2 = ((g**2) / 2.0_omega_prec)
    gwwsu1su1_2 = (((g**2) / 2.0_omega_prec) * (mix_su211 * conjg (mix_su211)))
    gwwsu2su2_2 = (((g**2) / 2.0_omega_prec) * (mix_su221 * conjg (mix_su221)))
    gwwsu1su2_2 = (((g**2) / 2.0_omega_prec) * mix_su211 * conjg (mix_su221))
    gwwsu2su1_2 = (((g**2) / 2.0_omega_prec) * mix_su221 * conjg (mix_su211))
    gwwsd1sd1_2 = (((g**2) / 2.0_omega_prec) * (mix_sd211 * conjg (mix_sd211)))
    gwwsd2sd2_2 = (((g**2) / 2.0_omega_prec) * (mix_sd221 * conjg (mix_sd221)))
    gwwsd1sd2_2 = (((g**2) / 2.0_omega_prec) * mix_sd211 * conjg (mix_sd221))
    gwwsd2sd1_2 = (((g**2) / 2.0_omega_prec) * mix_sd221 * conjg (mix_sd211))
    gpwsl1sn_2 = ( - (e * 2.0_omega_prec * gcc * mix_sl211))
    gpwsl2sn_2 = ( - (e * 2.0_omega_prec * gcc * mix_sl221))
    gpwsl1sn_2_c = ( - (e * 2.0_omega_prec * gcc * conjg (mix_sl211)))
    gpwsl2sn_2_c = ( - (e * 2.0_omega_prec * gcc * conjg (mix_sl221)))
    gwzsl1sn_2 = (gcc * gz * 2.0_omega_prec * sin2thw * mix_sl211)
    gwzsl2sn_2 = (gcc * gz * 2.0_omega_prec * sin2thw * mix_sl221)
    gwzsl1sn_2_c = (gcc * gz * 2.0_omega_prec * sin2thw * conjg (mix_sl211))
    gwzsl2sn_2_c = (gcc * gz * 2.0_omega_prec * sin2thw * conjg (mix_sl221))
    gzzsl1sl1_3 = (((gz**2) / 2.0_omega_prec) * (((1.0_omega_prec -  &
      (4.0_omega_prec * sin2thw)) * (mix_sl311 * conjg (mix_sl311))) +  &
      (4.0_omega_prec * (sin2thw**2))))
    gzzsl2sl2_3 = (((gz**2) / 2.0_omega_prec) * (((1.0_omega_prec -  &
      (4.0_omega_prec * sin2thw)) * (mix_sl321 * conjg (mix_sl321))) +  &
      (4.0_omega_prec * (sin2thw**2))))
    gzzsl1sl2_3 = (((gz**2) / 2.0_omega_prec) * (1.0_omega_prec -  &
      (4.0_omega_prec * sin2thw)) * mix_sl311 * conjg (mix_sl321))
    gzzsl2sl1_3 = (((gz**2) / 2.0_omega_prec) * (1.0_omega_prec -  &
      (4.0_omega_prec * sin2thw)) * mix_sl321 * conjg (mix_sl311))
    gzzsn1sn1_3 = ((gz**2) / 2.0_omega_prec)
    gzzsu1su1_3 = (((gz**2) / 2.0_omega_prec) * (((1.0_omega_prec - ( &
      (8.0_omega_prec / 3.0_omega_prec) * sin2thw)) * (mix_su311 *  &
      conjg (mix_su311))) + ((sin2thw**2) *  &
      (16.0_omega_prec / 9.0_omega_prec))))
    gzzsu2su2_3 = (((gz**2) / 2.0_omega_prec) * (((1.0_omega_prec - ( &
      (8.0_omega_prec / 3.0_omega_prec) * sin2thw)) * (mix_su321 *  &
      conjg (mix_su321))) + ((sin2thw**2) *  &
      (16.0_omega_prec / 9.0_omega_prec))))
    gzzsu1su2_3 = (((gz**2) / 2.0_omega_prec) * (1.0_omega_prec - (sin2thw *  &
      (8.0_omega_prec / 3.0_omega_prec))) * mix_su311 * conjg (mix_su321))
    gzzsu2su1_3 = (((gz**2) / 2.0_omega_prec) * (1.0_omega_prec - (sin2thw *  &
      (8.0_omega_prec / 3.0_omega_prec))) * mix_su321 * conjg (mix_su311))
    gzzsd1sd1_3 = (((gz**2) / 2.0_omega_prec) * (((1.0_omega_prec - (sin2thw *  &
      (4.0_omega_prec / 3.0_omega_prec))) * (mix_sd311 * conjg (mix_sd311))) +  &
      ((sin2thw**2) * (4.0_omega_prec / 9.0_omega_prec))))
    gzzsd2sd2_3 = (((gz**2) / 2.0_omega_prec) * (((1.0_omega_prec - (sin2thw *  &
      (4.0_omega_prec / 3.0_omega_prec))) * (mix_sd321 * conjg (mix_sd321))) +  &
      ((sin2thw**2) * (4.0_omega_prec / 9.0_omega_prec))))
    gzzsd1sd2_3 = (((gz**2) / 2.0_omega_prec) * (1.0_omega_prec - (sin2thw *  &
      (4.0_omega_prec / 3.0_omega_prec))) * mix_sd311 * conjg (mix_sd321))
    gzzsd2sd1_3 = (((gz**2) / 2.0_omega_prec) * (1.0_omega_prec - (sin2thw *  &
      (4.0_omega_prec / 3.0_omega_prec))) * mix_sd321 * conjg (mix_sd312))
    gzpsl1sl1_3 = (e * gz * ((mix_sl311 * conjg (mix_sl311)) -  &
      (2.0_omega_prec * sin2thw)))
    gzpsl2sl2_3 = (e * gz * ((mix_sl321 * conjg (mix_sl321)) -  &
      (2.0_omega_prec * sin2thw)))
    gzpsl1sl2_3 = (e * gz * mix_sl311 * conjg (mix_sl321))
    gzpsl2sl1_3 = (e * gz * mix_sl321 * conjg (mix_sl311))
    gzpsu1su1_3 = (e * gz * (2.0_omega_prec / 3.0_omega_prec) * ((mix_su311 *  &
      conjg (mix_su311)) - (sin2thw * (4.0_omega_prec / 3.0_omega_prec))))
    gzpsu2su2_3 = (e * gz * (2.0_omega_prec / 3.0_omega_prec) * ((mix_su321 *  &
      conjg (mix_su321)) - (sin2thw * (4.0_omega_prec / 3.0_omega_prec))))
    gzpsu1su2_3 = (e * gz * (2.0_omega_prec / 3.0_omega_prec) * mix_su311 *  &
      conjg (mix_su321))
    gzpsu2su1_3 = (e * gz * (2.0_omega_prec / 3.0_omega_prec) * mix_su321 *  &
      conjg (mix_su311))
    gzpsd1sd1_3 = (e * gz * (1.0_omega_prec / 3.0_omega_prec) * ((mix_sd311 *  &
      conjg (mix_sd311)) - (sin2thw * (2.0_omega_prec / 3.0_omega_prec))))
    gzpsd2sd2_3 = (e * gz * (1.0_omega_prec / 3.0_omega_prec) * ((mix_sd321 *  &
      conjg (mix_sd321)) - (sin2thw * (2.0_omega_prec / 3.0_omega_prec))))
    gzpsd1sd2_3 = (e * gz * (1.0_omega_prec / 3.0_omega_prec) * mix_sd311 *  &
      conjg (mix_sd321))
    gzpsd2sd1_3 = (e * gz * (1.0_omega_prec / 3.0_omega_prec) * mix_sd321 *  &
      conjg (mix_sd311))
    gwwsl1sl1_3 = (((g**2) / 2.0_omega_prec) * (mix_sl311 * conjg (mix_sl311)))
    gwwsl2sl2_3 = (((g**2) / 2.0_omega_prec) * (mix_sl321 * conjg (mix_sl321)))
    gwwsl1sl2_3 = (((g**2) / 2.0_omega_prec) * mix_sl311 * conjg (mix_sl321))
    gwwsl2sl1_3 = (((g**2) / 2.0_omega_prec) * mix_sl321 * conjg (mix_sl311))
    gwwsn1sn1_3 = ((g**2) / 2.0_omega_prec)
    gwwsu1su1_3 = (((g**2) / 2.0_omega_prec) * (mix_su311 * conjg (mix_su311)))
    gwwsu2su2_3 = (((g**2) / 2.0_omega_prec) * (mix_su321 * conjg (mix_su321)))
    gwwsu1su2_3 = (((g**2) / 2.0_omega_prec) * mix_su311 * conjg (mix_su321))
    gwwsu2su1_3 = (((g**2) / 2.0_omega_prec) * mix_su321 * conjg (mix_su311))
    gwwsd1sd1_3 = (((g**2) / 2.0_omega_prec) * (mix_sd311 * conjg (mix_sd311)))
    gwwsd2sd2_3 = (((g**2) / 2.0_omega_prec) * (mix_sd321 * conjg (mix_sd321)))
    gwwsd1sd2_3 = (((g**2) / 2.0_omega_prec) * mix_sd311 * conjg (mix_sd321))
    gwwsd2sd1_3 = (((g**2) / 2.0_omega_prec) * mix_sd321 * conjg (mix_sd311))
    gpwsl1sn_3 = ( - (e * 2.0_omega_prec * gcc * mix_sl311))
    gpwsl2sn_3 = ( - (e * 2.0_omega_prec * gcc * mix_sl321))
    gpwsl1sn_3_c = ( - (e * 2.0_omega_prec * gcc * conjg (mix_sl311)))
    gpwsl2sn_3_c = ( - (e * 2.0_omega_prec * gcc * conjg (mix_sl321)))
    gwzsl1sn_3 = (gcc * gz * 2.0_omega_prec * sin2thw * mix_sl311)
    gwzsl2sn_3 = (gcc * gz * 2.0_omega_prec * sin2thw * mix_sl321)
    gwzsl1sn_3_c = (gcc * gz * 2.0_omega_prec * sin2thw * conjg (mix_sl311))
    gwzsl2sn_3_c = (gcc * gz * 2.0_omega_prec * sin2thw * conjg (mix_sl321))
    gpwpsu1sd1_1_1 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_11 *  &
      conjg (mix_su111) * mix_sd111)
    gpwpsu2sd2_1_1 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_11 *  &
      conjg (mix_su121) * mix_sd121)
    gpwpsu1sd2_1_1 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_11 *  &
      conjg (mix_su111) * mix_sd121)
    gpwpsu2sd1_1_1 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_11 *  &
      conjg (mix_su121) * mix_sd111)
    gpwpsu1sd1_1_1_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_11) * mix_su111 * conjg (mix_sd111))
    gpwpsu2sd2_1_1_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_11) * mix_su121 * conjg (mix_sd121))
    gpwpsu1sd2_1_1_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_11) * mix_su111 * conjg (mix_sd121))
    gpwpsu2sd1_1_1_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_11) * mix_su121 * conjg (mix_sd111))
    gzwpsu1sd1_1_1 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw * vckm_11 *  &
      conjg (mix_su111) * mix_sd111))
    gzwpsu2sd2_1_1 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw * vckm_11 *  &
      conjg (mix_su121) * mix_sd121))
    gzwpsu1sd2_1_1 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * vckm_11 *  &
      conjg (mix_su111) * mix_sd121))
    gzwpsu2sd1_1_1 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * vckm_11 *  &
      conjg (mix_su121) * mix_sd111))
    gzwpsu1sd1_1_1_c = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw *  &
      conjg (vckm_11) * mix_su111 * conjg (mix_sd111)))
    gzwpsu2sd2_1_1_c = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw *  &
      conjg (vckm_11) * mix_su121 * conjg (mix_sd121)))
    gzwpsu1sd2_1_1_c = ( - (gcc * gz * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_11) * mix_su111 * conjg (mix_sd121)))
    gzwpsu2sd1_1_1_c = ( - (gcc * gz * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_11) * mix_su121 * conjg (mix_sd111)))
    gpwpsu1sd1_1_2 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_12 *  &
      conjg (mix_su111) * mix_sd211)
    gpwpsu2sd2_1_2 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_12 *  &
      conjg (mix_su121) * mix_sd221)
    gpwpsu1sd2_1_2 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_12 *  &
      conjg (mix_su111) * mix_sd221)
    gpwpsu2sd1_1_2 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_12 *  &
      conjg (mix_su121) * mix_sd211)
    gpwpsu1sd1_1_2_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_12) * mix_su111 * conjg (mix_sd211))
    gpwpsu2sd2_1_2_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_12) * mix_su121 * conjg (mix_sd221))
    gpwpsu1sd2_1_2_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_12) * mix_su111 * conjg (mix_sd221))
    gpwpsu2sd1_1_2_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_12) * mix_su121 * conjg (mix_sd211))
    gzwpsu1sd1_1_2 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw * vckm_12 *  &
      conjg (mix_su111) * mix_sd211))
 end subroutine setup_parameters4
 subroutine setup_parameters5 ()
    gzwpsu2sd2_1_2 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw * vckm_12 *  &
      conjg (mix_su121) * mix_sd221))
    gzwpsu1sd2_1_2 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * vckm_12 *  &
      conjg (mix_su111) * mix_sd221))
    gzwpsu2sd1_1_2 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * vckm_12 *  &
      conjg (mix_su121) * mix_sd211))
    gzwpsu1sd1_1_2_c = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw *  &
      conjg (vckm_12) * mix_su111 * conjg (mix_sd211)))
    gzwpsu2sd2_1_2_c = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw *  &
      conjg (vckm_12) * mix_su121 * conjg (mix_sd221)))
    gzwpsu1sd2_1_2_c = ( - (gcc * gz * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_12) * mix_su111 * conjg (mix_sd221)))
    gzwpsu2sd1_1_2_c = ( - (gcc * gz * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_12) * mix_su121 * conjg (mix_sd211)))
    gpwpsu1sd1_1_3 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_13 *  &
      conjg (mix_su111) * mix_sd311)
    gpwpsu2sd2_1_3 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_13 *  &
      conjg (mix_su121) * mix_sd321)
    gpwpsu1sd2_1_3 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_13 *  &
      conjg (mix_su111) * mix_sd321)
    gpwpsu2sd1_1_3 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_13 *  &
      conjg (mix_su121) * mix_sd311)
    gpwpsu1sd1_1_3_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_13) * mix_su111 * conjg (mix_sd311))
    gpwpsu2sd2_1_3_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_13) * mix_su121 * conjg (mix_sd321))
    gpwpsu1sd2_1_3_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_13) * mix_su111 * conjg (mix_sd321))
    gpwpsu2sd1_1_3_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_13) * mix_su121 * conjg (mix_sd311))
    gzwpsu1sd1_1_3 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw * vckm_13 *  &
      conjg (mix_su111) * mix_sd311))
    gzwpsu2sd2_1_3 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw * vckm_13 *  &
      conjg (mix_su121) * mix_sd321))
    gzwpsu1sd2_1_3 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * vckm_13 *  &
      conjg (mix_su111) * mix_sd321))
    gzwpsu2sd1_1_3 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * vckm_13 *  &
      conjg (mix_su121) * mix_sd311))
    gzwpsu1sd1_1_3_c = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw *  &
      conjg (vckm_13) * mix_su111 * conjg (mix_sd311)))
    gzwpsu2sd2_1_3_c = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw *  &
      conjg (vckm_13) * mix_su121 * conjg (mix_sd321)))
    gzwpsu1sd2_1_3_c = ( - (gcc * gz * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_13) * mix_su111 * conjg (mix_sd321)))
    gzwpsu2sd1_1_3_c = ( - (gcc * gz * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_13) * mix_su121 * conjg (mix_sd311)))
    gpwpsu1sd1_2_1 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_21 *  &
      conjg (mix_su211) * mix_sd111)
    gpwpsu2sd2_2_1 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_21 *  &
      conjg (mix_su221) * mix_sd121)
    gpwpsu1sd2_2_1 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_21 *  &
      conjg (mix_su211) * mix_sd121)
    gpwpsu2sd1_2_1 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_21 *  &
      conjg (mix_su221) * mix_sd111)
    gpwpsu1sd1_2_1_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_21) * mix_su211 * conjg (mix_sd111))
    gpwpsu2sd2_2_1_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_21) * mix_su221 * conjg (mix_sd121))
    gpwpsu1sd2_2_1_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_21) * mix_su211 * conjg (mix_sd121))
    gpwpsu2sd1_2_1_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_21) * mix_su221 * conjg (mix_sd111))
    gzwpsu1sd1_2_1 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw * vckm_21 *  &
      conjg (mix_su211) * mix_sd111))
    gzwpsu2sd2_2_1 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw * vckm_21 *  &
      conjg (mix_su221) * mix_sd121))
    gzwpsu1sd2_2_1 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * vckm_21 *  &
      conjg (mix_su211) * mix_sd121))
    gzwpsu2sd1_2_1 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * vckm_21 *  &
      conjg (mix_su221) * mix_sd111))
    gzwpsu1sd1_2_1_c = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw *  &
      conjg (vckm_21) * mix_su211 * conjg (mix_sd111)))
    gzwpsu2sd2_2_1_c = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw *  &
      conjg (vckm_21) * mix_su221 * conjg (mix_sd121)))
    gzwpsu1sd2_2_1_c = ( - (gcc * gz * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_21) * mix_su211 * conjg (mix_sd121)))
    gzwpsu2sd1_2_1_c = ( - (gcc * gz * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_21) * mix_su221 * conjg (mix_sd111)))
    gpwpsu1sd1_2_2 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_22 *  &
      conjg (mix_su211) * mix_sd211)
    gpwpsu2sd2_2_2 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_22 *  &
      conjg (mix_su221) * mix_sd221)
    gpwpsu1sd2_2_2 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_22 *  &
      conjg (mix_su211) * mix_sd221)
    gpwpsu2sd1_2_2 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_22 *  &
      conjg (mix_su221) * mix_sd211)
    gpwpsu1sd1_2_2_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_22) * mix_su211 * conjg (mix_sd211))
    gpwpsu2sd2_2_2_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_22) * mix_su221 * conjg (mix_sd221))
    gpwpsu1sd2_2_2_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_22) * mix_su211 * conjg (mix_sd221))
    gpwpsu2sd1_2_2_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_22) * mix_su221 * conjg (mix_sd211))
    gzwpsu1sd1_2_2 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw * vckm_22 *  &
      conjg (mix_su211) * mix_sd211))
    gzwpsu2sd2_2_2 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw * vckm_22 *  &
      conjg (mix_su221) * mix_sd221))
    gzwpsu1sd2_2_2 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * vckm_22 *  &
      conjg (mix_su211) * mix_sd221))
    gzwpsu2sd1_2_2 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * vckm_22 *  &
      conjg (mix_su221) * mix_sd211))
    gzwpsu1sd1_2_2_c = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw *  &
      conjg (vckm_22) * mix_su211 * conjg (mix_sd211)))
    gzwpsu2sd2_2_2_c = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw *  &
      conjg (vckm_22) * mix_su221 * conjg (mix_sd221)))
    gzwpsu1sd2_2_2_c = ( - (gcc * gz * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_22) * mix_su211 * conjg (mix_sd221)))
    gzwpsu2sd1_2_2_c = ( - (gcc * gz * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_22) * mix_su221 * conjg (mix_sd211)))
    gpwpsu1sd1_2_3 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_23 *  &
      conjg (mix_su211) * mix_sd311)
    gpwpsu2sd2_2_3 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_23 *  &
      conjg (mix_su221) * mix_sd321)
    gpwpsu1sd2_2_3 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_23 *  &
      conjg (mix_su211) * mix_sd321)
    gpwpsu2sd1_2_3 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_23 *  &
      conjg (mix_su221) * mix_sd311)
    gpwpsu1sd1_2_3_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_23) * mix_su211 * conjg (mix_sd311))
    gpwpsu2sd2_2_3_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_23) * mix_su221 * conjg (mix_sd321))
    gpwpsu1sd2_2_3_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_23) * mix_su211 * conjg (mix_sd321))
    gpwpsu2sd1_2_3_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_23) * mix_su221 * conjg (mix_sd311))
    gzwpsu1sd1_2_3 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw * vckm_23 *  &
      conjg (mix_su211) * mix_sd311))
    gzwpsu2sd2_2_3 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw * vckm_23 *  &
      conjg (mix_su221) * mix_sd321))
    gzwpsu1sd2_2_3 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * vckm_23 *  &
      conjg (mix_su211) * mix_sd321))
    gzwpsu2sd1_2_3 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * vckm_23 *  &
      conjg (mix_su221) * mix_sd311))
    gzwpsu1sd1_2_3_c = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw *  &
      conjg (vckm_23) * mix_su211 * conjg (mix_sd311)))
    gzwpsu2sd2_2_3_c = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw *  &
      conjg (vckm_23) * mix_su221 * conjg (mix_sd321)))
    gzwpsu1sd2_2_3_c = ( - (gcc * gz * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_23) * mix_su211 * conjg (mix_sd321)))
    gzwpsu2sd1_2_3_c = ( - (gcc * gz * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_23) * mix_su221 * conjg (mix_sd311)))
    gpwpsu1sd1_3_1 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_31 *  &
      conjg (mix_su311) * mix_sd111)
    gpwpsu2sd2_3_1 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_31 *  &
      conjg (mix_su321) * mix_sd121)
    gpwpsu1sd2_3_1 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_31 *  &
      conjg (mix_su311) * mix_sd121)
    gpwpsu2sd1_3_1 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_31 *  &
      conjg (mix_su321) * mix_sd111)
    gpwpsu1sd1_3_1_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_31) * mix_su311 * conjg (mix_sd111))
    gpwpsu2sd2_3_1_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_31) * mix_su321 * conjg (mix_sd121))
    gpwpsu1sd2_3_1_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_31) * mix_su311 * conjg (mix_sd121))
    gpwpsu2sd1_3_1_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_31) * mix_su321 * conjg (mix_sd111))
    gzwpsu1sd1_3_1 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw * vckm_31 *  &
      conjg (mix_su311) * mix_sd111))
    gzwpsu2sd2_3_1 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw * vckm_31 *  &
      conjg (mix_su321) * mix_sd121))
    gzwpsu1sd2_3_1 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * vckm_31 *  &
      conjg (mix_su311) * mix_sd121))
    gzwpsu2sd1_3_1 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * vckm_31 *  &
      conjg (mix_su321) * mix_sd111))
    gzwpsu1sd1_3_1_c = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw *  &
      conjg (vckm_31) * mix_su311 * conjg (mix_sd111)))
    gzwpsu2sd2_3_1_c = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw *  &
      conjg (vckm_31) * mix_su321 * conjg (mix_sd121)))
    gzwpsu1sd2_3_1_c = ( - (gcc * gz * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_31) * mix_su311 * conjg (mix_sd121)))
    gzwpsu2sd1_3_1_c = ( - (gcc * gz * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_31) * mix_su321 * conjg (mix_sd111)))
    gpwpsu1sd1_3_2 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_32 *  &
      conjg (mix_su311) * mix_sd211)
    gpwpsu2sd2_3_2 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_32 *  &
      conjg (mix_su321) * mix_sd221)
    gpwpsu1sd2_3_2 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_32 *  &
      conjg (mix_su311) * mix_sd221)
    gpwpsu2sd1_3_2 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_32 *  &
      conjg (mix_su321) * mix_sd211)
    gpwpsu1sd1_3_2_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_32) * mix_su311 * conjg (mix_sd211))
    gpwpsu2sd2_3_2_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_32) * mix_su321 * conjg (mix_sd221))
    gpwpsu1sd2_3_2_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_32) * mix_su311 * conjg (mix_sd221))
    gpwpsu2sd1_3_2_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_32) * mix_su321 * conjg (mix_sd211))
    gzwpsu1sd1_3_2 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw * vckm_32 *  &
      conjg (mix_su311) * mix_sd211))
    gzwpsu2sd2_3_2 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw * vckm_32 *  &
      conjg (mix_su321) * mix_sd221))
    gzwpsu1sd2_3_2 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * vckm_32 *  &
      conjg (mix_su311) * mix_sd221))
    gzwpsu2sd1_3_2 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * vckm_32 *  &
      conjg (mix_su321) * mix_sd211))
    gzwpsu1sd1_3_2_c = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw *  &
      conjg (vckm_32) * mix_su311 * conjg (mix_sd211)))
    gzwpsu2sd2_3_2_c = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw *  &
      conjg (vckm_32) * mix_su321 * conjg (mix_sd221)))
    gzwpsu1sd2_3_2_c = ( - (gcc * gz * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_32) * mix_su311 * conjg (mix_sd221)))
    gzwpsu2sd1_3_2_c = ( - (gcc * gz * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_32) * mix_su321 * conjg (mix_sd211)))
    gpwpsu1sd1_3_3 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_33 *  &
      conjg (mix_su311) * mix_sd311)
    gpwpsu2sd2_3_3 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_33 *  &
      conjg (mix_su321) * mix_sd321)
    gpwpsu1sd2_3_3 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_33 *  &
      conjg (mix_su311) * mix_sd321)
    gpwpsu2sd1_3_3 = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) * vckm_33 *  &
      conjg (mix_su321) * mix_sd311)
    gpwpsu1sd1_3_3_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_33) * mix_su311 * conjg (mix_sd311))
    gpwpsu2sd2_3_3_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_33) * mix_su321 * conjg (mix_sd321))
    gpwpsu1sd2_3_3_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_33) * mix_su311 * conjg (mix_sd321))
    gpwpsu2sd1_3_3_c = (e * gcc * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_33) * mix_su321 * conjg (mix_sd311))
    gzwpsu1sd1_3_3 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw * vckm_33 *  &
      conjg (mix_su311) * mix_sd311))
    gzwpsu2sd2_3_3 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw * vckm_33 *  &
      conjg (mix_su321) * mix_sd321))
    gzwpsu1sd2_3_3 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * vckm_33 *  &
      conjg (mix_su311) * mix_sd321))
    gzwpsu2sd1_3_3 = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * vckm_33 *  &
      conjg (mix_su321) * mix_sd311))
    gzwpsu1sd1_3_3_c = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw *  &
      conjg (vckm_33) * mix_su311 * conjg (mix_sd311)))
    gzwpsu2sd2_3_3_c = ( - (gcc * gz *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw *  &
      conjg (vckm_33) * mix_su321 * conjg (mix_sd321)))
    gzwpsu1sd2_3_3_c = ( - (gcc * gz * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_33) * mix_su311 * conjg (mix_sd321)))
    gzwpsu2sd1_3_3_c = ( - (gcc * gz * (2.0_omega_prec / 3.0_omega_prec) *  &
      conjg (vckm_33) * mix_su321 * conjg (mix_sd311)))
    gglglsqsq = (gs**2)
 end subroutine setup_parameters5
 subroutine setup_parameters6 ()
    gglpsqsq = (2.0_omega_prec * e * gs)
    gglsu1su1_1 = (gz * gs * (((1.0_omega_prec / 2.0_omega_prec) *  &
      (mix_su111 * conjg (mix_su111))) - (sin2thw *  &
      (2.0_omega_prec / 3.0_omega_prec))))
    gglsu2su2_1 = (gz * gs * (((1.0_omega_prec / 2.0_omega_prec) *  &
      (mix_su121 * conjg (mix_su121))) - (sin2thw *  &
      (2.0_omega_prec / 3.0_omega_prec))))
    gglsu1su2_1 = (gz * gs * (1.0_omega_prec / 2.0_omega_prec) * mix_su111 *  &
      conjg (mix_su121))
    gglsu2su1_1 = (gz * gs * (1.0_omega_prec / 2.0_omega_prec) * mix_su121 *  &
      conjg (mix_su111))
    gglsd1sd1_1 = ( - (gz * gs * (((1.0_omega_prec / 2.0_omega_prec) *  &
      (mix_sd111 * conjg (mix_sd111))) - (sin2thw *  &
      (1.0_omega_prec / 3.0_omega_prec)))))
    gglsd2sd2_1 = ( - (gz * gs * (((1.0_omega_prec / 2.0_omega_prec) *  &
      (mix_sd121 * conjg (mix_sd121))) - (sin2thw *  &
      (1.0_omega_prec / 3.0_omega_prec)))))
    gglsd1sd2_1 = ( - (gz * gs *  &
      (1.0_omega_prec / 2.0_omega_prec) * mix_sd111 * conjg (mix_sd121)))
    gglsd2sd1_1 = ( - (gz * gs *  &
      (1.0_omega_prec / 2.0_omega_prec) * mix_sd121 * conjg (mix_sd111)))
    gglsu1su1_2 = (gz * gs * (((1.0_omega_prec / 2.0_omega_prec) *  &
      (mix_su211 * conjg (mix_su211))) - (sin2thw *  &
      (2.0_omega_prec / 3.0_omega_prec))))
    gglsu2su2_2 = (gz * gs * (((1.0_omega_prec / 2.0_omega_prec) *  &
      (mix_su221 * conjg (mix_su221))) - (sin2thw *  &
      (2.0_omega_prec / 3.0_omega_prec))))
    gglsu1su2_2 = (gz * gs * (1.0_omega_prec / 2.0_omega_prec) * mix_su211 *  &
      conjg (mix_su221))
    gglsu2su1_2 = (gz * gs * (1.0_omega_prec / 2.0_omega_prec) * mix_su221 *  &
      conjg (mix_su211))
    gglsd1sd1_2 = ( - (gz * gs * (((1.0_omega_prec / 2.0_omega_prec) *  &
      (mix_sd211 * conjg (mix_sd211))) - (sin2thw *  &
      (1.0_omega_prec / 3.0_omega_prec)))))
    gglsd2sd2_2 = ( - (gz * gs * (((1.0_omega_prec / 2.0_omega_prec) *  &
      (mix_sd221 * conjg (mix_sd221))) - (sin2thw *  &
      (1.0_omega_prec / 3.0_omega_prec)))))
    gglsd1sd2_2 = ( - (gz * gs *  &
      (1.0_omega_prec / 2.0_omega_prec) * mix_sd211 * conjg (mix_sd221)))
    gglsd2sd1_2 = ( - (gz * gs *  &
      (1.0_omega_prec / 2.0_omega_prec) * mix_sd221 * conjg (mix_sd211)))
    gglsu1su1_3 = (gz * gs * (((1.0_omega_prec / 2.0_omega_prec) *  &
      (mix_su311 * conjg (mix_su311))) - (sin2thw *  &
      (2.0_omega_prec / 3.0_omega_prec))))
    gglsu2su2_3 = (gz * gs * (((1.0_omega_prec / 2.0_omega_prec) *  &
      (mix_su321 * conjg (mix_su321))) - (sin2thw *  &
      (2.0_omega_prec / 3.0_omega_prec))))
    gglsu1su2_3 = (gz * gs * (1.0_omega_prec / 2.0_omega_prec) * mix_su311 *  &
      conjg (mix_su321))
    gglsu2su1_3 = (gz * gs * (1.0_omega_prec / 2.0_omega_prec) * mix_su321 *  &
      conjg (mix_su311))
    gglsd1sd1_3 = ( - (gz * gs * (((1.0_omega_prec / 2.0_omega_prec) *  &
      (mix_sd311 * conjg (mix_sd311))) - (sin2thw *  &
      (1.0_omega_prec / 3.0_omega_prec)))))
    gglsd2sd2_3 = ( - (gz * gs * (((1.0_omega_prec / 2.0_omega_prec) *  &
      (mix_sd321 * conjg (mix_sd321))) - (sin2thw *  &
      (1.0_omega_prec / 3.0_omega_prec)))))
    gglsd1sd2_3 = ( - (gz * gs *  &
      (1.0_omega_prec / 2.0_omega_prec) * mix_sd311 * conjg (mix_sd321)))
    gglsd2sd1_3 = ( - (gz * gs *  &
      (1.0_omega_prec / 2.0_omega_prec) * mix_sd321 * conjg (mix_sd311)))
    gglwsu1sd1_1_1 = (g * gs * sqrt (2.0_omega_prec) * vckm_11 *  &
      conjg (mix_su111) * mix_sd111)
    gglwsu2sd2_1_1 = (g * gs * sqrt (2.0_omega_prec) * vckm_11 *  &
      conjg (mix_su121) * mix_sd121)
    gglwsu1sd2_1_1 = (g * gs * sqrt (2.0_omega_prec) * vckm_11 *  &
      conjg (mix_su111) * mix_sd121)
    gglwsu2sd1_1_1 = (g * gs * sqrt (2.0_omega_prec) * vckm_11 *  &
      conjg (mix_su121) * mix_sd111)
    gglwsu1sd1_1_1_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_11) * mix_su111 * conjg (mix_sd111))
    gglwsu2sd2_1_1_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_11) * mix_su121 * conjg (mix_sd121))
    gglwsu1sd2_1_1_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_11) * mix_su111 * conjg (mix_sd121))
    gglwsu2sd1_1_1_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_11) * mix_su121 * conjg (mix_sd111))
    gglwsu1sd1_1_2 = (g * gs * sqrt (2.0_omega_prec) * vckm_12 *  &
      conjg (mix_su111) * mix_sd211)
    gglwsu2sd2_1_2 = (g * gs * sqrt (2.0_omega_prec) * vckm_12 *  &
      conjg (mix_su121) * mix_sd221)
    gglwsu1sd2_1_2 = (g * gs * sqrt (2.0_omega_prec) * vckm_12 *  &
      conjg (mix_su111) * mix_sd221)
    gglwsu2sd1_1_2 = (g * gs * sqrt (2.0_omega_prec) * vckm_12 *  &
      conjg (mix_su121) * mix_sd211)
    gglwsu1sd1_1_2_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_12) * mix_su111 * conjg (mix_sd211))
    gglwsu2sd2_1_2_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_12) * mix_su121 * conjg (mix_sd221))
    gglwsu1sd2_1_2_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_12) * mix_su111 * conjg (mix_sd221))
    gglwsu2sd1_1_2_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_12) * mix_su121 * conjg (mix_sd211))
    gglwsu1sd1_1_3 = (g * gs * sqrt (2.0_omega_prec) * vckm_13 *  &
      conjg (mix_su111) * mix_sd311)
    gglwsu2sd2_1_3 = (g * gs * sqrt (2.0_omega_prec) * vckm_13 *  &
      conjg (mix_su121) * mix_sd321)
    gglwsu1sd2_1_3 = (g * gs * sqrt (2.0_omega_prec) * vckm_13 *  &
      conjg (mix_su111) * mix_sd321)
    gglwsu2sd1_1_3 = (g * gs * sqrt (2.0_omega_prec) * vckm_13 *  &
      conjg (mix_su121) * mix_sd311)
    gglwsu1sd1_1_3_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_13) * mix_su111 * conjg (mix_sd311))
    gglwsu2sd2_1_3_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_13) * mix_su121 * conjg (mix_sd321))
    gglwsu1sd2_1_3_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_13) * mix_su111 * conjg (mix_sd321))
    gglwsu2sd1_1_3_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_13) * mix_su121 * conjg (mix_sd311))
    gglwsu1sd1_2_1 = (g * gs * sqrt (2.0_omega_prec) * vckm_21 *  &
      conjg (mix_su211) * mix_sd111)
    gglwsu2sd2_2_1 = (g * gs * sqrt (2.0_omega_prec) * vckm_21 *  &
      conjg (mix_su221) * mix_sd121)
    gglwsu1sd2_2_1 = (g * gs * sqrt (2.0_omega_prec) * vckm_21 *  &
      conjg (mix_su211) * mix_sd121)
    gglwsu2sd1_2_1 = (g * gs * sqrt (2.0_omega_prec) * vckm_21 *  &
      conjg (mix_su221) * mix_sd111)
    gglwsu1sd1_2_1_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_21) * mix_su211 * conjg (mix_sd111))
    gglwsu2sd2_2_1_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_21) * mix_su221 * conjg (mix_sd121))
    gglwsu1sd2_2_1_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_21) * mix_su211 * conjg (mix_sd121))
    gglwsu2sd1_2_1_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_21) * mix_su221 * conjg (mix_sd111))
    gglwsu1sd1_2_2 = (g * gs * sqrt (2.0_omega_prec) * vckm_22 *  &
      conjg (mix_su211) * mix_sd211)
    gglwsu2sd2_2_2 = (g * gs * sqrt (2.0_omega_prec) * vckm_22 *  &
      conjg (mix_su221) * mix_sd221)
    gglwsu1sd2_2_2 = (g * gs * sqrt (2.0_omega_prec) * vckm_22 *  &
      conjg (mix_su211) * mix_sd221)
    gglwsu2sd1_2_2 = (g * gs * sqrt (2.0_omega_prec) * vckm_22 *  &
      conjg (mix_su221) * mix_sd211)
    gglwsu1sd1_2_2_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_22) * mix_su211 * conjg (mix_sd211))
    gglwsu2sd2_2_2_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_22) * mix_su221 * conjg (mix_sd221))
    gglwsu1sd2_2_2_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_22) * mix_su211 * conjg (mix_sd221))
    gglwsu2sd1_2_2_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_22) * mix_su221 * conjg (mix_sd211))
    gglwsu1sd1_2_3 = (g * gs * sqrt (2.0_omega_prec) * vckm_23 *  &
      conjg (mix_su211) * mix_sd311)
    gglwsu2sd2_2_3 = (g * gs * sqrt (2.0_omega_prec) * vckm_23 *  &
      conjg (mix_su221) * mix_sd321)
    gglwsu1sd2_2_3 = (g * gs * sqrt (2.0_omega_prec) * vckm_23 *  &
      conjg (mix_su211) * mix_sd321)
    gglwsu2sd1_2_3 = (g * gs * sqrt (2.0_omega_prec) * vckm_23 *  &
      conjg (mix_su221) * mix_sd311)
    gglwsu1sd1_2_3_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_23) * mix_su211 * conjg (mix_sd311))
    gglwsu2sd2_2_3_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_23) * mix_su221 * conjg (mix_sd321))
    gglwsu1sd2_2_3_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_23) * mix_su211 * conjg (mix_sd321))
    gglwsu2sd1_2_3_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_23) * mix_su221 * conjg (mix_sd311))
    gglwsu1sd1_3_1 = (g * gs * sqrt (2.0_omega_prec) * vckm_31 *  &
      conjg (mix_su311) * mix_sd111)
    gglwsu2sd2_3_1 = (g * gs * sqrt (2.0_omega_prec) * vckm_31 *  &
      conjg (mix_su321) * mix_sd121)
    gglwsu1sd2_3_1 = (g * gs * sqrt (2.0_omega_prec) * vckm_31 *  &
      conjg (mix_su311) * mix_sd121)
    gglwsu2sd1_3_1 = (g * gs * sqrt (2.0_omega_prec) * vckm_31 *  &
      conjg (mix_su321) * mix_sd111)
    gglwsu1sd1_3_1_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_31) * mix_su311 * conjg (mix_sd111))
    gglwsu2sd2_3_1_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_31) * mix_su321 * conjg (mix_sd121))
    gglwsu1sd2_3_1_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_31) * mix_su311 * conjg (mix_sd121))
    gglwsu2sd1_3_1_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_31) * mix_su321 * conjg (mix_sd111))
    gglwsu1sd1_3_2 = (g * gs * sqrt (2.0_omega_prec) * vckm_32 *  &
      conjg (mix_su311) * mix_sd211)
    gglwsu2sd2_3_2 = (g * gs * sqrt (2.0_omega_prec) * vckm_32 *  &
      conjg (mix_su321) * mix_sd221)
    gglwsu1sd2_3_2 = (g * gs * sqrt (2.0_omega_prec) * vckm_32 *  &
      conjg (mix_su311) * mix_sd221)
 end subroutine setup_parameters6
 subroutine setup_parameters7 ()
    gglwsu2sd1_3_2 = (g * gs * sqrt (2.0_omega_prec) * vckm_32 *  &
      conjg (mix_su321) * mix_sd211)
    gglwsu1sd1_3_2_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_32) * mix_su311 * conjg (mix_sd211))
    gglwsu2sd2_3_2_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_32) * mix_su321 * conjg (mix_sd221))
    gglwsu1sd2_3_2_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_32) * mix_su311 * conjg (mix_sd221))
    gglwsu2sd1_3_2_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_32) * mix_su321 * conjg (mix_sd211))
    gglwsu1sd1_3_3 = (g * gs * sqrt (2.0_omega_prec) * vckm_33 *  &
      conjg (mix_su311) * mix_sd311)
    gglwsu2sd2_3_3 = (g * gs * sqrt (2.0_omega_prec) * vckm_33 *  &
      conjg (mix_su321) * mix_sd321)
    gglwsu1sd2_3_3 = (g * gs * sqrt (2.0_omega_prec) * vckm_33 *  &
      conjg (mix_su311) * mix_sd321)
    gglwsu2sd1_3_3 = (g * gs * sqrt (2.0_omega_prec) * vckm_33 *  &
      conjg (mix_su321) * mix_sd311)
    gglwsu1sd1_3_3_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_33) * mix_su311 * conjg (mix_sd311))
    gglwsu2sd2_3_3_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_33) * mix_su321 * conjg (mix_sd321))
    gglwsu1sd2_3_3_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_33) * mix_su311 * conjg (mix_sd321))
    gglwsu2sd1_3_3_c = (g * gs * sqrt (2.0_omega_prec) *  &
      conjg (vckm_33) * mix_su321 * conjg (mix_sd311))
    a0_11 = real ((mn_14 * conjg (mn_14)) - (mn_13 * conjg (mn_13))) &
      / 2.0_omega_prec
    snnh1_11 = 2.0_omega_prec * ( - real ((mn_12 - ( &
      (sinthw / costhw) * mn_11)) * ((sinal * mn_13) + (cosal * mn_14)))) 
    snnh2_11 = 2.0_omega_prec * real ((mn_12 - ((sinthw / costhw) * mn_11)) * &
      ((cosal * mn_13) - (sinal * mn_14))) 
    pnna_11 = 2.0_omega_prec * real ((mn_12 - (mn_11 * (sinthw / costhw))) * ( &
      (mn_13 * sinbe) - (mn_14 * cosbe))) 
    v0_12 = cmplx (0.0_omega_prec, aimag ((mn_14 * conjg (mn_24)) -  &
      (mn_13 * conjg (mn_23))), kind=omega_prec) / 2.0_omega_prec
    a0_12 = real ((mn_14 * conjg (mn_24)) - (mn_13 * conjg (mn_23))) &
      / 2.0_omega_prec
    snnh1_12 = ( - real (((mn_12 - ((sinthw / costhw) * mn_11)) * ((sinal &
       * mn_23) + (cosal * mn_24))) + ((mn_22 - ((sinthw / costhw) * mn_21)) &
      * ((sinal * mn_13) + (cosal * mn_14))))) 
    pnnh1_12 = ( - cmplx (0.0_omega_prec, aimag (((mn_12 - ( &
      (sinthw / costhw) * mn_11)) * ((sinal * mn_23) + (cosal * mn_24))) + ( &
      (mn_22 - ((sinthw / costhw) * mn_21)) * ((sinal * mn_13) +  &
      (cosal * mn_14)))), kind=omega_prec))
    snnh2_12 = real (((mn_12 - ((sinthw / costhw) * mn_11)) * ((cosal * & 
      mn_23) - (sinal * mn_24))) + ((mn_22 - ((sinthw / costhw) * mn_21)) * ( &
      (cosal * mn_13) - (sinal * mn_14)))) 
    pnnh2_12 = cmplx (0.0_omega_prec, aimag (((mn_12 - ((sinthw / costhw) & 
      * mn_11)) * ((cosal * mn_23) - (sinal * mn_24))) + ((mn_22 - ( &
      (sinthw / costhw) * mn_21)) * ((cosal * mn_13) -  &
      (sinal * mn_14)))), kind=omega_prec)
    snna_12 = - cmplx (0.0_omega_prec, aimag (((mn_12 - (mn_11 *  &
      (sinthw / costhw))) * ((mn_23 * sinbe) - (mn_24 * cosbe))) + ((mn_22 -  &
      (mn_21 * (sinthw / costhw))) * ((mn_13 * sinbe) -  &
      (mn_14 * cosbe)))), kind=omega_prec)
    pnna_12 = real (((mn_12 - (mn_11 * (sinthw / costhw))) * ((mn_23 * sinbe) &
      - (mn_24 * cosbe))) + ((mn_22 - (mn_21 * (sinthw / costhw))) * ( &
      (mn_13 * sinbe) - (mn_14 * cosbe)))) 
    v0_13 = cmplx (0.0_omega_prec, aimag ((mn_14 * conjg (mn_34)) - (mn_13 * &
      conjg (mn_33))), kind=omega_prec) / 2.0_omega_prec 
    a0_13 = real ((mn_14 * conjg (mn_34)) - (mn_13 * conjg (mn_33))) &
      / 2.0_omega_prec
    snnh1_13 = ( - real (((mn_12 - ((sinthw / costhw) * mn_11)) * ((sinal * &
       mn_33) + (cosal * mn_34))) + ((mn_32 - ((sinthw / costhw) * mn_31)) * ( &
      (sinal * mn_13) + (cosal * mn_14))))) 
    pnnh1_13 = ( - cmplx (0.0_omega_prec, aimag (((mn_12 - ( &
      (sinthw / costhw) * mn_11)) * ((sinal * mn_33) + (cosal * mn_34))) + ( &
      (mn_32 - ((sinthw / costhw) * mn_31)) * ((sinal * mn_13) +  &
      (cosal * mn_14)))), kind=omega_prec)) 
    snnh2_13 = real (((mn_12 - ((sinthw / costhw) * mn_11)) * ((cosal * & 
      mn_33) - (sinal * mn_34))) + ((mn_32 - ((sinthw / costhw) * mn_31)) * ( &
      (cosal * mn_13) - (sinal * mn_14)))) 
    pnnh2_13 = cmplx (0.0_omega_prec, aimag (((mn_12 - ((sinthw / costhw) * & 
      mn_11)) * ((cosal * mn_33) - (sinal * mn_34))) + ((mn_32 - ( &
      (sinthw / costhw) * mn_31)) * ((cosal * mn_13) -  &
      (sinal * mn_14)))), kind=omega_prec)
    snna_13 = - cmplx (0.0_omega_prec, aimag (((mn_12 - (mn_11 *  &
      (sinthw / costhw))) * ((mn_33 * sinbe) - (mn_34 * cosbe))) + ((mn_32 -  &
      (mn_31 * (sinthw / costhw))) * ((mn_13 * sinbe) -  &
      (mn_14 * cosbe)))), kind=omega_prec) 
    pnna_13 = real (((mn_12 - (mn_11 * (sinthw / costhw))) * ((mn_33 * sinbe) &
      -  (mn_34 * cosbe))) + ((mn_32 - (mn_31 * (sinthw / costhw))) * ( &
      (mn_13 * sinbe) - (mn_14 * cosbe)))) 
    v0_14 = cmplx (0.0_omega_prec, aimag ((mn_14 * conjg (mn_44)) - (mn_13 * & 
      conjg (mn_43))), kind=omega_prec) / 2.0_omega_prec
    a0_14 = real ((mn_14 * conjg (mn_44)) - (mn_13 * conjg (mn_43))) &
      / 2.0_omega_prec
    snnh1_14 = ( - real (((mn_12 - ((sinthw / costhw) * mn_11)) * ((sinal * & 
       mn_43) + (cosal * mn_44))) + ((mn_42 - ((sinthw / costhw) * mn_41)) * ( &
      (sinal * mn_13) + (cosal * mn_14))))) 
    pnnh1_14 = ( - cmplx (0.0_omega_prec, aimag (((mn_12 - ( &
      (sinthw / costhw) * mn_11)) * ((sinal * mn_43) + (cosal * mn_44))) + ( &
      (mn_42 - ((sinthw / costhw) * mn_41)) * ((sinal * mn_13) +  &
      (cosal * mn_14)))), kind=omega_prec))
    snnh2_14 = real (((mn_12 - ((sinthw / costhw) * mn_11)) * ((cosal * & 
      mn_43) - (sinal * mn_44))) + ((mn_42 - ((sinthw / costhw) * mn_41)) * ( &
      (cosal * mn_13) - (sinal * mn_14)))) 
    pnnh2_14 = cmplx (0.0_omega_prec, aimag (((mn_12 - ((sinthw / costhw) * &
      mn_11)) * ((cosal * mn_43) - (sinal * mn_44))) + ((mn_42 - ( &
      (sinthw / costhw) * mn_41)) * ((cosal * mn_13) -  &
      (sinal * mn_14)))), kind=omega_prec) 
    snna_14 = - cmplx (0.0_omega_prec, aimag (((mn_12 - (mn_11 *  &
      (sinthw / costhw))) * ((mn_43 * sinbe) - (mn_44 * cosbe))) + ((mn_42 -  &
      (mn_41 * (sinthw / costhw))) * ((mn_13 * sinbe) -  &
      (mn_14 * cosbe)))), kind=omega_prec) 
    pnna_14 = real (((mn_12 - (mn_11 * (sinthw / costhw))) * ((mn_43 * sinbe) &
      -  (mn_44 * cosbe))) + ((mn_42 - (mn_41 * (sinthw / costhw))) * ( &
      (mn_13 * sinbe) - (mn_14 * cosbe)))) 
    a0_22 = real ((mn_24 * conjg (mn_24)) - (mn_23 * conjg (mn_23))) &
      / 2.0_omega_prec
    snnh1_22 = 2.0_omega_prec * ( - real ((mn_22 - ( &
      (sinthw / costhw) * mn_21)) * ((sinal * mn_23) + (cosal * mn_24))))
    snnh2_22 = 2.0_omega_prec * real ((mn_22 - ((sinthw / costhw) * mn_21)) & 
      * ((cosal * mn_23) - (sinal * mn_24))) 
    pnna_22 = 2.0_omega_prec * real ((mn_22 - (mn_21 * (sinthw / costhw))) * ( &
      (mn_23 * sinbe) - (mn_24 * cosbe))) 
    v0_23 = cmplx (0.0_omega_prec, aimag ((mn_24 * conjg (mn_34)) - (mn_23 * & 
      conjg (mn_33))), kind=omega_prec) / 2.0_omega_prec
    a0_23 = real ((mn_24 * conjg (mn_34)) - (mn_23 * conjg (mn_33))) &
      / 2.0_omega_prec
    snnh1_23 = ( - real (((mn_22 - ((sinthw / costhw) * mn_21)) * ((sinal * &
      mn_33) + (cosal * mn_34))) + ((mn_32 - ((sinthw / costhw) * mn_31)) * ( &
      (sinal * mn_23) + (cosal * mn_24))))) 
    pnnh1_23 = ( - cmplx (0.0_omega_prec, aimag (((mn_22 - ( &
      (sinthw / costhw) * mn_21)) * ((sinal * mn_33) + (cosal * mn_34))) + ( &
      (mn_32 - ((sinthw / costhw) * mn_31)) * ((sinal * mn_23) +  &
      (cosal * mn_24)))), kind=omega_prec))
    snnh2_23 = real (((mn_22 - ((sinthw / costhw) * mn_21)) * ((cosal * & 
      mn_33) - (sinal * mn_34))) + ((mn_32 - ((sinthw / costhw) * mn_31)) * ( &
      (cosal * mn_23) - (sinal * mn_24)))) 
    pnnh2_23 = cmplx (0.0_omega_prec, aimag (((mn_22 - ((sinthw / costhw) * &
      mn_21)) * ((cosal * mn_33) - (sinal * mn_34))) + ((mn_32 - ( &
      (sinthw / costhw) * mn_31)) * ((cosal * mn_23) -  &
      (sinal * mn_24)))), kind=omega_prec) 
    snna_23 = - cmplx (0.0_omega_prec, aimag (((mn_22 - (mn_21 *  &
      (sinthw / costhw))) * ((mn_33 * sinbe) - (mn_34 * cosbe))) + ((mn_32 -  &
      (mn_31 * (sinthw / costhw))) * ((mn_23 * sinbe) -  &
      (mn_24 * cosbe)))), kind=omega_prec) 
    pnna_23 = real (((mn_22 - (mn_21 * (sinthw / costhw))) * ((mn_33 * sinbe) &
      - (mn_34 * cosbe))) + ((mn_32 - (mn_31 * (sinthw / costhw))) * ( &
      (mn_23 * sinbe) - (mn_24 * cosbe)))) 
    v0_24 = cmplx (0.0_omega_prec, aimag ((mn_24 * conjg (mn_44)) - (mn_23 * & 
      conjg (mn_43))), kind=omega_prec) / 2.0_omega_prec
    a0_24 = real ((mn_24 * conjg (mn_44)) - (mn_23 * conjg (mn_43))) &
      / 2.0_omega_prec
    snnh1_24 = - real (((mn_22 - ((sinthw / costhw) * mn_21)) * ((sinal * & 
      mn_43) + (cosal * mn_44))) + ((mn_42 - ((sinthw / costhw) * mn_41)) * ( &
      (sinal * mn_23) + (cosal * mn_24))))
    pnnh1_24 = ( - cmplx (0.0_omega_prec, aimag (((mn_22 - ( &
      (sinthw / costhw) * mn_21)) * ((sinal * mn_43) + (cosal * mn_44))) + ( &
      (mn_42 - ((sinthw / costhw) * mn_41)) * ((sinal * mn_23) +  &
      (cosal * mn_24)))), kind=omega_prec))
    snnh2_24 = real (((mn_22 - ((sinthw / costhw) * mn_21)) * ((cosal * & 
      mn_43) - (sinal * mn_44))) + ((mn_42 - ((sinthw / costhw) * mn_41)) * ( &
      (cosal * mn_23) - (sinal * mn_24)))) 
    pnnh2_24 = cmplx (0.0_omega_prec, aimag (((mn_22 - ((sinthw / costhw) * &
      mn_21)) * ((cosal * mn_43) - (sinal * mn_44))) + ((mn_42 - ( &
      (sinthw / costhw) * mn_41)) * ((cosal * mn_23) -  &
      (sinal * mn_24)))), kind=omega_prec) 
    snna_24 = - cmplx (0.0_omega_prec, aimag (((mn_22 - (mn_21 *  &
      (sinthw / costhw))) * ((mn_43 * sinbe) - (mn_44 * cosbe))) + ((mn_42 -  &
      (mn_41 * (sinthw / costhw))) * ((mn_23 * sinbe) -  &
      (mn_24 * cosbe)))), kind=omega_prec)
    pnna_24 = real (((mn_22 - (mn_21 * (sinthw / costhw))) * ((mn_43 * sinbe) &
      - (mn_44 * cosbe))) + ((mn_42 - (mn_41 * (sinthw / costhw))) * ( &
      (mn_23 * sinbe) - (mn_24 * cosbe)))) 
    a0_33 = real ((mn_34 * conjg (mn_34)) - (mn_33 * conjg (mn_33))) &
      / 2.0_omega_prec
    snnh1_33 = 2.0_omega_prec * ( - real ((mn_32 - ( &
      (sinthw / costhw) * mn_31)) * ((sinal * mn_33) + (cosal * mn_34)))) 
    snnh2_33 = 2.0_omega_prec * real ((mn_32 - ((sinthw / costhw) * mn_31)) & 
      * ((cosal * mn_33) - (sinal * mn_34))) 
    pnna_33 = 2.0_omega_prec * real ((mn_32 - (mn_31 * (sinthw / costhw))) * ( &
      (mn_33 * sinbe) - (mn_34 * cosbe))) 
 end subroutine setup_parameters7
 subroutine setup_parameters8 ()
    v0_34 = cmplx (0.0_omega_prec, aimag ((mn_34 * conjg (mn_44)) - (mn_33 * & 
      conjg (mn_43))), kind=omega_prec) / 2.0_omega_prec
    a0_34 = real ((mn_34 * conjg (mn_44)) - (mn_33 * conjg (mn_43))) &
      / 2.0_omega_prec
    snnh1_34 = ( - real (((mn_32 - ((sinthw / costhw) * mn_31)) * ((sinal * &
      mn_43) + (cosal * mn_44))) + ((mn_42 - ((sinthw / costhw) * mn_41)) * ( &
      (sinal * mn_33) + (cosal * mn_34))))) 
    pnnh1_34 = ( - cmplx (0.0_omega_prec, aimag (((mn_32 - ( &
      (sinthw / costhw) * mn_31)) * ((sinal * mn_43) + (cosal * mn_44))) + ( &
      (mn_42 - ((sinthw / costhw) * mn_41)) * ((sinal * mn_33) +  &
      (cosal * mn_34)))), kind=omega_prec))
    snnh2_34 = real (((mn_32 - ((sinthw / costhw) * mn_31)) * ((cosal * & 
      mn_43) - (sinal * mn_44))) + ((mn_42 - ((sinthw / costhw) * mn_41)) * ( &
      (cosal * mn_33) - (sinal * mn_34)))) 
    pnnh2_34 = cmplx (0.0_omega_prec, aimag (((mn_32 - ((sinthw / costhw) * & 
      mn_31)) * ((cosal * mn_43) - (sinal * mn_44))) + ((mn_42 - ( &
      (sinthw / costhw) * mn_41)) * ((cosal * mn_33) -  &
      (sinal * mn_34)))), kind=omega_prec) 
    snna_34 = - cmplx (0.0_omega_prec, aimag (((mn_32 - (mn_31 *  &
      (sinthw / costhw))) * ((mn_43 * sinbe) - (mn_44 * cosbe))) + ((mn_42 -  &
      (mn_41 * (sinthw / costhw))) * ((mn_33 * sinbe) -  &
      (mn_34 * cosbe)))), kind=omega_prec) 
    pnna_34 = real (((mn_32 - (mn_31 * (sinthw / costhw))) * ((mn_43 * sinbe) &
      -  (mn_44 * cosbe))) + ((mn_42 - (mn_41 * (sinthw / costhw))) * ( &
      (mn_33 * sinbe) - (mn_34 * cosbe)))) 
    a0_44 = real ((mn_44 * conjg (mn_44)) - (mn_43 * conjg (mn_43))) &
      / 2.0_omega_prec
    snnh1_44 = 2.0_omega_prec * ( - real ((mn_42 - ( &
      (sinthw / costhw) * mn_41)) * ((sinal * mn_43) + (cosal * mn_44))))
    snnh2_44 = 2.0_omega_prec * real ((mn_42 - ((sinthw / costhw) * mn_41)) & 
      * ((cosal * mn_43) - (sinal * mn_44))) 
    pnna_44 = 2.0_omega_prec * real ((mn_42 - (mn_41 * (sinthw / costhw))) * ( &
      (mn_43 * sinbe) - (mn_44 * cosbe)))
    vp_11 = ((((1.0_omega_prec -  &
      (2.0_omega_prec * sin2thw)) / 4.0_omega_prec) * ((mv_12 * conjg (mv_12)) &
       + (conjg (mu_12) * mu_12))) + (((costhw**2) / 2.0_omega_prec) * ( &
      (mv_11 * conjg (mv_11)) + (conjg (mu_11) * mu_11))))
    ap_11 = ((((1.0_omega_prec -  &
      (2.0_omega_prec * sin2thw)) / 4.0_omega_prec) * ((mv_12 *  &
      conjg (mv_12)) - (conjg (mu_12) * mu_12))) + (( &
      (costhw**2) / 2.0_omega_prec) * ((mv_11 * conjg (mv_11)) - ( &
      conjg (mu_11) * mu_11))))
    vp_12 = ((((1.0_omega_prec -  &
      (2.0_omega_prec * sin2thw)) / 4.0_omega_prec) * ((mv_12 * conjg (mv_22)) &
       + (conjg (mu_12) * mu_22))) + (((costhw**2) / 2.0_omega_prec) * ( &
      (mv_11 * conjg (mv_21)) + (conjg (mu_11) * mu_21))))
    ap_12 = ((((1.0_omega_prec -  &
      (2.0_omega_prec * sin2thw)) / 4.0_omega_prec) * ((mv_12 *  &
      conjg (mv_22)) - (conjg (mu_12) * mu_22))) + (( &
      (costhw**2) / 2.0_omega_prec) * ((mv_11 * conjg (mv_21)) - ( &
      conjg (mu_11) * mu_21))))
    vp_21 = conjg (vp_12)
    ap_21 = conjg (ap_12)
    vp_22 = ((((1.0_omega_prec -  &
      (2.0_omega_prec * sin2thw)) / 4.0_omega_prec) * ((mv_22 * conjg (mv_22)) &
       + (conjg (mu_22) * mu_22))) + (((costhw**2) / 2.0_omega_prec) * ( &
      (mv_21 * conjg (mv_21)) + (conjg (mu_21) * mu_21))))
    ap_22 = ((((1.0_omega_prec -  &
      (2.0_omega_prec * sin2thw)) / 4.0_omega_prec) * ((mv_22 *  &
      conjg (mv_22)) - (conjg (mu_22) * mu_22))) + (( &
      (costhw**2) / 2.0_omega_prec) * ((mv_21 * conjg (mv_21)) - ( &
      conjg (mu_21) * mu_21))))
    lcn_11 = ((conjg (mn_12) * mv_11 * sqrt (2.0_omega_prec)) - ( &
      conjg (mn_14) * mv_12))
    rcn_11 = ((mn_12 * conjg (mu_11) * sqrt (2.0_omega_prec)) + (mn_13 *  &
      conjg (mu_12)))
    lnch_11 = (cosbe * ((conjg (mn_14) * conjg (mv_11)) + ((conjg (mv_12) /  &
      sqrt (2.0_omega_prec)) * (conjg (mn_12) + ((sinthw / costhw) *  &
      conjg (mn_11))))))
    rnch_11 = (sinbe * ((mn_13 * mu_11) - ((mu_12 / sqrt (2.0_omega_prec)) *  &
      (mn_12 + ((sinthw / costhw) * mn_11)))))
    lcn_12 = ((conjg (mn_22) * mv_11 * sqrt (2.0_omega_prec)) - ( &
       conjg (mn_24) * mv_12))
    rcn_12 = ((mn_22 * conjg (mu_11) * sqrt (2.0_omega_prec)) + (mn_23 *  &
      conjg (mu_12)))
    lnch_21 = (cosbe * ((conjg (mn_24) * conjg (mv_11)) + ((conjg (mv_12) /  &
      sqrt (2.0_omega_prec)) * (conjg (mn_22) + ((sinthw / costhw) *  &
      conjg (mn_21))))))
    rnch_21 = (sinbe * ((mn_23 * mu_11) - ((mu_12 / sqrt (2.0_omega_prec)) *  &
      (mn_22 + ((sinthw / costhw) * mn_21)))))
    lcn_13 = ((conjg (mn_32) * mv_11 * sqrt (2.0_omega_prec)) - ( &
       conjg (mn_34) * mv_12))
    rcn_13 = ((mn_32 * conjg (mu_11) * sqrt (2.0_omega_prec)) + (mn_33 *  &
      conjg (mu_12)))
    lnch_31 = (cosbe * ((conjg (mn_34) * conjg (mv_11)) + ((conjg (mv_12) /  &
      sqrt (2.0_omega_prec)) * (conjg (mn_32) + ((sinthw / costhw) *  &
      conjg (mn_31))))))
    rnch_31 = (sinbe * ((mn_33 * mu_11) - ((mu_12 / sqrt (2.0_omega_prec)) *  &
      (mn_32 + ((sinthw / costhw) * mn_31)))))
    lcn_14 = ((conjg (mn_42) * mv_11 * sqrt (2.0_omega_prec)) - ( &
       conjg (mn_44) * mv_12))
    rcn_14 = ((mn_42 * conjg (mu_11) * sqrt (2.0_omega_prec)) + (mn_43 *  &
      conjg (mu_12)))
    lnch_41 = (cosbe * ((conjg (mn_44) * conjg (mv_11)) + ((conjg (mv_12) /  &
      sqrt (2.0_omega_prec)) * (conjg (mn_42) + ((sinthw / costhw) *  &
      conjg (mn_41))))))
    rnch_41 = (sinbe * ((mn_43 * mu_11) - ((mu_12 / sqrt (2.0_omega_prec)) *  &
      (mn_42 + ((sinthw / costhw) * mn_41)))))
    lcn_21 = ((conjg (mn_12) * mv_21 * sqrt (2.0_omega_prec)) - ( &
       conjg (mn_14) * mv_22))
    rcn_21 = ((mn_12 * conjg (mu_21) * sqrt (2.0_omega_prec)) + (mn_13 *  &
      conjg (mu_22)))
    lnch_12 = (cosbe * ((conjg (mn_14) * conjg (mv_21)) + ((conjg (mv_22) /  &
      sqrt (2.0_omega_prec)) * (conjg (mn_12) + ((sinthw / costhw) *  &
      conjg (mn_11))))))
 end subroutine setup_parameters8
subroutine setup_parameters9 ()
    rnch_12 = (sinbe * ((mn_13 * mu_21) - ((mu_22 / sqrt (2.0_omega_prec)) *  &
      (mn_12 + ((sinthw / costhw) * mn_11)))))
    lcn_22 = ((conjg (mn_22) * mv_21 * sqrt (2.0_omega_prec)) - ( &
       conjg (mn_24) * mv_22))
    rcn_22 = ((mn_22 * conjg (mu_21) * sqrt (2.0_omega_prec)) + (mn_23 *  &
      conjg (mu_22)))
    lnch_22 = (cosbe * ((conjg (mn_24) * conjg (mv_21)) + ((conjg (mv_22) /  &
      sqrt (2.0_omega_prec)) * (conjg (mn_22) + ((sinthw / costhw) *  &
      conjg (mn_21))))))
    rnch_22 = (sinbe * ((mn_23 * mu_21) - ((mu_22 / sqrt (2.0_omega_prec)) *  &
      (mn_22 + ((sinthw / costhw) * mn_21)))))
    lcn_23 = ((conjg (mn_32) * mv_21 * sqrt (2.0_omega_prec)) - ( &
       conjg (mn_34) * mv_22))
    rcn_23 = ((mn_32 * conjg (mu_21) * sqrt (2.0_omega_prec)) + (mn_33 *  &
      conjg (mu_22)))
    lnch_32 = (cosbe * ((conjg (mn_34) * conjg (mv_21)) + ((conjg (mv_22) /  &
      sqrt (2.0_omega_prec)) * (conjg (mn_32) + ((sinthw / costhw) *  &
      conjg (mn_31))))))
    rnch_32 = (sinbe * ((mn_33 * mu_21) - ((mu_22 / sqrt (2.0_omega_prec)) *  &
      (mn_32 + ((sinthw / costhw) * mn_31)))))
    lcn_24 = ((conjg (mn_42) * mv_21 * sqrt (2.0_omega_prec)) - ( &
       conjg (mn_44) * mv_22))
    rcn_24 = ((mn_42 * conjg (mu_21) * sqrt (2.0_omega_prec)) + (mn_43 *  &
      conjg (mu_22)))
    lnch_42 = (cosbe * ((conjg (mn_44) * conjg (mv_21)) + ((conjg (mv_22) /  &
      sqrt (2.0_omega_prec)) * (conjg (mn_42) + ((sinthw / costhw) *  &
      conjg (mn_41))))))
    rnch_42 = (sinbe * ((mn_43 * mu_21) - ((mu_22 / sqrt (2.0_omega_prec)) *  &
      (mn_42 + ((sinthw / costhw) * mn_41)))))
    lnc_11 = conjg (lcn_11)
    rnc_11 = conjg (rcn_11)
    lnc_12 = conjg (lcn_21)
    rnc_12 = conjg (rcn_21)
    lnc_21 = conjg (lcn_12)
    rnc_21 = conjg (rcn_12)
    lnc_22 = conjg (lcn_22)
    rnc_22 = conjg (rcn_22)
    lnc_31 = conjg (lcn_13)
    rnc_31 = conjg (rcn_13)
    lnc_32 = conjg (lcn_23)
    rnc_32 = conjg (rcn_23)
    lnc_41 = conjg (lcn_14)
    rnc_41 = conjg (rcn_14)
    lnc_42 = conjg (lcn_24)
    rnc_42 = conjg (rcn_24)
    gnzn_1_1 = (gz * a0_11)
    gnzn_2_2 = (gz * a0_22)
    gnzn_3_3 = (gz * a0_33)
    gnzn_4_4 = (gz * a0_44)
    dummy1 = ( - gs)
    g_h1111susu = (gz * mass(23) * ((1.0_omega_prec / 2.0_omega_prec) -  &
      (sin2thw * q_up)) * sinapb)
    g_h1122susu = (gz * mass(23) *  q_up * sinapb * sin2thw)
    g_h1111sdsd = (gz * mass(23) * (( - (1.0_omega_prec / 2.0_omega_prec)) -  &
      (sin2thw * q_down)) * sinapb)
    g_h1122sdsd = (gz * mass(23) * q_down * sinapb * sin2thw)
    g_h2111susu = ( - (gz * mass(23) * ((1.0_omega_prec / 2.0_omega_prec) -  &
      (sin2thw * q_up)) * cosapb))
    g_h2122susu = ( - gz * mass(23) * q_up * cosapb * sin2thw) 
    g_h2111sdsd = ( - (gz * mass(23) * (( - (1.0_omega_prec / 2.0_omega_prec)) -  &
      (sin2thw * q_down)) * cosapb)) 
    g_h2122sdsd = ( - gz * mass(23) * q_down * cosapb * sin2thw)
    !!! g_h3112susu = (imago * ((g * mass(2) * (( &
    !!!   conjg (( - au_1)) * cosbe) + (mu * sinbe))) /  &
    !!!   (2.0_omega_prec * mass(24) * sinbe)))
    !!! g_h3121susu = conjg (g_h3112susu)
    !!! g_h3112sdsd = (imago * ((g * mass(1) * (( &
    !!!   conjg (( - ad_1)) * tanb) + mu)) / (2.0_omega_prec * mass(24))))
    !!! g_h3121sdsd = conjg (g_h3112sdsd)
    g_h1111snsn = (gz * mass(23) * ((1.0_omega_prec / 2.0_omega_prec) -  &
      (sin2thw * 0.0_omega_prec)) * sinapb)
    g_h1111slsl = (gz * mass(23) * (( - (1.0_omega_prec / 2.0_omega_prec)) -  &
      (sin2thw * ( - 1.0_omega_prec))) * sinapb) 
    g_h1122slsl = (gz * mass(23) * ( - 1.0_omega_prec) * sinapb * sin2thw) 
    g_h2111snsn = ( - (gz * mass(23) * ((1.0_omega_prec / 2.0_omega_prec) -  &
      (sin2thw * 0.0_omega_prec)) * cosapb))
    g_h2111slsl = ( - (gz * mass(23) * (( - (1.0_omega_prec / 2.0_omega_prec)) -  &
      (sin2thw * ( - 1.0_omega_prec))) * cosapb))
    g_h2122slsl = ( - (gz * mass(23) * ( - 1.0_omega_prec) * cosapb * sin2thw)) 
    !!! g_h3112slsl = (imago * ((g * mass(11) * (( &
    !!!   conjg (( - al_1)) * tanb) + mu)) / (2.0_omega_prec * mass(24))))
    !!! g_h3121slsl = conjg (g_h3112slsl)
    g_h4111slsn = ((g / (sqrt (2.0_omega_prec) * mass(24))) * (mass(24)**2) * sin2be)
    !!! g_h4112slsn = (sqrt (2.0_omega_prec) * ((g * mass(11) * ((conjg ( &
    !!!   ( - al_1)) * sinbe) + (mu * cosbe))) /  &
    !!!   (2.0_omega_prec * mass(24) * cosbe)))
    g_h1211susu = (gz * mass(23) * ((1.0_omega_prec / 2.0_omega_prec) -  &
      (sin2thw * q_up)) * sinapb)
    g_h1222susu = (gz * mass(23) * q_up * sinapb * sin2thw)
    g_h1211sdsd = (gz * mass(23) * (( - (1.0_omega_prec / 2.0_omega_prec)) -  &
      (sin2thw * q_down)) * sinapb)
    g_h1222sdsd = (gz * mass(23) * q_down * sinapb * sin2thw)
    g_h2211susu = ( - (gz * mass(23) * ((1.0_omega_prec / 2.0_omega_prec) -  &
      (sin2thw * q_up)) * cosapb))
    g_h2222susu = ( - gz * mass(23) * q_up * cosapb * sin2thw)
end subroutine setup_parameters9
 subroutine setup_parameters10 ()
    g_h2211sdsd = ( - (gz * mass(23) * (( - (1.0_omega_prec / 2.0_omega_prec)) -  &
      (sin2thw * q_down)) * cosapb))
    g_h2222sdsd = ( - gz * mass(23) * q_down * cosapb * sin2thw) 
    !!! g_h3212susu = (imago * ((g * mass(4) * (( &
    !!!   conjg (( - au_2)) * cosbe) + (mu * sinbe))) /  &
    !!!   (2.0_omega_prec * mass(24) * sinbe)))
    !!! g_h3221susu = conjg (g_h3212susu)
    !!! g_h3212sdsd = (imago * ((g * mass(3) * (( &
    !!!   conjg (( - ad_2)) * sinbe) + (mu * cosbe))) /  &
    !!!   (2.0_omega_prec * mass(24) * cosbe)))
    !!! g_h3221sdsd = conjg (g_h3212sdsd)
    g_h1211snsn = (gz * mass(23) * ((1.0_omega_prec / 2.0_omega_prec) -  &
      (sin2thw * 0.0_omega_prec)) * sinapb)
    g_h1211slsl = (gz * mass(23) * (( - (1.0_omega_prec / 2.0_omega_prec)) -  &
      (sin2thw * ( - 1.0_omega_prec))) * sinapb)
    g_h1222slsl = (gz * mass(23) * ( - 1.0_omega_prec) * sinapb * sin2thw)
    g_h2211snsn = ( - (gz * mass(23) * ((1.0_omega_prec / 2.0_omega_prec) -  &
      (sin2thw * 0.0_omega_prec)) * cosapb))
    g_h2211slsl = ( - (gz * mass(23) * (( - (1.0_omega_prec / 2.0_omega_prec)) -  &
      (sin2thw * ( - 1.0_omega_prec))) * cosapb))
    g_h2222slsl = ( - (gz * mass(23) * ( - 1.0_omega_prec) * cosapb * sin2thw))
    !!! g_h3212slsl = (imago * ((g * mass(13) * (( &
    !!!   conjg (( - al_2)) * sinbe) + (mu * cosbe))) /  &
    !!!   (2.0_omega_prec * mass(24) * cosbe)))
    !!! g_h3221slsl = conjg (g_h3212slsl)
    g_h4211slsn = ((g / (sqrt (2.0_omega_prec) * mass(24))) * (mass(24)**2) * sin2be)
    !!! g_h4212slsn = (sqrt (2.0_omega_prec) * ((g * mass(13) * ((conjg ( &
    !!!   ( - al_2)) * sinbe) + (mu * cosbe))) /  &
    !!!   (2.0_omega_prec * mass(24) * cosbe)))
    g_h1311susu = ((gz * mass(23) * ((1.0_omega_prec / 2.0_omega_prec) -  &
      (sin2thw * q_up)) * sinapb) - ((g *  &
      (mass(6)**2) * cosal) / (mass(24) * sinbe)))
    g_h1322susu = ((gz * mass(23) * q_up * sinapb * sin2thw) - ((g *  &
      (mass(6)**2) * cosal) / (mass(24) * sinbe)))
    g_h1312susu = ((g * mass(6) * ((conjg (au_3) * cosal) + (  &
      ( - mu) * sinal))) / (2.0_omega_prec * mass(24) * sinbe))
    g_h1321susu = conjg (g_h1312susu)
    g_h1311sdsd = ((gz * mass(23) * (( - (1.0_omega_prec / 2.0_omega_prec)) -  &
      (sin2thw * q_down)) * sinapb) + ((g *  &
      (mass(5)**2) * sinal) / (mass(24) * cosbe)))
    g_h1322sdsd = ((gz * mass(23) * q_down * sinapb * sin2thw) + ((g *  &
      (mass(5)**2) * sinal) / (mass(24) * cosbe)))
    g_h1312sdsd = ((g * mass(5) * ((conjg (( - ad_3)) * sinal) + ( &
       mu * cosal))) / (2.0_omega_prec * mass(24) * cosbe))
    g_h1321sdsd = conjg (g_h1312sdsd)
    g_h2311susu = ( - ((gz * mass(23) * ((1.0_omega_prec / 2.0_omega_prec) -  &
      (sin2thw * q_up)) * cosapb) + ((g *  &
      (mass(6)**2) * sinal) / (mass(24) * sinbe))))
    g_h2322susu = ( - ((gz * mass(23) * q_up * cosapb * sin2thw) + ((g *  &
      (mass(6)**2) * sinal) / (mass(24) * sinbe))))
    g_h2312susu = ((g * mass(6) * ((conjg (au_3) * sinal) + ( &
       mu * cosal))) / (2.0_omega_prec * mass(24) * sinbe))
    g_h2321susu = conjg (g_h2312susu)
    g_h2311sdsd = ( - ((gz * mass(23) * (( - (1.0_omega_prec / 2.0_omega_prec)) -  &
      (sin2thw * q_down)) * cosapb) + ((g *  &
      (mass(5)**2) * cosal) / (mass(24) * cosbe))))
    g_h2322sdsd = ( - ((gz * mass(23) * q_down * cosapb * sin2thw) + ((g *  &
      (mass(5)**2) * cosal) / (mass(24) * cosbe))))
    g_h2312sdsd = ((g * mass(5) * ((conjg (ad_3) * cosal) + ( &
       mu * sinal))) / (2.0_omega_prec * mass(24) * cosbe))
    g_h2321sdsd = conjg (g_h2312sdsd)
    g_h3312susu = (imago * ((g * mass(6) * (( &
      conjg (( - au_3)) * cosbe) + (mu * sinbe))) /  &
      (2.0_omega_prec * mass(24) * sinbe)))
    g_h3321susu = conjg (g_h3312susu)
    g_h3312sdsd = (imago * ((g * mass(5) * (( &
      conjg (( - ad_3)) * sinbe) + (mu * cosbe))) /  &
      (2.0_omega_prec * mass(24) * cosbe)))
    g_h3321sdsd = conjg (g_h3312sdsd)
    g_h1311snsn = (gz * mass(23) * ((1.0_omega_prec / 2.0_omega_prec) -  &
      (sin2thw * 0.0_omega_prec)) * sinapb)
    g_h1311slsl = ((gz * mass(23) * (( - (1.0_omega_prec / 2.0_omega_prec)) -  &
      (sin2thw * ( - 1.0_omega_prec))) * sinapb) + ((g *  &
      (mass(15)**2) * sinal) / (mass(24) * cosbe)))
    g_h1322slsl = ((gz * mass(23) * ( - 1.0_omega_prec) * sinapb * sin2thw) + ( &
      (g * (mass(15)**2) * sinal) / (mass(24) * cosbe)))
    g_h1312slsl = ((g * mass(15) * ((conjg (( - al_3)) * sinal) + ( &
       mu * cosal))) / (2.0_omega_prec * mass(24) * cosbe))
    g_h1321slsl = conjg (g_h1312slsl)
    g_h2311snsn = ( - (gz * mass(23) * ((1.0_omega_prec / 2.0_omega_prec) -  &
      (sin2thw * 0.0_omega_prec)) * cosapb))
    g_h2311slsl = ( - ((gz * mass(23) * (( - (1.0_omega_prec / 2.0_omega_prec)) -  &
      (sin2thw * ( - 1.0_omega_prec))) * cosapb) + ((g *  &
      (mass(15)**2) * cosal) / (mass(24) * cosbe))))
    g_h2322slsl = ( - ((gz * mass(23) * ( - 1.0_omega_prec) * cosapb * sin2thw) + ( &
      (g * (mass(15)**2) * cosal) / (mass(24) * cosbe))))
    g_h2312slsl = ((g * mass(15) * ((conjg (al_3) * cosal) + ( &
       mu * sinal))) / (2.0_omega_prec * mass(24) * cosbe))
    g_h2321slsl = conjg (g_h2312slsl)
    g_h3312slsl = (imago * ((g * mass(15) * (( &
      conjg (( - al_3)) * sinbe) + (mu * cosbe))) /  &
      (2.0_omega_prec * mass(24) * cosbe)))
    g_h3321slsl = conjg (g_h3312slsl)
    g_h4311slsn = ((g / (sqrt (2.0_omega_prec) * mass(24))) * (( &
      (mass(15)**2) * tanb) - ((mass(24)**2) * sin2be)))
    g_h4312slsn = (sqrt (2.0_omega_prec) * ((g * mass(15) * ((conjg ( &
      ( - al_3)) * sinbe) + (mu * cosbe))) /  &
      (2.0_omega_prec * mass(24) * cosbe)))
    g_h41_111susd = ((g / (sqrt (2.0_omega_prec) * mass(24))) * vckm_11 * ( - ( &
      (mass(24)**2) * sin2be)))
    g_h41_211susd = ((g / (sqrt (2.0_omega_prec) * mass(24))) * vckm_12 * ( - ( &
      (mass(24)**2) * sin2be)))
    g_h41_311susd = ((g / (sqrt (2.0_omega_prec) * mass(24))) * vckm_13 * (( - ( &
      (mass(24)**2) * sin2be)) + (((mass(5)**2) * tanb) + ((mass(2)**2) / tanb))))
    g_h41_322susd = ((sqrt (2.0_omega_prec) * g * mass(2) * mass(5) * vckm_13) /  &
      (mass(24) * sin2be))
    g_h41_312susd = (((g * mass(5)) / ( &
      sqrt (2.0_omega_prec) * mass(24))) * vckm_13 * (mu - ( &
      conjg (ad_3) * tanb)))
    g_h41_321susd = (((g * mass(2)) / ( &
      sqrt (2.0_omega_prec) * mass(24))) * vckm_13 * (conjg (mu) -  &
      (au_1 / tanb)))
    g_h42_111susd = ((g / (sqrt (2.0_omega_prec) * mass(24))) * vckm_21 * ( - ( &
      (mass(24)**2) * sin2be)))
    g_h42_211susd = ((g / (sqrt (2.0_omega_prec) * mass(24))) * vckm_22 * ( - ( &
      (mass(24)**2) * sin2be)))
    g_h42_311susd = ((g / (sqrt (2.0_omega_prec) * mass(24))) * vckm_23 * (( - ( &
      (mass(24)**2) * sin2be)) + (((mass(5)**2) * tanb) + ((mass(4)**2) / tanb))))
    g_h42_322susd = ((sqrt (2.0_omega_prec) * g * mass(4) * mass(5) * vckm_23) /  &
      (mass(24) * sin2be))
    g_h42_312susd = (((g * mass(5)) / ( &
      sqrt (2.0_omega_prec) * mass(24))) * vckm_23 * (mu - ( &
      conjg (ad_3) * tanb)))
    g_h42_321susd = (((g * mass(4)) / ( &
      sqrt (2.0_omega_prec) * mass(24))) * vckm_23 * (conjg (mu) -  &
      (au_2 / tanb)))
    g_h43_111susd = ((g / (sqrt (2.0_omega_prec) * mass(24))) * vckm_31 * (( - ( &
      (mass(24)**2) * sin2be)) + (((mass(1)**2) * tanb) + ((mass(6)**2) / tanb))))
    g_h43_122susd = ((sqrt (2.0_omega_prec) * g * mass(6) * mass(1) * vckm_31) /  &
      (mass(24) * sin2be))
    g_h43_112susd = (((g * mass(1)) / ( &
      sqrt (2.0_omega_prec) * mass(24))) * vckm_31 * (mu - ( &
      conjg (ad_1) * tanb)))
    g_h43_121susd = (((g * mass(6)) / ( &
      sqrt (2.0_omega_prec) * mass(24))) * vckm_31 * (conjg (mu) -  &
      (au_3 / tanb)))
    g_h43_211susd = ((g / (sqrt (2.0_omega_prec) * mass(24))) * vckm_32 * (( - ( &
      (mass(24)**2) * sin2be)) + (((mass(3)**2) * tanb) + ((mass(6)**2) / tanb))))
    g_h43_222susd = ((sqrt (2.0_omega_prec) * g * mass(6) * mass(3) * vckm_32) /  &
      (mass(24) * sin2be))
    g_h43_212susd = (((g * mass(3)) / ( &
      sqrt (2.0_omega_prec) * mass(24))) * vckm_32 * (mu - ( &
      conjg (ad_2) * tanb)))
    g_h43_221susd = (((g * mass(6)) / ( &
      sqrt (2.0_omega_prec) * mass(24))) * vckm_32 * (conjg (mu) -  &
      (au_3 / tanb)))
    g_h43_311susd = ((g / (sqrt (2.0_omega_prec) * mass(24))) * vckm_33 * (( - ( &
      (mass(24)**2) * sin2be)) + (((mass(5)**2) * tanb) + ((mass(6)**2) / tanb))))
    g_h43_322susd = ((sqrt (2.0_omega_prec) * g * mass(6) * mass(5) * vckm_33) /  &
      (mass(24) * sin2be))
    g_h43_312susd = (((g * mass(5)) / ( &
      sqrt (2.0_omega_prec) * mass(24))) * vckm_33 * (mu - ( &
      conjg (ad_3) * tanb)))
    g_h43_321susd = (((g * mass(6)) / ( &
      sqrt (2.0_omega_prec) * mass(24))) * vckm_33 * (conjg (mu) -  &
      (au_3 / tanb)))
 end subroutine setup_parameters10
 subroutine setup_parameters11 ()
    gh1sl1sl1_1 = g_h1111slsl
    gh1su1su1_1 = g_h1111susu
    gh1sd1sd1_1 = g_h1111sdsd
    gh2sl1sl1_1 = g_h2111slsl
    gh2su1su1_1 = g_h2111susu
    gh2sd1sd1_1 = g_h2111sdsd
    !!! gasl1sl1_1 = ((conjg (mix_sl111) * mix_sl112 * g_h3112slsl) + ( &
    !!!   conjg (mix_sl112) * mix_sl111 * g_h3121slsl))
    !!! gasu1su1_1 = ((conjg (mix_su111) * mix_su112 * g_h3112susu) + ( &
    !!!   conjg (mix_su112) * mix_su111 * g_h3121susu))
    !!! gasd1sd1_1 = ((conjg (mix_sd111) * mix_sd112 * g_h3112sdsd) + ( &
    !!!   conjg (mix_sd112) * mix_sd111 * g_h3121sdsd))
    !!! gasl1sl2_1 = ((conjg (mix_sl111) * mix_sl122 * g_h3112slsl) + ( &
    !!!   conjg (mix_sl112) * mix_sl121 * g_h3121slsl))
    !!! gasu1su2_1 = ((conjg (mix_su111) * mix_su122 * g_h3112susu) + ( &
    !!!   conjg (mix_su112) * mix_su121 * g_h3121susu))
    !!! gasd1sd2_1 = ((conjg (mix_sd111) * mix_sd122 * g_h3112sdsd) + ( &
    !!!   conjg (mix_sd112) * mix_sd121 * g_h3121sdsd))
    !!! gasl2sl1_1 = ((conjg (mix_sl121) * mix_sl112 * g_h3112slsl) + ( &
    !!!   conjg (mix_sl122) * mix_sl111 * g_h3121slsl))
    !!! gasu2su1_1 = ((conjg (mix_su121) * mix_su112 * g_h3112susu) + ( &
    !!!   conjg (mix_su122) * mix_su111 * g_h3121susu))
    !!! gasd2sd1_1 = ((conjg (mix_sd121) * mix_sd112 * g_h3112sdsd) + ( &
    !!!   conjg (mix_sd122) * mix_sd111 * g_h3121sdsd))
    gh1sl2sl2_1 = g_h1122slsl
    gh1su2su2_1 = g_h1122susu
    gh1sd2sd2_1 = g_h1122sdsd
    gh2sl2sl2_1 = g_h2122slsl
    gh2su2su2_1 = g_h2122susu
    gh2sd2sd2_1 = g_h2122sdsd
    !!! gasl2sl2_1 = ((conjg (mix_sl121) * mix_sl122 * g_h3112slsl) + ( &
    !!!   conjg (mix_sl122) * mix_sl121 * g_h3121slsl))
    !!! gasu2su2_1 = ((conjg (mix_su121) * mix_su122 * g_h3112susu) + ( &
    !!!   conjg (mix_su122) * mix_su121 * g_h3121susu))
    !!! gasd2sd2_1 = ((conjg (mix_sd121) * mix_sd122 * g_h3112sdsd) + ( &
    !!!   conjg (mix_sd122) * mix_sd121 * g_h3121sdsd))
    !!! ghsnsl1_1 = g_h4111slsn
    !!! ghsnsl1_1 = ((conjg (mix_sl111) * g_h4111slsn) + ( &
    !!!   conjg (mix_sl112) * g_h4112slsn))
    !!! ghsnsl1_1_c = conjg (ghsnsl1_1)
    ghsnsl1_1 = g_h4111slsn
    !!! ghsnsl2_1 = ((conjg (mix_sl121) * g_h4111slsn) + ( &
    !!!   conjg (mix_sl122) * g_h4112slsn))
    ghsnsl1_1_c = conjg (ghsnsl1_1)
    gh1sn1sn1_1 = g_h1111snsn
    gh2sn1sn1_1 = g_h2111snsn
    gh1sl1sl1_2 = g_h1211slsl
    gh1su1su1_2 = g_h1211susu
    gh1sd1sd1_2 = g_h1211sdsd
    gh2sl1sl1_2 = g_h2211slsl
    gh2su1su1_2 = g_h2211susu
    gh2sd1sd1_2 = g_h2211sdsd
    !!! gasl1sl1_2 = ((conjg (mix_sl211) * mix_sl212 * g_h3212slsl) + ( &
    !!!   conjg (mix_sl212) * mix_sl211 * g_h3221slsl))
    !!! gasu1su1_2 = ((conjg (mix_su211) * mix_su212 * g_h3212susu) + ( &
    !!!   conjg (mix_su212) * mix_su211 * g_h3221susu))
    !!! gasd1sd1_2 = ((conjg (mix_sd211) * mix_sd212 * g_h3212sdsd) + ( &
    !!!   conjg (mix_sd212) * mix_sd211 * g_h3221sdsd))
    !!! gasl1sl2_2 = ((conjg (mix_sl211) * mix_sl222 * g_h3212slsl) + ( &
    !!!   conjg (mix_sl212) * mix_sl221 * g_h3221slsl))
    !!! gasu1su2_2 = ((conjg (mix_su211) * mix_su222 * g_h3212susu) + ( &
    !!!   conjg (mix_su212) * mix_su221 * g_h3221susu))
    !!! gasd1sd2_2 = ((conjg (mix_sd211) * mix_sd222 * g_h3212sdsd) + ( &
    !!!   conjg (mix_sd212) * mix_sd221 * g_h3221sdsd))
    !!! gasl2sl1_2 = ((conjg (mix_sl221) * mix_sl212 * g_h3212slsl) + ( &
    !!!   conjg (mix_sl222) * mix_sl211 * g_h3221slsl))
    !!! gasu2su1_2 = ((conjg (mix_su221) * mix_su212 * g_h3212susu) + ( &
    !!!   conjg (mix_su222) * mix_su211 * g_h3221susu))
    !!! gasd2sd1_2 = ((conjg (mix_sd221) * mix_sd212 * g_h3212sdsd) + ( &
    !!!   conjg (mix_sd222) * mix_sd211 * g_h3221sdsd))
    gh1sl2sl2_2 = g_h1222slsl
    gh1su2su2_2 = g_h1222susu
    gh1sd2sd2_2 = g_h1222sdsd
    gh2sl2sl2_2 = g_h2222slsl
    gh2su2su2_2 = g_h2222susu
    gh2sd2sd2_2 = g_h2222sdsd
    !!! gasl2sl2_2 = ((conjg (mix_sl221) * mix_sl222 * g_h3212slsl) + ( &
    !!!   conjg (mix_sl222) * mix_sl221 * g_h3221slsl))
    !!! gasu2su2_2 = ((conjg (mix_su221) * mix_su222 * g_h3212susu) + ( &
    !!!   conjg (mix_su222) * mix_su221 * g_h3221susu))
    !!! gasd2sd2_2 = ((conjg (mix_sd221) * mix_sd222 * g_h3212sdsd) + ( &
    !!!   conjg (mix_sd222) * mix_sd221 * g_h3221sdsd))
    ghsnsl1_2 = g_h4211slsn
    !!! ghsnsl1_2 = ((conjg (mix_sl211) * g_h4211slsn) + ( &
    !!!   conjg (mix_sl212) * g_h4212slsn))
    ghsnsl1_2_c = conjg (ghsnsl1_2)
    !!! ghsnsl2_2 = g_h4211slsn
    !!! ghsnsl2_2 = ((conjg (mix_sl221) * g_h4211slsn) + ( &
    !!!   conjg (mix_sl222) * g_h4212slsn))
    !!! ghsnsl2_2_c = conjg (ghsnsl2_2)
    gh1sn1sn1_2 = g_h1211snsn
    gh2sn1sn1_2 = g_h2211snsn
    gh1sl1sl1_3 = ((conjg (mix_sl311) * mix_sl311 * g_h1311slsl) + ( &
      conjg (mix_sl312) * mix_sl312 * g_h1322slsl) + ( &
      conjg (mix_sl311) * mix_sl312 * g_h1312slsl) + ( &
      conjg (mix_sl312) * mix_sl311 * g_h1321slsl))
    gh1su1su1_3 = ((conjg (mix_su311) * mix_su311 * g_h1311susu) + ( &
      conjg (mix_su312) * mix_su312 * g_h1322susu) + ( &
      conjg (mix_su311) * mix_su312 * g_h1312susu) + ( &
      conjg (mix_su312) * mix_su311 * g_h1321susu))
    gh1sd1sd1_3 = ((conjg (mix_sd311) * mix_sd311 * g_h1311sdsd) + ( &
      conjg (mix_sd312) * mix_sd312 * g_h1322sdsd) + ( &
      conjg (mix_sd311) * mix_sd312 * g_h1312sdsd) + ( &
      conjg (mix_sd312) * mix_sd311 * g_h1321sdsd))
    gh2sl1sl1_3 = ((conjg (mix_sl311) * mix_sl311 * g_h2311slsl) + ( &
      conjg (mix_sl312) * mix_sl312 * g_h2322slsl) + ( &
      conjg (mix_sl311) * mix_sl312 * g_h2312slsl) + ( &
      conjg (mix_sl312) * mix_sl311 * g_h2321slsl))
    gh2su1su1_3 = ((conjg (mix_su311) * mix_su311 * g_h2311susu) + ( &
      conjg (mix_su312) * mix_su312 * g_h2322susu) + ( &
      conjg (mix_su311) * mix_su312 * g_h2312susu) + ( &
      conjg (mix_su312) * mix_su311 * g_h2321susu))
    gh2sd1sd1_3 = ((conjg (mix_sd311) * mix_sd311 * g_h2311sdsd) + ( &
      conjg (mix_sd312) * mix_sd312 * g_h2322sdsd) + ( &
      conjg (mix_sd311) * mix_sd312 * g_h2312sdsd) + ( &
      conjg (mix_sd312) * mix_sd311 * g_h2321sdsd))
    gasl1sl1_3 = ((conjg (mix_sl311) * mix_sl312 * g_h3312slsl) + ( &
      conjg (mix_sl312) * mix_sl311 * g_h3321slsl))
    gasu1su1_3 = ((conjg (mix_su311) * mix_su312 * g_h3312susu) + ( &
      conjg (mix_su312) * mix_su311 * g_h3321susu))
    gasd1sd1_3 = ((conjg (mix_sd311) * mix_sd312 * g_h3312sdsd) + ( &
      conjg (mix_sd312) * mix_sd311 * g_h3321sdsd))
    gh1sl1sl2_3 = ((conjg (mix_sl311) * mix_sl321 * g_h1311slsl) + ( &
      conjg (mix_sl312) * mix_sl322 * g_h1322slsl) + ( &
      conjg (mix_sl311) * mix_sl322 * g_h1312slsl) + ( &
      conjg (mix_sl312) * mix_sl321 * g_h1321slsl))
    gh1su1su2_3 = ((conjg (mix_su311) * mix_su321 * g_h1311susu) + ( &
      conjg (mix_su312) * mix_su322 * g_h1322susu) + ( &
      conjg (mix_su311) * mix_su322 * g_h1312susu) + ( &
      conjg (mix_su312) * mix_su321 * g_h1321susu))
    gh1sd1sd2_3 = ((conjg (mix_sd311) * mix_sd321 * g_h1311sdsd) + ( &
      conjg (mix_sd312) * mix_sd322 * g_h1322sdsd) + ( &
      conjg (mix_sd311) * mix_sd322 * g_h1312sdsd) + ( &
      conjg (mix_sd312) * mix_sd321 * g_h1321sdsd))
    gh2sl1sl2_3 = ((conjg (mix_sl311) * mix_sl321 * g_h2311slsl) + ( &
      conjg (mix_sl312) * mix_sl322 * g_h2322slsl) + ( &
      conjg (mix_sl311) * mix_sl322 * g_h2312slsl) + ( &
      conjg (mix_sl312) * mix_sl321 * g_h2321slsl))
    gh2su1su2_3 = ((conjg (mix_su311) * mix_su321 * g_h2311susu) + ( &
      conjg (mix_su312) * mix_su322 * g_h2322susu) + ( &
      conjg (mix_su311) * mix_su322 * g_h2312susu) + ( &
      conjg (mix_su312) * mix_su321 * g_h2321susu))
    gh2sd1sd2_3 = ((conjg (mix_sd311) * mix_sd321 * g_h2311sdsd) + ( &
      conjg (mix_sd312) * mix_sd322 * g_h2322sdsd) + ( &
      conjg (mix_sd311) * mix_sd322 * g_h2312sdsd) + ( &
      conjg (mix_sd312) * mix_sd321 * g_h2321sdsd))
    gasl1sl2_3 = ((conjg (mix_sl311) * mix_sl322 * g_h3312slsl) + ( &
      conjg (mix_sl312) * mix_sl321 * g_h3321slsl))
    gasu1su2_3 = ((conjg (mix_su311) * mix_su322 * g_h3312susu) + ( &
      conjg (mix_su312) * mix_su321 * g_h3321susu))
    gasd1sd2_3 = ((conjg (mix_sd311) * mix_sd322 * g_h3312sdsd) + ( &
      conjg (mix_sd312) * mix_sd321 * g_h3321sdsd))
    gh1sl2sl1_3 = ((conjg (mix_sl321) * mix_sl311 * g_h1311slsl) + ( &
      conjg (mix_sl322) * mix_sl312 * g_h1322slsl) + ( &
      conjg (mix_sl321) * mix_sl312 * g_h1312slsl) + ( &
      conjg (mix_sl322) * mix_sl311 * g_h1321slsl))
    gh1su2su1_3 = ((conjg (mix_su321) * mix_su311 * g_h1311susu) + ( &
      conjg (mix_su322) * mix_su312 * g_h1322susu) + ( &
      conjg (mix_su321) * mix_su312 * g_h1312susu) + ( &
      conjg (mix_su322) * mix_su311 * g_h1321susu))
    gh1sd2sd1_3 = ((conjg (mix_sd321) * mix_sd311 * g_h1311sdsd) + ( &
      conjg (mix_sd322) * mix_sd312 * g_h1322sdsd) + ( &
      conjg (mix_sd321) * mix_sd312 * g_h1312sdsd) + ( &
      conjg (mix_sd322) * mix_sd311 * g_h1321sdsd))
    gh2sl2sl1_3 = ((conjg (mix_sl321) * mix_sl311 * g_h2311slsl) + ( &
      conjg (mix_sl322) * mix_sl312 * g_h2322slsl) + ( &
      conjg (mix_sl321) * mix_sl312 * g_h2312slsl) + ( &
      conjg (mix_sl322) * mix_sl311 * g_h2321slsl))
    gh2su2su1_3 = ((conjg (mix_su321) * mix_su311 * g_h2311susu) + ( &
      conjg (mix_su322) * mix_su312 * g_h2322susu) + ( &
      conjg (mix_su321) * mix_su312 * g_h2312susu) + ( &
      conjg (mix_su322) * mix_su311 * g_h2321susu))
    gh2sd2sd1_3 = ((conjg (mix_sd321) * mix_sd311 * g_h2311sdsd) + ( &
      conjg (mix_sd322) * mix_sd312 * g_h2322sdsd) + ( &
      conjg (mix_sd321) * mix_sd312 * g_h2312sdsd) + ( &
      conjg (mix_sd322) * mix_sd311 * g_h2321sdsd))
    gasl2sl1_3 = ((conjg (mix_sl321) * mix_sl312 * g_h3312slsl) + ( &
      conjg (mix_sl322) * mix_sl311 * g_h3321slsl))
 end subroutine setup_parameters11
subroutine setup_parameters12 ()
    gasu2su1_3 = ((conjg (mix_su321) * mix_su312 * g_h3312susu) + ( &
      conjg (mix_su322) * mix_su311 * g_h3321susu))
    gasd2sd1_3 = ((conjg (mix_sd321) * mix_sd312 * g_h3312sdsd) + ( &
      conjg (mix_sd322) * mix_sd311 * g_h3321sdsd))
    gh1sl2sl2_3 = ((conjg (mix_sl321) * mix_sl321 * g_h1311slsl) + ( &
      conjg (mix_sl322) * mix_sl322 * g_h1322slsl) + ( &
      conjg (mix_sl321) * mix_sl322 * g_h1312slsl) + ( &
      conjg (mix_sl322) * mix_sl321 * g_h1321slsl))
    gh1su2su2_3 = ((conjg (mix_su321) * mix_su321 * g_h1311susu) + ( &
      conjg (mix_su322) * mix_su322 * g_h1322susu) + ( &
      conjg (mix_su321) * mix_su322 * g_h1312susu) + ( &
      conjg (mix_su322) * mix_su321 * g_h1321susu))
    gh1sd2sd2_3 = ((conjg (mix_sd321) * mix_sd321 * g_h1311sdsd) + ( &
      conjg (mix_sd322) * mix_sd322 * g_h1322sdsd) + ( &
      conjg (mix_sd321) * mix_sd322 * g_h1312sdsd) + ( &
      conjg (mix_sd322) * mix_sd321 * g_h1321sdsd))
    gh2sl2sl2_3 = ((conjg (mix_sl321) * mix_sl321 * g_h2311slsl) + ( &
      conjg (mix_sl322) * mix_sl322 * g_h2322slsl) + ( &
      conjg (mix_sl321) * mix_sl322 * g_h2312slsl) + ( &
      conjg (mix_sl322) * mix_sl321 * g_h2321slsl))
    gh2su2su2_3 = ((conjg (mix_su321) * mix_su321 * g_h2311susu) + ( &
      conjg (mix_su322) * mix_su322 * g_h2322susu) + ( &
      conjg (mix_su321) * mix_su322 * g_h2312susu) + ( &
      conjg (mix_su322) * mix_su321 * g_h2321susu))
    gh2sd2sd2_3 = ((conjg (mix_sd321) * mix_sd321 * g_h2311sdsd) + ( &
      conjg (mix_sd322) * mix_sd322 * g_h2322sdsd) + ( &
      conjg (mix_sd321) * mix_sd322 * g_h2312sdsd) + ( &
      conjg (mix_sd322) * mix_sd321 * g_h2321sdsd))
    gasl2sl2_3 = ((conjg (mix_sl321) * mix_sl322 * g_h3312slsl) + ( &
      conjg (mix_sl322) * mix_sl321 * g_h3321slsl))
    gasu2su2_3 = ((conjg (mix_su321) * mix_su322 * g_h3312susu) + ( &
      conjg (mix_su322) * mix_su321 * g_h3321susu))
    gasd2sd2_3 = ((conjg (mix_sd321) * mix_sd322 * g_h3312sdsd) + ( &
      conjg (mix_sd322) * mix_sd321 * g_h3321sdsd))
    ghsnsl1_3 = ((conjg (mix_sl311) * g_h4311slsn) + ( &
      conjg (mix_sl312) * g_h4312slsn))
    ghsnsl1_3_c = conjg (ghsnsl1_3)
    ghsnsl2_3 = ((conjg (mix_sl321) * g_h4311slsn) + ( &
      conjg (mix_sl322) * g_h4312slsn))
    ghsnsl2_3_c = conjg (ghsnsl2_3)
    gh1sn1sn1_3 = g_h1311snsn
    gh2sn1sn1_3 = g_h2311snsn
    ghsu1sd1_1_1 = g_h41_111susd
    ghsu1sd1_1_1_c = conjg (ghsu1sd1_1_1)
    ghsu1sd1_1_2 = g_h41_211susd
    ghsu1sd1_1_2_c = conjg (ghsu1sd1_1_2)
    ghsu1sd1_1_3 = ((conjg (mix_su111) * mix_sd311 * g_h41_311susd) + ( &
      conjg (mix_su112) * mix_sd312 * g_h41_322susd) + ( &
      conjg (mix_su111) * mix_sd312 * g_h41_312susd) + ( &
      conjg (mix_su112) * mix_sd311 * g_h41_321susd))
    ghsu1sd1_1_3_c = conjg (ghsu1sd1_1_3)
    ghsu1sd2_1_3 = ((conjg (mix_su111) * mix_sd321 * g_h41_311susd) + ( &
      conjg (mix_su112) * mix_sd322 * g_h41_322susd) + ( &
      conjg (mix_su111) * mix_sd322 * g_h41_312susd) + ( &
      conjg (mix_su112) * mix_sd321 * g_h41_321susd))
    ghsu1sd2_1_3_c = conjg (ghsu1sd2_1_3)
    ghsu2sd1_1_3 = ((conjg (mix_su121) * mix_sd311 * g_h41_311susd) + ( &
      conjg (mix_su122) * mix_sd312 * g_h41_322susd) + ( &
      conjg (mix_su121) * mix_sd312 * g_h41_312susd) + ( &
      conjg (mix_su122) * mix_sd311 * g_h41_321susd))
    ghsu2sd1_1_3_c = conjg (ghsu2sd1_1_3)
    ghsu2sd2_1_3 = ((conjg (mix_su121) * mix_sd321 * g_h41_311susd) + ( &
      conjg (mix_su122) * mix_sd322 * g_h41_322susd) + ( &
      conjg (mix_su121) * mix_sd322 * g_h41_312susd) + ( &
      conjg (mix_su122) * mix_sd321 * g_h41_321susd))
    ghsu2sd2_1_3_c = conjg (ghsu2sd2_1_3)
    ghsu1sd1_2_1 = g_h42_111susd
    ghsu1sd1_2_1_c = conjg (ghsu1sd1_2_1)
    ghsu1sd1_2_2 = g_h42_211susd
    ghsu1sd1_2_2_c = conjg (ghsu1sd1_2_2)
    ghsu1sd1_2_3 = ((conjg (mix_su211) * mix_sd311 * g_h42_311susd) + ( &
      conjg (mix_su212) * mix_sd312 * g_h42_322susd) + ( &
      conjg (mix_su211) * mix_sd312 * g_h42_312susd) + ( &
      conjg (mix_su212) * mix_sd311 * g_h42_321susd))
    ghsu1sd1_2_3_c = conjg (ghsu1sd1_2_3)
    ghsu1sd2_2_3 = ((conjg (mix_su211) * mix_sd321 * g_h42_311susd) + ( &
      conjg (mix_su212) * mix_sd322 * g_h42_322susd) + ( &
      conjg (mix_su211) * mix_sd322 * g_h42_312susd) + ( &
      conjg (mix_su212) * mix_sd321 * g_h42_321susd))
    ghsu1sd2_2_3_c = conjg (ghsu1sd2_2_3)
    ghsu2sd1_2_3 = ((conjg (mix_su221) * mix_sd311 * g_h42_311susd) + ( &
      conjg (mix_su222) * mix_sd312 * g_h42_322susd) + ( &
      conjg (mix_su221) * mix_sd312 * g_h42_312susd) + ( &
      conjg (mix_su222) * mix_sd311 * g_h42_321susd))
    ghsu2sd1_2_3_c = conjg (ghsu2sd1_2_3)
    ghsu2sd2_2_3 = ((conjg (mix_su221) * mix_sd321 * g_h42_311susd) + ( &
      conjg (mix_su222) * mix_sd322 * g_h42_322susd) + ( &
      conjg (mix_su221) * mix_sd322 * g_h42_312susd) + ( &
      conjg (mix_su222) * mix_sd321 * g_h42_321susd))
    ghsu2sd2_2_3_c = conjg (ghsu2sd2_2_3)
    ghsu1sd1_3_1 = ((conjg (mix_su311) * mix_sd111 * g_h43_111susd) + ( &
      conjg (mix_su312) * mix_sd112 * g_h43_122susd) + ( &
      conjg (mix_su311) * mix_sd112 * g_h43_112susd) + ( &
      conjg (mix_su312) * mix_sd111 * g_h43_121susd))
    ghsu1sd1_3_1_c = conjg (ghsu1sd1_3_1)
    ghsu1sd2_3_1 = ((conjg (mix_su311) * mix_sd121 * g_h43_111susd) + ( &
      conjg (mix_su312) * mix_sd122 * g_h43_122susd) + ( &
      conjg (mix_su311) * mix_sd122 * g_h43_112susd) + ( &
      conjg (mix_su312) * mix_sd121 * g_h43_121susd))
    ghsu1sd2_3_1_c = conjg (ghsu1sd2_3_1)
    ghsu2sd1_3_1 = ((conjg (mix_su321) * mix_sd111 * g_h43_111susd) + ( &
      conjg (mix_su322) * mix_sd112 * g_h43_122susd) + ( &
      conjg (mix_su321) * mix_sd112 * g_h43_112susd) + ( &
      conjg (mix_su322) * mix_sd111 * g_h43_121susd))
    ghsu2sd1_3_1_c = conjg (ghsu2sd1_3_1)
    ghsu2sd2_3_1 = ((conjg (mix_su321) * mix_sd121 * g_h43_111susd) + ( &
      conjg (mix_su322) * mix_sd122 * g_h43_122susd) + ( &
      conjg (mix_su321) * mix_sd122 * g_h43_112susd) + ( &
      conjg (mix_su322) * mix_sd121 * g_h43_121susd))
    ghsu2sd2_3_1_c = conjg (ghsu2sd2_3_1)
    ghsu1sd1_3_2 = ((conjg (mix_su311) * mix_sd211 * g_h43_211susd) + ( &
      conjg (mix_su312) * mix_sd212 * g_h43_222susd) + ( &
      conjg (mix_su311) * mix_sd212 * g_h43_212susd) + ( &
      conjg (mix_su312) * mix_sd211 * g_h43_221susd))
    ghsu1sd1_3_2_c = conjg (ghsu1sd1_3_2)
    ghsu1sd2_3_2 = ((conjg (mix_su311) * mix_sd221 * g_h43_211susd) + ( &
      conjg (mix_su312) * mix_sd222 * g_h43_222susd) + ( &
      conjg (mix_su311) * mix_sd222 * g_h43_212susd) + ( &
      conjg (mix_su312) * mix_sd221 * g_h43_221susd))
    ghsu1sd2_3_2_c = conjg (ghsu1sd2_3_2)
    ghsu2sd1_3_2 = ((conjg (mix_su321) * mix_sd211 * g_h43_211susd) + ( &
      conjg (mix_su322) * mix_sd212 * g_h43_222susd) + ( &
      conjg (mix_su321) * mix_sd212 * g_h43_212susd) + ( &
      conjg (mix_su322) * mix_sd211 * g_h43_221susd))
    ghsu2sd1_3_2_c = conjg (ghsu2sd1_3_2)
    ghsu2sd2_3_2 = ((conjg (mix_su321) * mix_sd221 * g_h43_211susd) + ( &
      conjg (mix_su322) * mix_sd222 * g_h43_222susd) + ( &
      conjg (mix_su321) * mix_sd222 * g_h43_212susd) + ( &
      conjg (mix_su322) * mix_sd221 * g_h43_221susd))
    ghsu2sd2_3_2_c = conjg (ghsu2sd2_3_2)
    ghsu1sd1_3_3 = ((conjg (mix_su311) * mix_sd311 * g_h43_311susd) + ( &
      conjg (mix_su312) * mix_sd312 * g_h43_322susd) + ( &
      conjg (mix_su311) * mix_sd312 * g_h43_312susd) + ( &
      conjg (mix_su312) * mix_sd311 * g_h43_321susd))
    ghsu1sd1_3_3_c = conjg (ghsu1sd1_3_3)
    ghsu1sd2_3_3 = ((conjg (mix_su311) * mix_sd321 * g_h43_311susd) + ( &
      conjg (mix_su312) * mix_sd322 * g_h43_322susd) + ( &
      conjg (mix_su311) * mix_sd322 * g_h43_312susd) + ( &
      conjg (mix_su312) * mix_sd321 * g_h43_321susd))
    ghsu1sd2_3_3_c = conjg (ghsu1sd2_3_3)
    ghsu2sd1_3_3 = ((conjg (mix_su321) * mix_sd311 * g_h43_311susd) + ( &
      conjg (mix_su322) * mix_sd312 * g_h43_322susd) + ( &
      conjg (mix_su321) * mix_sd312 * g_h43_312susd) + ( &
      conjg (mix_su322) * mix_sd311 * g_h43_321susd))
    ghsu2sd1_3_3_c = conjg (ghsu2sd1_3_3)
    ghsu2sd2_3_3 = ((conjg (mix_su321) * mix_sd321 * g_h43_311susd) + ( &
      conjg (mix_su322) * mix_sd322 * g_h43_322susd) + ( &
      conjg (mix_su321) * mix_sd322 * g_h43_312susd) + ( &
      conjg (mix_su322) * mix_sd321 * g_h43_321susd))
    ghsu2sd2_3_3_c = conjg (ghsu2sd2_3_3)
    g_yuk_ch1_sl1_1_c = ((( - g) / 2.0_omega_prec) * mu_11)
    g_yuk_ch1_sl1_1 = conjg (g_yuk_ch1_sl1_1_c)
    g_yuk_ch1_sl1_2_c = ((( - g) / 2.0_omega_prec) * mu_11)
    g_yuk_ch1_sl1_2 = conjg (g_yuk_ch1_sl1_2_c)
    g_yuk_ch1_sl1_3_c = ((((( - g) / 2.0_omega_prec) * mu_11) *  &
      conjg (mix_sl311)) + (((gcc * mass(15) * mu_12) / (mass(24) * cosbe)) * &
      conjg (mix_sl312)))
    g_yuk_ch1_sl1_3 = conjg (g_yuk_ch1_sl1_3_c)
    g_yuk_ch1_sl2_3_c = ((((( - g) / 2.0_omega_prec) * mu_11) *  &
      conjg (mix_sl321)) + (((gcc * mass(15) * mu_12) / (mass(24) * cosbe)) * &
      conjg (mix_sl322)))
    g_yuk_ch1_sl2_3 = conjg (g_yuk_ch1_sl2_3_c)
    g_yuk_ch1_sn1_1_c = ( - ((g / 2.0_omega_prec) * mv_11))
    g_yuk_ch1_sn1_1 = conjg (g_yuk_ch1_sn1_1_c)
    g_yuk_ch1_sn1_2_c = ( - ((g / 2.0_omega_prec) * mv_11))
    g_yuk_ch1_sn1_2 = conjg (g_yuk_ch1_sn1_2_c)
    g_yuk_ch2_sl1_1_c = ((( - g) / 2.0_omega_prec) * mu_21)
    g_yuk_ch2_sl1_1 = conjg (g_yuk_ch2_sl1_1_c)
    g_yuk_ch2_sl1_2_c = ((( - g) / 2.0_omega_prec) * mu_21)
    g_yuk_ch2_sl1_2 = conjg (g_yuk_ch2_sl1_2_c)
    g_yuk_ch2_sl1_3_c = ((((( - g) / 2.0_omega_prec) * mu_21) *  &
      conjg (mix_sl311)) + (((gcc * mass(15) * mu_22) / (mass(24) * cosbe)) * &
      conjg (mix_sl312)))
    g_yuk_ch2_sl1_3 = conjg (g_yuk_ch2_sl1_3_c)
    g_yuk_ch2_sl2_3_c = ((((( - g) / 2.0_omega_prec) * mu_21) *  &
      conjg (mix_sl321)) + (((gcc * mass(15) * mu_22) / (mass(24) * cosbe)) * &
      conjg (mix_sl322)))
    g_yuk_ch2_sl2_3 = conjg (g_yuk_ch2_sl2_3_c)
    g_yuk_ch2_sl2_3_c = conjg (g_yuk_ch2_sl2_3)
    g_yuk_ch2_sn1_1_c = ( - ((g / 2.0_omega_prec) * mv_21))
    g_yuk_ch2_sn1_1 = conjg (g_yuk_ch2_sn1_1_c)
    g_yuk_ch2_sn1_2_c = ( - ((g / 2.0_omega_prec) * mv_21))
    g_yuk_ch2_sn1_2 = conjg (g_yuk_ch2_sn1_2_c)
    g_yuk_ch1_sd1_1_1 = ( - ((g / 2.0_omega_prec) * conjg (mu_11) * vckm_11))
    g_yuk_ch1_sd1_1_1_c = conjg (g_yuk_ch1_sd1_1_1)
    g_yuk_ch1_su1_1_1 = ( - ((g / 2.0_omega_prec) * conjg (mv_11) * vckm_11))
    g_yuk_ch1_su1_1_1_c = conjg (g_yuk_ch1_su1_1_1)
    g_yuk_ch1_sd1_1_2 = ( - ((g / 2.0_omega_prec) * conjg (mu_11) * vckm_12))
    g_yuk_ch1_sd1_1_2_c = conjg (g_yuk_ch1_sd1_1_2)
    g_yuk_ch1_su1_1_2 = ( - ((g / 2.0_omega_prec) * conjg (mv_11) * vckm_12))
    g_yuk_ch1_su1_1_2_c = conjg (g_yuk_ch1_su1_1_2)
    g_yuk_ch1_sd1_2_1 = ( - ((g / 2.0_omega_prec) * conjg (mu_11) * vckm_21))
    g_yuk_ch1_sd1_2_1_c = conjg (g_yuk_ch1_sd1_2_1)
    g_yuk_ch1_su1_2_1 = ( - ((g / 2.0_omega_prec) * conjg (mv_11) * vckm_21))
    g_yuk_ch1_su1_2_1_c = conjg (g_yuk_ch1_su1_2_1)
    g_yuk_ch1_sd1_2_2 = ( - ((g / 2.0_omega_prec) * conjg (mu_11) * vckm_22))
    g_yuk_ch1_sd1_2_2_c = conjg (g_yuk_ch1_sd1_2_2)
    g_yuk_ch1_su1_2_2 = ( - ((g / 2.0_omega_prec) * conjg (mv_11) * vckm_22))
    g_yuk_ch1_su1_2_2_c = conjg (g_yuk_ch1_su1_2_2)
    g_yuk_ch2_sd1_1_1 = ( - ((g / 2.0_omega_prec) * conjg (mu_21) * vckm_11))
    g_yuk_ch2_sd1_1_1_c = conjg (g_yuk_ch2_sd1_1_1)
    g_yuk_ch2_su1_1_1 = ( - ((g / 2.0_omega_prec) * conjg (mv_21) * vckm_11))
    g_yuk_ch2_su1_1_1_c = conjg (g_yuk_ch2_su1_1_1)
    g_yuk_ch2_sd1_1_2 = ( - ((g / 2.0_omega_prec) * conjg (mu_21) * vckm_12))
    g_yuk_ch2_sd1_1_2_c = conjg (g_yuk_ch2_sd1_1_2)
    g_yuk_ch2_su1_1_2 = ( - ((g / 2.0_omega_prec) * conjg (mv_21) * vckm_12))
    g_yuk_ch2_su1_1_2_c = conjg (g_yuk_ch2_su1_1_2)
    g_yuk_ch2_sd1_2_1 = ( - ((g / 2.0_omega_prec) * conjg (mu_21) * vckm_21))
    g_yuk_ch2_sd1_2_1_c = conjg (g_yuk_ch2_sd1_2_1)
    g_yuk_ch2_su1_2_1 = ( - ((g / 2.0_omega_prec) * conjg (mv_21) * vckm_21))
    g_yuk_ch2_su1_2_1_c = conjg (g_yuk_ch2_su1_2_1)
    g_yuk_ch2_sd1_2_2 = ( - ((g / 2.0_omega_prec) * conjg (mu_21) * vckm_22))
    g_yuk_ch2_sd1_2_2_c = conjg (g_yuk_ch2_sd1_2_2)
    g_yuk_ch2_su1_2_2 = ( - ((g / 2.0_omega_prec) * conjg (mv_21) * vckm_22))
    g_yuk_ch2_su1_2_2_c = conjg (g_yuk_ch2_su1_2_2)
   g_yuk_n1_sn1_1 = (gcc * ((mn_11 * (sinthw / costhw)) - mn_12))
   g_yuk_n1_sn1_1_c = conjg (g_yuk_n1_sn1_1)
   g_yuk_n1_sn1_2 = (gcc * ((mn_11 * (sinthw / costhw)) - mn_12))
   g_yuk_n1_sn1_2_c = conjg (g_yuk_n1_sn1_2)
   g_yuk_n1_sn1_3 = (gcc * ((mn_11 * (sinthw / costhw)) - mn_12))
   g_yuk_n1_sn1_3_c = conjg (g_yuk_n1_sn1_3)
    g_yuk_n2_sn1_1 = (gcc * ((mn_21 * (sinthw / costhw)) - mn_22))
    g_yuk_n2_sn1_1_c = conjg (g_yuk_n2_sn1_1)
    g_yuk_n2_sn1_2 = (gcc * ((mn_21 * (sinthw / costhw)) - mn_22))
    g_yuk_n2_sn1_2_c = conjg (g_yuk_n2_sn1_2)
    g_yuk_n2_sn1_3 = (gcc * ((mn_21 * (sinthw / costhw)) - mn_22))
    g_yuk_n2_sn1_3_c = conjg (g_yuk_n2_sn1_3)
    g_yuk_n3_sn1_1 = (gcc * ((mn_31 * (sinthw / costhw)) - mn_32))
    g_yuk_n3_sn1_1_c = conjg (g_yuk_n3_sn1_1)
    g_yuk_n3_sn1_2 = (gcc * ((mn_31 * (sinthw / costhw)) - mn_32))
    g_yuk_n3_sn1_2_c = conjg (g_yuk_n3_sn1_2)
    g_yuk_n3_sn1_3 = (gcc * ((mn_31 * (sinthw / costhw)) - mn_32))
    g_yuk_n3_sn1_3_c = conjg (g_yuk_n3_sn1_3)
    g_yuk_n4_sn1_1 = (gcc * ((mn_41 * (sinthw / costhw)) - mn_42))
    g_yuk_n4_sn1_1_c = conjg (g_yuk_n4_sn1_1)
    g_yuk_n4_sn1_2 = (gcc * ((mn_41 * (sinthw / costhw)) - mn_42))
    g_yuk_n4_sn1_2_c = conjg (g_yuk_n4_sn1_2)
    g_yuk_n4_sn1_3 = (gcc * ((mn_41 * (sinthw / costhw)) - mn_42))
    g_yuk_n4_sn1_3_c = conjg (g_yuk_n4_sn1_3)
    g_yuk_n1_sl1_1 = (gcc * (mn_12 + ((sinthw * mn_11) / costhw)))
    g_yuk_n1_sl1_1_c = conjg (g_yuk_n1_sl1_1)
    g_yuk_n1_sl2_1 = ((gcc * 2.0_omega_prec * q_lep * sinthw *  &
      conjg (mn_11)) / costhw)
    g_yuk_n1_sl2_1_c = conjg (g_yuk_n1_sl2_1)
    g_yuk_n1_su1_1 = (( - gcc) * (mn_12 + ((sinthw * mn_11) /  &
      (3.0_omega_prec * costhw))))
    g_yuk_n1_su1_1_c = conjg (g_yuk_n1_su1_1)
    g_yuk_n1_su2_1 = ((gcc * 2.0_omega_prec * q_up * sinthw *  &
      conjg (mn_11)) / costhw)
    g_yuk_n1_su2_1_c = conjg (g_yuk_n1_su2_1)
    g_yuk_n1_sd1_1 = (gcc * (mn_12 - ((sinthw * mn_11) /  &
      (costhw * 3.0_omega_prec))))
    g_yuk_n1_sd1_1_c = conjg (g_yuk_n1_sd1_1)
    g_yuk_n1_sd2_1 = ((gcc * 2.0_omega_prec * q_down * sinthw *  &
      conjg (mn_11)) / costhw)
    g_yuk_n1_sd2_1_c = conjg (g_yuk_n1_sd2_1)
    g_yuk_n2_sl1_1 = (gcc * (mn_22 + ((sinthw * mn_21) / costhw)))
    g_yuk_n2_sl1_1_c = conjg (g_yuk_n2_sl1_1)
    g_yuk_n2_sl2_1 = ((gcc * 2.0_omega_prec * q_lep * sinthw *  &
      conjg (mn_21)) / costhw)
    g_yuk_n2_sl2_1_c = conjg (g_yuk_n2_sl2_1)
    g_yuk_n2_su1_1 = (( - gcc) * (mn_22 + ((sinthw * mn_21) /  &
      (3.0_omega_prec * costhw))))
    g_yuk_n2_su1_1_c = conjg (g_yuk_n2_su1_1)
    g_yuk_n2_su2_1 = ((gcc * 2.0_omega_prec * q_up * sinthw *  &
      conjg (mn_21)) / costhw)
    g_yuk_n2_su2_1_c = conjg (g_yuk_n2_su2_1)
    g_yuk_n2_sd1_1 = (gcc * (mn_22 - ((sinthw * mn_21) /  &
      (costhw * 3.0_omega_prec))))
    g_yuk_n2_sd1_1_c = conjg (g_yuk_n2_sd1_1)
    g_yuk_n2_sd2_1 = ((gcc * 2.0_omega_prec * q_down * sinthw *  &
      conjg (mn_21)) / costhw)
    g_yuk_n2_sd2_1_c = conjg (g_yuk_n2_sd2_1)
    g_yuk_n3_sl1_1 = (gcc * (mn_32 + ((sinthw * mn_31) / costhw)))
    g_yuk_n3_sl1_1_c = conjg (g_yuk_n3_sl1_1)
    g_yuk_n3_sl2_1 = ((gcc * 2.0_omega_prec * q_lep * sinthw *  &
      conjg (mn_31)) / costhw)
    g_yuk_n3_sl2_1_c = conjg (g_yuk_n3_sl2_1)
    g_yuk_n3_su1_1 = (( - gcc) * (mn_32 + ((sinthw * mn_31) /  &
      (3.0_omega_prec * costhw))))
    g_yuk_n3_su1_1_c = conjg (g_yuk_n3_su1_1)
    g_yuk_n3_su2_1 = ((gcc * 2.0_omega_prec * q_up * sinthw *  &
      conjg (mn_31)) / costhw)
    g_yuk_n3_su2_1_c = conjg (g_yuk_n3_su2_1)
    g_yuk_n3_sd1_1 = (gcc * (mn_32 - ((sinthw * mn_31) /  &
      (costhw * 3.0_omega_prec))))
    g_yuk_n3_sd1_1_c = conjg (g_yuk_n3_sd1_1)
    g_yuk_n3_sd2_1 = ((gcc * 2.0_omega_prec * q_down * sinthw *  &
      conjg (mn_31)) / costhw)
    g_yuk_n3_sd2_1_c = conjg (g_yuk_n3_sd2_1)
    g_yuk_n4_sl1_1 = (gcc * (mn_42 + ((sinthw * mn_41) / costhw)))
    g_yuk_n4_sl1_1_c = conjg (g_yuk_n4_sl1_1)
    g_yuk_n4_sl2_1 = ((gcc * 2.0_omega_prec * q_lep * sinthw *  &
      conjg (mn_41)) / costhw)
    g_yuk_n4_sl2_1_c = conjg (g_yuk_n4_sl2_1)
    g_yuk_n4_su1_1 = (( - gcc) * (mn_42 + ((sinthw * mn_41) /  &
      (3.0_omega_prec * costhw))))
    g_yuk_n4_su1_1_c = conjg (g_yuk_n4_su1_1)
    g_yuk_n4_su2_1 = ((gcc * 2.0_omega_prec * q_up * sinthw *  &
      conjg (mn_41)) / costhw)
    g_yuk_n4_su2_1_c = conjg (g_yuk_n4_su2_1)
    g_yuk_n4_sd1_1 = (gcc * (mn_42 - ((sinthw * mn_41) /  &
      (costhw * 3.0_omega_prec))))
    g_yuk_n4_sd1_1_c = conjg (g_yuk_n4_sd1_1)
    g_yuk_n4_sd2_1 = ((gcc * 2.0_omega_prec * q_down * sinthw *  &
      conjg (mn_41)) / costhw)
    g_yuk_n4_sd2_1_c = conjg (g_yuk_n4_sd2_1)
    g_yuk_n1_sl1_2 = (gcc * (mn_12 + ((sinthw * mn_11) / costhw)))
    g_yuk_n1_sl1_2_c = conjg (g_yuk_n1_sl1_2)
    g_yuk_n1_sl2_2 = ((gcc * 2.0_omega_prec * q_lep * sinthw *  &
      conjg (mn_11)) / costhw)
    g_yuk_n1_sl2_2_c = conjg (g_yuk_n1_sl2_2)
    g_yuk_n1_su1_2 = (( - gcc) * (mn_12 + ((sinthw * mn_11) /  &
      (3.0_omega_prec * costhw))))
    g_yuk_n1_su1_2_c = conjg (g_yuk_n1_su1_2)
    g_yuk_n1_su2_2 = ((gcc * 2.0_omega_prec * q_up * sinthw *  &
      conjg (mn_11)) / costhw)
    g_yuk_n1_su2_2_c = conjg (g_yuk_n1_su2_2)
    g_yuk_n1_sd1_2 = (gcc * (mn_12 - ((sinthw * mn_11) /  &
      (costhw * 3.0_omega_prec))))
    g_yuk_n1_sd1_2_c = conjg (g_yuk_n1_sd1_2)
    g_yuk_n1_sd2_2 = ((gcc * 2.0_omega_prec * q_down * sinthw *  &
      conjg (mn_11)) / costhw)
    g_yuk_n1_sd2_2_c = conjg (g_yuk_n1_sd2_2)
    g_yuk_n2_sl1_2 = (gcc * (mn_22 + ((sinthw * mn_21) / costhw)))
    g_yuk_n2_sl1_2_c = conjg (g_yuk_n2_sl1_2)
    g_yuk_n2_sl2_2 = ((gcc * 2.0_omega_prec * q_lep * sinthw *  &
      conjg (mn_21)) / costhw)
    g_yuk_n2_sl2_2_c = conjg (g_yuk_n2_sl2_2)
    g_yuk_n2_su1_2 = (( - gcc) * (mn_22 + ((sinthw * mn_21) /  &
      (3.0_omega_prec * costhw))))
    g_yuk_n2_su1_2_c = conjg (g_yuk_n2_su1_2)
    g_yuk_n2_su2_2 = ((gcc * 2.0_omega_prec * q_up * sinthw *  &
      conjg (mn_21)) / costhw)
    g_yuk_n2_su2_2_c = conjg (g_yuk_n2_su2_2)
    g_yuk_n2_sd1_2 = (gcc * (mn_22 - ((sinthw * mn_21) /  &
      (costhw * 3.0_omega_prec))))
    g_yuk_n2_sd1_2_c = conjg (g_yuk_n2_sd1_2)
    g_yuk_n2_sd2_2 = ((gcc * 2.0_omega_prec * q_down * sinthw *  &
      conjg (mn_21)) / costhw)
    g_yuk_n2_sd2_2_c = conjg (g_yuk_n2_sd2_2)
    g_yuk_n3_sl1_2 = (gcc * (mn_32 + ((sinthw * mn_31) / costhw)))
    g_yuk_n3_sl1_2_c = conjg (g_yuk_n3_sl1_2)
    g_yuk_n3_sl2_2 = ((gcc * 2.0_omega_prec * q_lep * sinthw *  &
      conjg (mn_31)) / costhw)
    g_yuk_n3_sl2_2_c = conjg (g_yuk_n3_sl2_2)
    g_yuk_n3_su1_2 = (( - gcc) * (mn_32 + ((sinthw * mn_31) /  &
      (3.0_omega_prec * costhw))))
    g_yuk_n3_su1_2_c = conjg (g_yuk_n3_su1_2)
    g_yuk_n3_su2_2 = ((gcc * 2.0_omega_prec * q_up * sinthw *  &
      conjg (mn_31)) / costhw)
    g_yuk_n3_su2_2_c = conjg (g_yuk_n3_su2_2)
    g_yuk_n3_sd1_2 = (gcc * (mn_32 - ((sinthw * mn_31) /  &
      (costhw * 3.0_omega_prec))))
    g_yuk_n3_sd1_2_c = conjg (g_yuk_n3_sd1_2)
    g_yuk_n3_sd2_2 = ((gcc * 2.0_omega_prec * q_down * sinthw *  &
      conjg (mn_31)) / costhw)
    g_yuk_n3_sd2_2_c = conjg (g_yuk_n3_sd2_2)
    g_yuk_n4_sl1_2 = (gcc * (mn_42 + ((sinthw * mn_41) / costhw)))
    g_yuk_n4_sl1_2_c = conjg (g_yuk_n4_sl1_2)
    g_yuk_n4_sl2_2 = ((gcc * 2.0_omega_prec * q_lep * sinthw *  &
      conjg (mn_41)) / costhw)
    g_yuk_n4_sl2_2_c = conjg (g_yuk_n4_sl2_2)
    g_yuk_n4_su1_2 = (( - gcc) * (mn_42 + ((sinthw * mn_41) /  &
      (3.0_omega_prec * costhw))))
    g_yuk_n4_su1_2_c = conjg (g_yuk_n4_su1_2)
    g_yuk_n4_su2_2 = ((gcc * 2.0_omega_prec * q_up * sinthw *  &
      conjg (mn_41)) / costhw)
    g_yuk_n4_su2_2_c = conjg (g_yuk_n4_su2_2)
    g_yuk_n4_sd1_2 = (gcc * (mn_42 - ((sinthw * mn_41) /  &
      (costhw * 3.0_omega_prec))))
    g_yuk_n4_sd1_2_c = conjg (g_yuk_n4_sd1_2)
    g_yuk_n4_sd2_2 = ((gcc * 2.0_omega_prec * q_down * sinthw *  &
      conjg (mn_41)) / costhw)
    g_yuk_n4_sd2_2_c = conjg (g_yuk_n4_sd2_2)
end subroutine setup_parameters12
subroutine setup_parameters13 ()
    gncneu(1) = ((gz / 2.0_omega_prec) * ( &
      (2.0_omega_prec * 0.0_omega_prec * sin2thw) -  &
      (1.0_omega_prec / 2.0_omega_prec)))
    gncneu(2) = ((( - gz) / 2.0_omega_prec) *  &
      (1.0_omega_prec / 2.0_omega_prec))
    gnclep(1) = ((gz / 2.0_omega_prec) * ( &
      (2.0_omega_prec * (-1.0_omega_prec) * sin2thw) - ( -  &
      (1.0_omega_prec / 2.0_omega_prec))))
    gnclep(2) = ((( - gz) / 2.0_omega_prec) * ( -  &
      (1.0_omega_prec / 2.0_omega_prec)))
    gncup(1) = ((gz / 2.0_omega_prec) * ((2.0_omega_prec *  &
      (2.0_omega_prec / 3.0_omega_prec) * sin2thw) -  &
      (1.0_omega_prec / 2.0_omega_prec)))
    gncup(2) = ((( - gz) / 2.0_omega_prec) * (1.0_omega_prec / 2.0_omega_prec))
    gncdwn(1) = ((gz / 2.0_omega_prec) * ((2.0_omega_prec *  &
      ((-1.0_omega_prec) / 3.0_omega_prec) * sin2thw) - ( -  &
      (1.0_omega_prec / 2.0_omega_prec))))
    gncdwn(2) = ((( - gz) / 2.0_omega_prec) * ( -  &
      (1.0_omega_prec / 2.0_omega_prec)))
    g_yuk1_1_3(1) = ((gcc / mass(24)) * vckm_13 * (mass(2) / tanb))
    g_yuk1_1_3(2) = ((gcc / mass(24)) * vckm_13 * tanb * mass(5))
    g_yuk1_2_3(1) = ((gcc / mass(24)) * vckm_23 * (mass(4) / tanb))
    g_yuk1_2_3(2) = ((gcc / mass(24)) * vckm_23 * tanb * mass(5))
    g_yuk1_3_3(1) = ((gcc / mass(24)) * vckm_33 * (mass(6) / tanb))
    g_yuk1_3_3(2) = ((gcc / mass(24)) * vckm_33 * tanb * mass(5))
    g_yuk1_3_2(1) = ((gcc / mass(24)) * vckm_32 * (mass(6) / tanb))
    g_yuk1_3_2(2) = ((gcc / mass(24)) * vckm_32 * tanb * mass(3))
    g_yuk1_3_1(1) = ((gcc / mass(24)) * vckm_31 * (mass(6) / tanb))
    g_yuk1_3_1(2) = ((gcc / mass(24)) * vckm_31 * tanb * mass(1))
    g_yuk2_1_3(1) = conjg (g_yuk1_1_3(2))
    g_yuk2_1_3(2) = conjg (g_yuk1_1_3(1))
    g_yuk2_2_3(1) = conjg (g_yuk1_2_3(2))
    g_yuk2_2_3(2) = conjg (g_yuk1_2_3(1))
    g_yuk2_3_1(1) = conjg (g_yuk1_3_1(2))
    g_yuk2_3_1(2) = conjg (g_yuk1_3_1(1))
    g_yuk2_3_2(1) = conjg (g_yuk1_3_2(2))
    g_yuk2_3_2(2) = conjg (g_yuk1_3_2(1))
    g_yuk2_3_3(1) = conjg (g_yuk1_3_3(2))
    g_yuk2_3_3(2) = conjg (g_yuk1_3_3(1))
    gnzn_1_2(1) = (gz * v0_12)
    gnzn_1_2(2) = (gz * a0_12)
    gnzn_1_3(1) = (gz * v0_13)
    gnzn_1_3(2) = (gz * a0_13)
    gnzn_1_4(1) = (gz * v0_14)
    gnzn_1_4(2) = (gz * a0_14)
    gnzn_2_3(1) = (gz * v0_23)
    gnzn_2_3(2) = (gz * a0_23)
    gnzn_2_4(1) = (gz * v0_24)
    gnzn_2_4(2) = (gz * a0_24)
    gnzn_3_4(1) = (gz * v0_34)
    gnzn_3_4(2) = (gz * a0_34)
    gczc_1_1(1) = (gz * vp_11)
    gczc_1_1(2) = (gz * ap_11)
    gczc_1_2(1) = (gz * vp_12)
    gczc_1_2(2) = (gz * ap_12)
    gczc_2_1(1) = (gz * vp_21)
    gczc_2_1(2) = (gz * ap_21)
    gczc_2_2(1) = (gz * vp_22)
    gczc_2_2(2) = (gz * ap_22)
    gnwc_1_1(1) = (gcc * lnc_11)
    gnwc_1_1(2) = (gcc * rnc_11)
    g_nhc_1_1(1) = ((g / 2.0_omega_prec) * lnch_11)
    g_nhc_1_1(2) = ((g / 2.0_omega_prec) * rnch_11)
    gnwc_1_2(1) = (gcc * lnc_12)
    gnwc_1_2(2) = (gcc * rnc_12)
    g_nhc_1_2(1) = ((g / 2.0_omega_prec) * lnch_12)
    g_nhc_1_2(2) = ((g / 2.0_omega_prec) * rnch_12)
    gnwc_2_1(1) = (gcc * lnc_21)
    gnwc_2_1(2) = (gcc * rnc_21)
    g_nhc_2_1(1) = ((g / 2.0_omega_prec) * lnch_21)
    g_nhc_2_1(2) = ((g / 2.0_omega_prec) * rnch_21)
    gnwc_2_2(1) = (gcc * lnc_22)
    gnwc_2_2(2) = (gcc * rnc_22)
    g_nhc_2_2(1) = ((g / 2.0_omega_prec) * lnch_22)
    g_nhc_2_2(2) = ((g / 2.0_omega_prec) * rnch_22)
    gnwc_3_1(1) = (gcc * lnc_31)
    gnwc_3_1(2) = (gcc * rnc_31)
    g_nhc_3_1(1) = ((g / 2.0_omega_prec) * lnch_31)
    g_nhc_3_1(2) = ((g / 2.0_omega_prec) * rnch_31)
    gnwc_3_2(1) = (gcc * lnc_32)
    gnwc_3_2(2) = (gcc * rnc_32)
    g_nhc_3_2(1) = ((g / 2.0_omega_prec) * lnch_32)
    g_nhc_3_2(2) = ((g / 2.0_omega_prec) * rnch_32)
    gnwc_4_1(1) = (gcc * lnc_41)
    gnwc_4_1(2) = (gcc * rnc_41)
    g_nhc_4_1(1) = ((g / 2.0_omega_prec) * lnch_41)
    g_nhc_4_1(2) = ((g / 2.0_omega_prec) * rnch_41)
    gnwc_4_2(1) = (gcc * lnc_42)
    gnwc_4_2(2) = (gcc * rnc_42)
    g_nhc_4_2(1) = ((g / 2.0_omega_prec) * lnch_42)
    g_nhc_4_2(2) = ((g / 2.0_omega_prec) * rnch_42)
    gcwn_1_1(1) = (gcc * lcn_11)
    gcwn_1_1(2) = (gcc * rcn_11)
    g_chn_1_1(1) = ((g / 2.0_omega_prec) * conjg (rnch_11))
    g_chn_1_1(2) = ((g / 2.0_omega_prec) * conjg (lnch_11))
    gcwn_1_2(1) = (gcc * lcn_12)
    gcwn_1_2(2) = (gcc * rcn_12)
    g_chn_2_1(1) = ((g / 2.0_omega_prec) * conjg (rnch_21))
    g_chn_2_1(2) = ((g / 2.0_omega_prec) * conjg (lnch_21))
    gcwn_1_3(1) = (gcc * lcn_13)
    gcwn_1_3(2) = (gcc * rcn_13)
    g_chn_3_1(1) = ((g / 2.0_omega_prec) * conjg (rnch_31))
    g_chn_3_1(2) = ((g / 2.0_omega_prec) * conjg (lnch_31))
    gcwn_1_4(1) = (gcc * lcn_14)
    gcwn_1_4(2) = (gcc * rcn_14)
    g_chn_4_1(1) = ((g / 2.0_omega_prec) * conjg (rnch_41))
    g_chn_4_1(2) = ((g / 2.0_omega_prec) * conjg (lnch_41))
    gcwn_2_1(1) = (gcc * lcn_21)
    gcwn_2_1(2) = (gcc * rcn_21)
    g_chn_1_2(1) = ((g / 2.0_omega_prec) * conjg (rnch_12))
    g_chn_1_2(2) = ((g / 2.0_omega_prec) * conjg (lnch_12))
    gcwn_2_2(1) = (gcc * lcn_22)
    gcwn_2_2(2) = (gcc * rcn_22)
    g_chn_2_2(1) = ((g / 2.0_omega_prec) * conjg (rnch_22))
    g_chn_2_2(2) = ((g / 2.0_omega_prec) * conjg (lnch_22))
    gcwn_2_3(1) = (gcc * lcn_23)
    gcwn_2_3(2) = (gcc * rcn_23)
    g_chn_3_2(1) = ((g / 2.0_omega_prec) * conjg (rnch_32))
    g_chn_3_2(2) = ((g / 2.0_omega_prec) * conjg (lnch_32))
    gcwn_2_4(1) = (gcc * lcn_24)
    gcwn_2_4(2) = (gcc * rcn_24)
    g_chn_4_2(1) = ((g / 2.0_omega_prec) * conjg (rnch_42))
    g_chn_4_2(2) = ((g / 2.0_omega_prec) * conjg (lnch_42))
    gcicih1_1_1 = ((( - g ) / 2.0_omega_prec) * snnh1_11)
    gcicih2_1_1 = ((( - g ) / 2.0_omega_prec) * snnh2_11)
    gcicia_1_1 = (imago *  &
      (( - g ) / 2.0_omega_prec) * pnna_11)
    gcicih1_1_2(1) = ((( - g ) / 2.0_omega_prec) * snnh1_12)
    gcicih1_1_2(2) = (imago *  &
      (( - g ) / 2.0_omega_prec) * pnnh1_12)
    gcicih2_1_2(1) = ((( - g ) / 2.0_omega_prec) * snnh2_12)
    gcicih2_1_2(2) = (imago *  &
      (( - g ) / 2.0_omega_prec) * pnnh2_12)
    gcicia_1_2(1) = ((( - g ) / 2.0_omega_prec) * snna_12)
    gcicia_1_2(2) = (imago *  &
      (( - g ) / 2.0_omega_prec) * pnna_12)
    gcicih1_1_3(1) = ((( - g ) / 2.0_omega_prec) * snnh1_13)
    gcicih1_1_3(2) = (imago *  &
      (( - g ) / 2.0_omega_prec) * pnnh1_13)
    gcicih2_1_3(1) = ((( - g ) / 2.0_omega_prec) * snnh2_13)
    gcicih2_1_3(2) = (imago *  &
      (( - g ) / 2.0_omega_prec) * pnnh2_13)
    gcicia_1_3(1) = ((( - g ) / 2.0_omega_prec) * snna_13)
    gcicia_1_3(2) = (imago *  &
      (( - g ) / 2.0_omega_prec) * pnna_13)
    gcicih1_1_4(1) = ((( - g ) / 2.0_omega_prec) * snnh1_14)
    gcicih1_1_4(2) = (imago *  &
      (( - g ) / 2.0_omega_prec) * pnnh1_14)
    gcicih2_1_4(1) = ((( - g ) / 2.0_omega_prec) * snnh2_14)
    gcicih2_1_4(2) = (imago *  &
      (( - g ) / 2.0_omega_prec) * pnnh2_14)
    gcicia_1_4(1) = ((( - g ) / 2.0_omega_prec) * snna_14)
    gcicia_1_4(2) = (imago *  &
      (( - g ) / 2.0_omega_prec) * pnna_14)
    gcicih1_2_2 = ((( - g ) / 2.0_omega_prec) * snnh1_22)
    gcicih2_2_2 = ((( - g ) / 2.0_omega_prec) * snnh2_22)
    gcicia_2_2 = (imago *  &
      (( - g ) / 2.0_omega_prec) * pnna_22)
    gcicih1_2_3(1) = ((( - g ) / 2.0_omega_prec) * snnh1_23)
    gcicih1_2_3(2) = (imago *  &
      (( - g ) / 2.0_omega_prec) * pnnh1_23)
    gcicih2_2_3(1) = ((( - g ) / 2.0_omega_prec) * snnh2_23)
    gcicih2_2_3(2) = (imago *  &
      (( - g ) / 2.0_omega_prec) * pnnh2_23)
 end subroutine setup_parameters13
! subroutine setup_parameters14 ()
!    gcicia_2_3(1) = ((( - g ) / 2.0_omega_prec) * snna_23)
!    gcicia_2_3(2) = (imago *  &
!      (( - g ) / 2.0_omega_prec) * pnna_23)
!    gcicih1_2_4(1) = ((( - g ) / 2.0_omega_prec) * snnh1_24)
!    gcicih1_2_4(2) = (imago *  &
!      (( - g ) / 2.0_omega_prec) * pnnh1_24)
!    gcicih2_2_4(1) = ((( - g ) / 2.0_omega_prec) * snnh2_24)
!    gcicih2_2_4(2) = (imago *  &
!      (( - g ) / 2.0_omega_prec) * pnnh2_24)
!    gcicia_2_4(1) = ((( - g ) / 2.0_omega_prec) * snna_24)
!    gcicia_2_4(2) = (imago *  &
!      (( - g ) / 2.0_omega_prec) * pnna_24)
!    gcicih1_3_3 = ((( - g ) / 2.0_omega_prec) * snnh1_33)
!    gcicih2_3_3 = ((( - g ) / 2.0_omega_prec) * snnh2_33)
!    gcicia_3_3 = (imago *  &
!      (( - g ) / 2.0_omega_prec) * pnna_33)
!    gcicih1_3_4(1) = ((( - g ) / 2.0_omega_prec) * snnh1_34)
!    gcicih1_3_4(2) = (imago *  &
!      (( - g ) / 2.0_omega_prec) * pnnh1_34)
!    gcicih2_3_4(1) = ((( - g ) / 2.0_omega_prec) * snnh2_34)
!    gcicih2_3_4(2) = (imago *  &
!      (( - g ) / 2.0_omega_prec) * pnnh2_34)
!    gcicia_3_4(1) = ((( - g ) / 2.0_omega_prec) * snna_34)
!    gcicia_3_4(2) = (imago *  &
!      (( - g ) / 2.0_omega_prec) * pnna_34)
!    gcicih1_4_4 = ((( - g ) / 2.0_omega_prec) * snnh1_44)
!    gcicih2_4_4 = ((( - g ) / 2.0_omega_prec) * snnh2_44)
!    gcicia_4_4 = (imago *  &
!      (( - g ) / 2.0_omega_prec) * pnna_44)
!    gch1c_1_1 = (( - (g / sqrt (2.0_omega_prec))) * ((conjg (mu_11) *  &
!      conjg (mv_12) * cosal) - (conjg (mu_12) * conjg (mv_11) * sinal)))
!    gch2c_1_1 = (( - (g / sqrt (2.0_omega_prec))) * ((conjg (mu_12) *  &
!      conjg (mv_11) * cosal) + (conjg (mu_11) * conjg (mv_12) * sinal)))
!    gcac_1_1 = (imago * ( - (g /  &
!      sqrt (2.0_omega_prec))) * ((mv_11 * mu_12 * sinbe) +  &
!      (mv_12 * mu_11 * cosbe)))
!    gch1c_1_2(1) = (( - gcc) * ((conjg (mu_11) *  &
!      conjg (mv_22) * cosal) - (conjg (mu_12) * conjg (mv_21) * sinal)))
!    gch1c_1_2(2) = (( - gcc) * ( &
!      (mv_12 * mu_21 * cosal) - (mv_11 * mu_22 * sinal)))
!    gch2c_1_2(1) = (( - gcc) * ((conjg (mu_12) *  &
!      conjg (mv_21) * cosal) + (conjg (mu_11) * conjg (mv_22) * sinal)))
!    gch2c_1_2(2) = (( - gcc) * ((mv_11 * mu_22 * cosal) &
!      + (mv_12 * mu_21 * sinal)))
!    gcac_1_2(1) = (imago * gcc * ((  &
!      conjg (mu_12) * conjg (mv_21) * sinbe) + ( &
!      conjg (mu_11) * conjg (mv_22) * cosbe)))
!    gcac_1_2(2) = (( - imago) * gcc *  (( &
!      mv_11 * mu_22 * sinbe) + (mv_12 * mu_21 * cosbe)))
!    gch1c_2_1(1) = conjg (gch1c_1_2(2)) 
!    gch1c_2_1(2) = conjg (gch1c_1_2(1))
!    gch2c_2_1(1) = conjg (gch2c_1_2(2))
!    gch2c_2_1(2) = conjg (gch2c_1_2(1))
!    gcac_2_1(1) = conjg (gcac_1_2(2))
!    gcac_2_1(2) = conjg (gcac_1_2(1))
!    gch1c_2_2 = (( - (g / sqrt (2.0_omega_prec))) * ((conjg (mu_21) *  &
!      conjg (mv_22) * cosal) - (conjg (mu_22) * conjg (mv_21) * sinal)))
!    gch2c_2_2 = (( - (g / sqrt (2.0_omega_prec))) * ((conjg (mu_22) *  &
!      conjg (mv_21) * cosal) + (conjg (mu_21) * conjg (mv_22) * sinal)))
!    gcac_2_2 = (imago * ( - (g /  &
!      sqrt (2.0_omega_prec))) * ((mv_21 * mu_22 * sinbe) +  &
!      (mv_22 * mu_21 * cosbe)))
!    g_yuk_ch1_sn1_3_c(1) = ((gcc * mass(15) * conjg (mu_12)) / (mass(24) &
!      * cosbe))
!    g_yuk_ch1_sn1_3_c(2) = ( - ((g * mv_11) / 2.0_omega_prec))
!    g_yuk_ch1_sn1_3(1) = conjg (g_yuk_ch1_sn1_3_c(2))
!    g_yuk_ch1_sn1_3(2) = conjg (g_yuk_ch1_sn1_3_c(1)) 
!    g_yuk_ch2_sn1_3_c(1) = ((gcc * mass(15) * conjg (mu_22)) / (mass(24) &
!      * cosbe))
!    g_yuk_ch2_sn1_3_c(2) = ( - ((g * mv_21) / 2.0_omega_prec))
!    g_yuk_ch2_sn1_3(1) = conjg (g_yuk_ch2_sn1_3_c(2))
!    g_yuk_ch2_sn1_3(2) = conjg (g_yuk_ch2_sn1_3_c(1))
!    g_yuk_ch1_sd1_1_3(1) = ((vckm_13 * gcc * mv_12 * mass(2) *  &
!      conjg (mix_sd311)) / (mass(24) * sinbe))
!    g_yuk_ch1_sd1_1_3(2) = (vckm_13 * gcc * (((conjg (mu_12) * mass(5) *  &
!      conjg (mix_sd312)) / (mass(24) * cosbe)) - (conjg (mu_11) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_sd311))))
!    g_yuk_ch1_sd1_1_3_c(1) = conjg (g_yuk_ch1_sd1_1_3(2))
!    g_yuk_ch1_sd1_1_3_c(2) = conjg (g_yuk_ch1_sd1_1_3(1))
!    g_yuk_ch1_su1_1_3(1) = (vckm_13 * gcc * (((conjg (mv_12) * mass(2) *  &
!      conjg (mix_su112)) / (mass(24) * sinbe)) - (conjg (mv_11) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_su111))))
!    g_yuk_ch1_su1_1_3(2) = ((vckm_13 * gcc * mu_12 * mass(5) *  &
!      conjg (mix_su111)) / (mass(24) * cosbe))
!    g_yuk_ch1_su1_1_3_c(1) = conjg (g_yuk_ch1_su1_1_3(2))
!    g_yuk_ch1_su1_1_3_c(2) = conjg (g_yuk_ch1_su1_1_3(1))
! end subroutine setup_parameters14
! subroutine setup_parameters15 ()
!    g_yuk_ch1_sd1_2_3(1) = ((vckm_23 * gcc * mv_12 * mass(4) *  &
!      conjg (mix_sd311)) / (mass(24) * sinbe))
!    g_yuk_ch1_sd1_2_3(2) = (vckm_23 * gcc * (((conjg (mu_12) * mass(5) *  &
!      conjg (mix_sd312)) / (mass(24) * cosbe)) - (conjg (mu_11) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_sd311))))
!    g_yuk_ch1_sd1_2_3_c(1) = conjg (g_yuk_ch1_sd1_2_3(2))
!    g_yuk_ch1_sd1_2_3_c(2) = conjg (g_yuk_ch1_sd1_2_3(1))
!    g_yuk_ch1_su1_2_3(1) = (vckm_23 * gcc * (((conjg (mv_12) * mass(4) *  &
!      conjg (mix_su212)) / (mass(24) * sinbe)) - (conjg (mv_11) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_su211))))
!    g_yuk_ch1_su1_2_3(2) = ((vckm_23 * gcc * mu_12 * mass(5) *  &
!      conjg (mix_su211)) / (mass(24) * cosbe))
!    g_yuk_ch1_su1_2_3_c(1) = conjg (g_yuk_ch1_su1_2_3(2))
!    g_yuk_ch1_su1_2_3_c(2) = conjg (g_yuk_ch1_su1_2_3(1))
!    g_yuk_ch1_sd1_3_3(1) = ((vckm_33 * gcc * mv_12 * mass(6) *  &
!      conjg (mix_sd311)) / (mass(24) * sinbe))
!    g_yuk_ch1_sd1_3_3(2) = (vckm_33 * gcc * (((conjg (mu_12) * mass(5) *  &
!      conjg (mix_sd312)) / (mass(24) * cosbe)) - (conjg (mu_11) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_sd311))))
!    g_yuk_ch1_sd1_3_3_c(1) = conjg (g_yuk_ch1_sd1_3_3(2))
!    g_yuk_ch1_sd1_3_3_c(2) = conjg (g_yuk_ch1_sd1_3_3(1))
!    g_yuk_ch1_su1_3_3(1) = (vckm_33 * gcc * (((conjg (mv_12) * mass(6) *  &
!      conjg (mix_su312)) / (mass(24) * sinbe)) - (conjg (mv_11) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_su311))))
!    g_yuk_ch1_su1_3_3(2) = ((vckm_33 * gcc * mu_12 * mass(5) *  &
!      conjg (mix_su311)) / (mass(24) * cosbe))
!    g_yuk_ch1_su1_3_3_c(1) = conjg (g_yuk_ch1_su1_3_3(2))
!    g_yuk_ch1_su1_3_3_c(2) = conjg (g_yuk_ch1_su1_3_3(1))
!    g_yuk_ch1_sd1_3_2(1) = ((vckm_32 * gcc * mv_12 * mass(6) *  &
!      conjg (mix_sd211)) / (mass(24) * sinbe))
!    g_yuk_ch1_sd1_3_2(2) = (vckm_32 * gcc * (((conjg (mu_12) * mass(3) *  &
!      conjg (mix_sd212)) / (mass(24) * cosbe)) - (conjg (mu_11) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_sd211))))
!    g_yuk_ch1_sd1_3_2_c(1) = conjg (g_yuk_ch1_sd1_3_2(2))
!    g_yuk_ch1_sd1_3_2_c(2) = conjg (g_yuk_ch1_sd1_3_2(1))
!    g_yuk_ch1_su1_3_2(1) = (vckm_32 * gcc * (((conjg (mv_12) * mass(6) *  &
!      conjg (mix_su312)) / (mass(24) * sinbe)) - (conjg (mv_11) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_su311))))
!    g_yuk_ch1_su1_3_2(2) = ((vckm_32 * gcc * mu_12 * mass(3) *  &
!      conjg (mix_su311)) / (mass(24) * cosbe))
!    g_yuk_ch1_su1_3_2_c(1) = conjg (g_yuk_ch1_su1_3_2(2))
!    g_yuk_ch1_su1_3_2_c(2) = conjg (g_yuk_ch1_su1_3_2(1))
!    g_yuk_ch1_sd1_3_1(1) = ((vckm_31 * gcc * mv_12 * mass(6) *  &
!      conjg (mix_sd111)) / (mass(24) * sinbe))
!    g_yuk_ch1_sd1_3_1(2) = (vckm_31 * gcc * (((conjg (mu_12) * mass(1) *  &
!      conjg (mix_sd112)) / (mass(24) * cosbe)) - (conjg (mu_11) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_sd111))))
!    g_yuk_ch1_sd1_3_1_c(1) = conjg (g_yuk_ch1_sd1_3_1(2))
!    g_yuk_ch1_sd1_3_1_c(2) = conjg (g_yuk_ch1_sd1_3_1(1))
!    g_yuk_ch1_su1_3_1(1) = (vckm_31 * gcc * (((conjg (mv_12) * mass(6) *  &
!      conjg (mix_su312)) / (mass(24) * sinbe)) - (conjg (mv_11) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_su311))))
!    g_yuk_ch1_su1_3_1(2) = ((vckm_31 * gcc * mu_12 * mass(1) *  &
!      conjg (mix_su311)) / (mass(24) * cosbe))
!    g_yuk_ch1_su1_3_1_c(1) = conjg (g_yuk_ch1_su1_3_1(2))
!    g_yuk_ch1_su1_3_1_c(2) = conjg (g_yuk_ch1_su1_3_1(1))
!    g_yuk_ch1_sd2_1_3(1) = ((vckm_13 * gcc * mv_12 * mass(2) *  &
!      conjg (mix_sd321)) / (mass(24) * sinbe))
!    g_yuk_ch1_sd2_1_3(2) = (vckm_13 * gcc * (((conjg (mu_12) * mass(5) *  &
!      conjg (mix_sd322)) / (mass(24) * cosbe)) - (conjg (mu_11) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_sd321))))
!    g_yuk_ch1_sd2_1_3_c(1) = conjg (g_yuk_ch1_sd2_1_3(2))
!    g_yuk_ch1_sd2_1_3_c(2) = conjg (g_yuk_ch1_sd2_1_3(1))
!    g_yuk_ch1_su2_1_3(1) = (vckm_13 * gcc * (((conjg (mv_12) * mass(2) *  &
!      conjg (mix_su122)) / (mass(24) * sinbe)) - (conjg (mv_11) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_su121))))
!    g_yuk_ch1_su2_1_3(2) = ((vckm_13 * gcc * mu_12 * mass(5) *  &
!      conjg (mix_su121)) / (mass(24) * cosbe))
!    g_yuk_ch1_su2_1_3_c(1) = conjg (g_yuk_ch1_su2_1_3(2))
!    g_yuk_ch1_su2_1_3_c(2) = conjg (g_yuk_ch1_su2_1_3(1))
!    g_yuk_ch1_sd2_2_3(1) = ((vckm_23 * gcc * mv_12 * mass(4) *  &
!      conjg (mix_sd321)) / (mass(24) * sinbe))
!    g_yuk_ch1_sd2_2_3(2) = (vckm_23 * gcc * (((conjg (mu_12) * mass(5) *  &
!      conjg (mix_sd322)) / (mass(24) * cosbe)) - (conjg (mu_11) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_sd321))))
!    g_yuk_ch1_sd2_2_3_c(1) = conjg (g_yuk_ch1_sd2_2_3(2))
!    g_yuk_ch1_sd2_2_3_c(2) = conjg (g_yuk_ch1_sd2_2_3(1))
!    g_yuk_ch1_su2_2_3(1) = (vckm_23 * gcc * (((conjg (mv_12) * mass(4) *  &
!      conjg (mix_su222)) / (mass(24) * sinbe)) - (conjg (mv_11) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_su221))))
!    g_yuk_ch1_su2_2_3(2) = ((vckm_23 * gcc * mu_12 * mass(5) *  &
!      conjg (mix_su221)) / (mass(24) * cosbe))
!    g_yuk_ch1_su2_2_3_c(1) = conjg (g_yuk_ch1_su2_2_3(2))
!    g_yuk_ch1_su2_2_3_c(2) = conjg (g_yuk_ch1_su2_2_3(1))
!    g_yuk_ch1_sd2_3_3(1) = ((vckm_33 * gcc * mv_12 * mass(6) *  &
!      conjg (mix_sd321)) / (mass(24) * sinbe))
!    g_yuk_ch1_sd2_3_3(2) = (vckm_33 * gcc * (((conjg (mu_12) * mass(5) *  &
!      conjg (mix_sd322)) / (mass(24) * cosbe)) - (conjg (mu_11) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_sd321))))
!    g_yuk_ch1_sd2_3_3_c(1) = conjg (g_yuk_ch1_sd2_3_3(2))
!    g_yuk_ch1_sd2_3_3_c(2) = conjg (g_yuk_ch1_sd2_3_3(1))
!    g_yuk_ch1_su2_3_3(1) = (vckm_33 * gcc * (((conjg (mv_12) * mass(6) *  &
!      conjg (mix_su322)) / (mass(24) * sinbe)) - (conjg (mv_11) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_su321))))
!    g_yuk_ch1_su2_3_3(2) = ((vckm_33 * gcc * mu_12 * mass(5) *  &
!      conjg (mix_su321)) / (mass(24) * cosbe))
!    g_yuk_ch1_su2_3_3_c(1) = conjg (g_yuk_ch1_su2_3_3(2))
!    g_yuk_ch1_su2_3_3_c(2) = conjg (g_yuk_ch1_su2_3_3(1))
!    g_yuk_ch1_sd2_3_2(1) = ((vckm_32 * gcc * mv_12 * mass(6) *  &
!      conjg (mix_sd221)) / (mass(24) * sinbe))
!    g_yuk_ch1_sd2_3_2(2) = (vckm_32 * gcc * (((conjg (mu_12) * mass(3) *  &
!      conjg (mix_sd222)) / (mass(24) * cosbe)) - (conjg (mu_11) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_sd221))))
!    g_yuk_ch1_sd2_3_2_c(1) = conjg (g_yuk_ch1_sd2_3_2(2))
!    g_yuk_ch1_sd2_3_2_c(2) = conjg (g_yuk_ch1_sd2_3_2(1))
!    g_yuk_ch1_su2_3_2(1) = (vckm_32 * gcc * (((conjg (mv_12) * mass(6) *  &
!      conjg (mix_su322)) / (mass(24) * sinbe)) - (conjg (mv_11) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_su321))))
!    g_yuk_ch1_su2_3_2(2) = ((vckm_32 * gcc * mu_12 * mass(3) *  &
!      conjg (mix_su321)) / (mass(24) * cosbe))
!    g_yuk_ch1_su2_3_2_c(1) = conjg (g_yuk_ch1_su2_3_3(2))
!    g_yuk_ch1_su2_3_2_c(2) = conjg (g_yuk_ch1_su2_3_3(1))
!    g_yuk_ch1_sd2_3_1(1) = ((vckm_31 * gcc * mv_12 * mass(6) *  &
!      conjg (mix_sd121)) / (mass(24) * sinbe))
!    g_yuk_ch1_sd2_3_1(2) = (vckm_31 * gcc * (((conjg (mu_12) * mass(1) *  &
!      conjg (mix_sd122)) / (mass(24) * cosbe)) - (conjg (mu_11) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_sd121))))
!    g_yuk_ch1_sd2_3_1_c(1) = conjg (g_yuk_ch1_sd2_3_1(2))
!    g_yuk_ch1_sd2_3_1_c(2) = conjg (g_yuk_ch1_sd2_3_1(1))
!    g_yuk_ch1_su2_3_1(1) = (vckm_31 * gcc * (((conjg (mv_12) * mass(6) *  &
!      conjg (mix_su322)) / (mass(24) * sinbe)) - (conjg (mv_11) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_su321))))
!    g_yuk_ch1_su2_3_1(2) = ((vckm_31 * gcc * mu_12 * mass(1) *  &
!      conjg (mix_su321)) / (mass(24) * cosbe))
!    g_yuk_ch1_su2_3_1_c(1) = conjg (g_yuk_ch1_su2_3_1(2))
!    g_yuk_ch1_su2_3_1_c(2) = conjg (g_yuk_ch1_su2_3_1(1))
!    g_yuk_ch2_sd1_1_3(1) = ((vckm_13 * gcc * mv_22 * mass(2) *  &
!      conjg (mix_sd311)) / (mass(24) * sinbe))
!    g_yuk_ch2_sd1_1_3(2) = (vckm_13 * gcc * (((conjg (mu_22) * mass(5) *  &
!      conjg (mix_sd312)) / (mass(24) * cosbe)) - (conjg (mu_21) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_sd311))))
!    g_yuk_ch2_sd1_1_3_c(1) = conjg (g_yuk_ch2_sd1_1_3(2))
!    g_yuk_ch2_sd1_1_3_c(2) = conjg (g_yuk_ch2_sd1_1_3(1))
!    g_yuk_ch2_su1_1_3(1) = (vckm_13 * gcc * (((conjg (mv_22) * mass(2) *  &
!      conjg (mix_su112)) / (mass(24) * sinbe)) - (conjg (mv_21) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_su111))))
!    g_yuk_ch2_su1_1_3(2) = ((vckm_13 * gcc * mu_22 * mass(5) *  &
!      conjg (mix_su111)) / (mass(24) * cosbe))
!    g_yuk_ch2_su1_1_3_c(1) = conjg (g_yuk_ch2_su1_1_3(2))
!    g_yuk_ch2_su1_1_3_c(2) = conjg (g_yuk_ch2_su1_1_3(1))
!    g_yuk_ch2_sd1_2_3(1) = ((vckm_23 * gcc * mv_22 * mass(4) *  &
!      conjg (mix_sd311)) / (mass(24) * sinbe))
!    g_yuk_ch2_sd1_2_3(2) = (vckm_23 * gcc * (((conjg (mu_22) * mass(5) *  &
!      conjg (mix_sd312)) / (mass(24) * cosbe)) - (conjg (mu_21) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_sd311))))
!    g_yuk_ch2_sd1_2_3_c(1) = conjg (g_yuk_ch2_sd1_2_3(2))
!    g_yuk_ch2_sd1_2_3_c(2) = conjg (g_yuk_ch2_sd1_2_3(1))
!    g_yuk_ch2_su1_2_3(1) = (vckm_23 * gcc * (((conjg (mv_22) * mass(4) *  &
!      conjg (mix_su212)) / (mass(24) * sinbe)) - (conjg (mv_21) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_su211))))
!    g_yuk_ch2_su1_2_3(2) = ((vckm_23 * gcc * mu_22 * mass(5) *  &
!      conjg (mix_su211)) / (mass(24) * cosbe))
!    g_yuk_ch2_su1_2_3_c(1) = conjg (g_yuk_ch2_su1_2_3(2))
!    g_yuk_ch2_su1_2_3_c(2) = conjg (g_yuk_ch2_su1_2_3(1))
!    g_yuk_ch2_sd1_3_3(1) = ((vckm_33 * gcc * mv_22 * mass(6) *  &
!      conjg (mix_sd311)) / (mass(24) * sinbe))
!    g_yuk_ch2_sd1_3_3(2) = (vckm_33 * gcc * (((conjg (mu_22) * mass(5) *  &
!      conjg (mix_sd312)) / (mass(24) * cosbe)) - (conjg (mu_21) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_sd311))))
!    g_yuk_ch2_sd1_3_3_c(1) = conjg (g_yuk_ch2_sd1_3_3(2))
!    g_yuk_ch2_sd1_3_3_c(2) = conjg (g_yuk_ch2_sd1_3_3(1))
!    g_yuk_ch2_su1_3_3(1) = (vckm_33 * gcc * (((conjg (mv_22) * mass(6) *  &
!      conjg (mix_su312)) / (mass(24) * sinbe)) - (conjg (mv_21) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_su311))))
!    g_yuk_ch2_su1_3_3(2) = ((vckm_33 * gcc * mu_22 * mass(5) *  &
!      conjg (mix_su311)) / (mass(24) * cosbe))
!    g_yuk_ch2_su1_3_3_c(1) = conjg (g_yuk_ch2_su1_3_3(2))
!    g_yuk_ch2_su1_3_3_c(2) = conjg (g_yuk_ch2_su1_3_3(1))
!    g_yuk_ch2_sd1_3_2(1) = ((vckm_32 * gcc * mv_22 * mass(6) *  &
!      conjg (mix_sd211)) / (mass(24) * sinbe))
!    g_yuk_ch2_sd1_3_2(2) = (vckm_32 * gcc * (((conjg (mu_22) * mass(3) *  &
!      conjg (mix_sd212)) / (mass(24) * cosbe)) - (conjg (mu_21) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_sd211))))
!    g_yuk_ch2_sd1_3_2_c(1) = conjg (g_yuk_ch2_sd1_3_2(2))
!    g_yuk_ch2_sd1_3_2_c(2) = conjg (g_yuk_ch2_sd1_3_2(1))
!    g_yuk_ch2_su1_3_2(1) = (vckm_32 * gcc * (((conjg (mv_22) * mass(6) *  &
!      conjg (mix_su312)) / (mass(24) * sinbe)) - (conjg (mv_21) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_su311))))
!    g_yuk_ch2_su1_3_2(2) = ((vckm_32 * gcc * mu_22 * mass(3) *  &
!      conjg (mix_su311)) / (mass(24) * cosbe))
!    g_yuk_ch2_su1_3_2_c(1) = conjg (g_yuk_ch2_su1_3_2(2))
!    g_yuk_ch2_su1_3_2_c(2) = conjg (g_yuk_ch2_su1_3_2(1))
!    g_yuk_ch2_sd1_3_1(1) = ((vckm_31 * gcc * mv_22 * mass(6) *  &
!      conjg (mix_sd111)) / (mass(24) * sinbe))
!    g_yuk_ch2_sd1_3_1(2) = (vckm_31 * gcc * (((conjg (mu_22) * mass(1) *  &
!      conjg (mix_sd112)) / (mass(24) * cosbe)) - (conjg (mu_21) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_sd111))))
!    g_yuk_ch2_sd1_3_1_c(1) = conjg (g_yuk_ch2_sd1_3_1(2))
!    g_yuk_ch2_sd1_3_1_c(2) = conjg (g_yuk_ch2_sd1_3_1(1))
!    g_yuk_ch2_su1_3_1(1) = (vckm_31 * gcc * (((conjg (mv_22) * mass(6) *  &
!      conjg (mix_su312)) / (mass(24) * sinbe)) - (conjg (mv_21) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_su311))))
!    g_yuk_ch2_su1_3_1(2) = ((vckm_31 * gcc * mu_22 * mass(1) *  &
!      conjg (mix_su311)) / (mass(24) * cosbe))
!    g_yuk_ch2_su1_3_1_c(1) = conjg (g_yuk_ch2_su1_3_1(2))
!    g_yuk_ch2_su1_3_1_c(2) = conjg (g_yuk_ch2_su1_3_1(1))
!    g_yuk_ch2_sd2_1_3(1) = ((vckm_13 * gcc * mv_22 * mass(2) *  &
!      conjg (mix_sd321)) / (mass(24) * sinbe))
!    g_yuk_ch2_sd2_1_3(2) = (vckm_13 * gcc * (((conjg (mu_22) * mass(5) *  &
!      conjg (mix_sd322)) / (mass(24) * cosbe)) - (conjg (mu_21) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_sd321))))
!    g_yuk_ch2_sd2_1_3_c(1) = conjg (g_yuk_ch2_sd2_1_3(2))
!    g_yuk_ch2_sd2_1_3_c(2) = conjg (g_yuk_ch2_sd2_1_3(1))
!    g_yuk_ch2_su2_1_3(1) = (vckm_13 * gcc * (((conjg (mv_22) * mass(2) *  &
!      conjg (mix_su122)) / (mass(24) * sinbe)) - (conjg (mv_21) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_su121))))
!    g_yuk_ch2_su2_1_3(2) = ((vckm_13 * gcc * mu_22 * mass(5) *  &
!      conjg (mix_su121)) / (mass(24) * cosbe))
!    g_yuk_ch2_su2_1_3_c(1) = conjg (g_yuk_ch2_su2_1_3(2))
!    g_yuk_ch2_su2_1_3_c(2) = conjg (g_yuk_ch2_su2_1_3(1))
!    g_yuk_ch2_sd2_2_3(1) = ((vckm_23 * gcc * mv_22 * mass(4) *  &
!      conjg (mix_sd321)) / (mass(24) * sinbe))
!    g_yuk_ch2_sd2_2_3(2) = (vckm_23 * gcc * (((conjg (mu_22) * mass(5) *  &
!      conjg (mix_sd322)) / (mass(24) * cosbe)) - (conjg (mu_21) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_sd321))))
!    g_yuk_ch2_sd2_2_3_c(1) = conjg (g_yuk_ch2_sd2_2_3(2))
!    g_yuk_ch2_sd2_2_3_c(2) = conjg (g_yuk_ch2_sd2_2_3(1))
!    g_yuk_ch2_su2_2_3(1) = (vckm_23 * gcc * (((conjg (mv_22) * mass(4) *  &
!      conjg (mix_su222)) / (mass(24) * sinbe)) - (conjg (mv_21) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_su221))))
!    g_yuk_ch2_su2_2_3(2) = ((vckm_23 * gcc * mu_22 * mass(5) *  &
!      conjg (mix_su221)) / (mass(24) * cosbe))
!    g_yuk_ch2_su2_2_3_c(1) = conjg (g_yuk_ch2_su2_2_3(2))
!    g_yuk_ch2_su2_2_3_c(2) = conjg (g_yuk_ch2_su2_2_3(1))
!    g_yuk_ch2_sd2_3_3(1) = ((vckm_33 * gcc * mv_22 * mass(6) *  &
!      conjg (mix_sd321)) / (mass(24) * sinbe))
!    g_yuk_ch2_sd2_3_3(2) = (vckm_33 * gcc * (((conjg (mu_22) * mass(5) *  &
!      conjg (mix_sd322)) / (mass(24) * cosbe)) - (conjg (mu_21) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_sd321))))
!    g_yuk_ch2_sd2_3_3_c(1) = conjg (g_yuk_ch2_sd2_3_3(2))
!    g_yuk_ch2_sd2_3_3_c(2) = conjg (g_yuk_ch2_sd2_3_3(1))
!    g_yuk_ch2_su2_3_3(1) = (vckm_33 * gcc * (((conjg (mv_22) * mass(6) *  &
!      conjg (mix_su322)) / (mass(24) * sinbe)) - (conjg (mv_21) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_su321))))
!    g_yuk_ch2_su2_3_3(2) = ((vckm_33 * gcc * mu_22 * mass(5) *  &
!      conjg (mix_su321)) / (mass(24) * cosbe))
!    g_yuk_ch2_su2_3_3_c(1) = conjg (g_yuk_ch2_su2_3_3(2))
!    g_yuk_ch2_su2_3_3_c(2) = conjg (g_yuk_ch2_su2_3_3(1))
!    g_yuk_ch2_sd2_3_2(1) = ((vckm_32 * gcc * mv_22 * mass(6) *  &
!      conjg (mix_sd221)) / (mass(24) * sinbe))
!    g_yuk_ch2_sd2_3_2(2) = (vckm_32 * gcc * (((conjg (mu_22) * mass(3) *  &
!      conjg (mix_sd222)) / (mass(24) * cosbe)) - (conjg (mu_21) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_sd221))))
!    g_yuk_ch2_sd2_3_2_c(1) = conjg (g_yuk_ch2_sd2_3_2(2))
!    g_yuk_ch2_sd2_3_2_c(2) = conjg (g_yuk_ch2_sd2_3_2(1))
!    g_yuk_ch2_su2_3_2(1) = (vckm_32 * gcc * (((conjg (mv_22) * mass(6) *  &
!      conjg (mix_su322)) / (mass(24) * sinbe)) - (conjg (mv_21) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_su321))))
!    g_yuk_ch2_su2_3_2(2) = ((vckm_32 * gcc * mu_22 * mass(3) *  &
!      conjg (mix_su321)) / (mass(24) * cosbe))
!    g_yuk_ch2_su2_3_2_c(1) = conjg (g_yuk_ch2_su2_3_2(2))
!    g_yuk_ch2_su2_3_2_c(2) = conjg (g_yuk_ch2_su2_3_2(1))
!    g_yuk_ch2_sd2_3_1(1) = ((vckm_31 * gcc * mv_22 * mass(6) *  &
!      conjg (mix_sd121)) / (mass(24) * sinbe))
!    g_yuk_ch2_sd2_3_1(2) = (vckm_31 * gcc * (((conjg (mu_22) * mass(1) *  &
!      conjg (mix_sd122)) / (mass(24) * cosbe)) - (conjg (mu_21) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_sd121))))
!    g_yuk_ch2_sd2_3_1_c(1) = conjg (g_yuk_ch2_sd2_3_1(2))
!    g_yuk_ch2_sd2_3_1_c(2) = conjg (g_yuk_ch2_sd2_3_1(1))
!    g_yuk_ch2_su2_3_1(1) = (vckm_31 * gcc * (((conjg (mv_22) * mass(6) *  &
!      conjg (mix_su322)) / (mass(24) * sinbe)) - (conjg (mv_21) *  &
!      sqrt (2.0_omega_prec) * conjg (mix_su321))))
!    g_yuk_ch2_su2_3_1(2) = ((vckm_31 * gcc * mu_22 * mass(1) *  &
!      conjg (mix_su321)) / (mass(24) * cosbe))
!    g_yuk_ch2_su2_3_1_c(1) = conjg (g_yuk_ch2_su2_3_1(2))
!    g_yuk_ch2_su2_3_1_c(2) = conjg (g_yuk_ch2_su2_3_1(1))
! end subroutine setup_parameters15
! subroutine setup_parameters16 ()
!    g_yuk_n1_sl1_3(1) = ( - (gcc * ((2.0_omega_prec * ( -  &
!      q_lep) * conjg (mn_11) * (sinthw / costhw) * mix_sl312) &
!      + ((conjg (mn_13) * mass(15) * mix_sl311) / (mass(24) * cosbe)))))
!    g_yuk_n1_sl1_3(2) = (gcc * ((1.0_omega_prec * (mn_12 + (1.0_omega_prec *  &
!      (sinthw / costhw) * mn_11)) * mix_sl311) - ( &
!      (mn_13 * mass(15) * mix_sl312) / (mass(24) * cosbe))))
!    g_yuk_n1_sl1_3_c(1) = conjg (g_yuk_n1_sl1_3(2))
!    g_yuk_n1_sl1_3_c(2) = conjg (g_yuk_n1_sl1_3(1))
!    g_yuk_n1_su1_3(1) = ( - (gcc * ((2.0_omega_prec * ( -  &
!      q_up) * conjg (mn_11) *  &
!      (sinthw / costhw) * mix_su312) + ((conjg (mn_14) * mass(6) * mix_su311) /  &
!      (mass(24) * sinbe)))))
!    g_yuk_n1_su1_3(2) = (gcc * (((-1.0_omega_prec) * (mn_12 + ( &
!      (1.0_omega_prec / 3.0_omega_prec) *  &
!      (sinthw / costhw) * mn_11)) * mix_su311) - ( &
!      (mn_14 * mass(6) * mix_su312) / (mass(24) * sinbe))))
!    g_yuk_n1_su1_3_c(1) = conjg (g_yuk_n1_su1_3(2))
!    g_yuk_n1_su1_3_c(2) = conjg (g_yuk_n1_su1_3(1))
!    g_yuk_n1_sd1_3(1) = ( - (gcc * ((2.0_omega_prec * ( - ( -  &
!      (1.0_omega_prec / 3.0_omega_prec))) * conjg (mn_11) *  &
!      (sinthw / costhw) * mix_sd312) + ((conjg (mn_13) * mass(5) * mix_sd311) /  &
!      (mass(24) * cosbe)))))
!    g_yuk_n1_sd1_3(2) = (gcc * ((1.0_omega_prec * (mn_12 + (( -  &
!      (1.0_omega_prec / 3.0_omega_prec)) *  &
!      (sinthw / costhw) * mn_11)) * mix_sd311) - ( &
!      (mn_13 * mass(5) * mix_sd312) / (mass(24) * cosbe))))
!    g_yuk_n1_sd1_3_c(1) = conjg (g_yuk_n1_sd1_3(2))
!    g_yuk_n1_sd1_3_c(2) = conjg (g_yuk_n1_sd1_3(1))
!    g_yuk_n2_sl1_3(1) = ( - (gcc * ((2.0_omega_prec * ( -  &
!      q_lep) * conjg (mn_21) * (sinthw / costhw) * mix_sl312) + ( &
!      (conjg (mn_23) * mass(15) * mix_sl311) / (mass(24) * cosbe)))))
!    g_yuk_n2_sl1_3(2) = (gcc * ((1.0_omega_prec * (mn_22 + (1.0_omega_prec *  &
!      (sinthw / costhw) * mn_21)) * mix_sl311) - ( &
!      (mn_23 * mass(15) * mix_sl312) / (mass(24) * cosbe))))
!    g_yuk_n2_sl1_3_c(1) = conjg (g_yuk_n2_sl1_3(2))
!    g_yuk_n2_sl1_3_c(2) = conjg (g_yuk_n2_sl1_3(1))
!    g_yuk_n2_su1_3(1) = ( - (gcc * ((2.0_omega_prec * ( -  &
!      q_up) * conjg (mn_21) *  &
!      (sinthw / costhw) * mix_su312) + ((conjg (mn_24) * mass(6) * mix_su311) /  &
!      (mass(24) * sinbe)))))
!    g_yuk_n2_su1_3(2) = (gcc * (((-1.0_omega_prec) * (mn_22 + ( &
!      (1.0_omega_prec / 3.0_omega_prec) *  &
!      (sinthw / costhw) * mn_21)) * mix_su311) - ( &
!      (mn_24 * mass(6) * mix_su312) / (mass(24) * sinbe))))
!    g_yuk_n2_su1_3_c(1) = conjg (g_yuk_n2_su1_3(2))
!    g_yuk_n2_su1_3_c(2) = conjg (g_yuk_n2_su1_3(1))
!    g_yuk_n2_sd1_3(1) = ( - (gcc * ((2.0_omega_prec * ( - ( -  &
!      (1.0_omega_prec / 3.0_omega_prec))) * conjg (mn_21) *  &
!      (sinthw / costhw) * mix_sd312) + ((conjg (mn_23) * mass(5) * mix_sd311) /  &
!      (mass(24) * cosbe)))))
!    g_yuk_n2_sd1_3(2) = (gcc * ((1.0_omega_prec * (mn_22 + (( -  &
!      (1.0_omega_prec / 3.0_omega_prec)) *  &
!      (sinthw / costhw) * mn_21)) * mix_sd311) - ( &
!      (mn_23 * mass(5) * mix_sd312) / (mass(24) * cosbe))))
!    g_yuk_n2_sd1_3_c(1) = conjg (g_yuk_n2_sd1_3(2))
!    g_yuk_n2_sd1_3_c(2) = conjg (g_yuk_n2_sd1_3(1))
!    g_yuk_n3_sl1_3(1) = ( - (gcc * ((2.0_omega_prec * ( -  &
!      q_lep) * conjg (mn_31) * (sinthw / costhw) * mix_sl312) + ( &
!      (conjg (mn_33) * mass(15) * mix_sl311) / (mass(24) * cosbe)))))
!    g_yuk_n3_sl1_3(2) = (gcc * ((1.0_omega_prec * (mn_32 + (1.0_omega_prec *  &
!      (sinthw / costhw) * mn_31)) * mix_sl311) - ( &
!      (mn_33 * mass(15) * mix_sl312) / (mass(24) * cosbe))))
!    g_yuk_n3_sl1_3_c(1) = conjg (g_yuk_n3_sl1_3(2))
!    g_yuk_n3_sl1_3_c(2) = conjg (g_yuk_n3_sl1_3(1))
!    g_yuk_n3_su1_3(1) = ( - (gcc * ((2.0_omega_prec * ( -  &
!      q_up) * conjg (mn_31) *  &
!      (sinthw / costhw) * mix_su312) + ((conjg (mn_34) * mass(6) * mix_su311) /  &
!      (mass(24) * sinbe)))))
!    g_yuk_n3_su1_3(2) = (gcc * (((-1.0_omega_prec) * (mn_32 + ( &
!      (1.0_omega_prec / 3.0_omega_prec) *  &
!      (sinthw / costhw) * mn_31)) * mix_su311) - ( &
!      (mn_34 * mass(6) * mix_su312) / (mass(24) * sinbe))))
!    g_yuk_n3_su1_3_c(1) = conjg (g_yuk_n3_su1_3(2))
!    g_yuk_n3_su1_3_c(2) = conjg (g_yuk_n3_su1_3(1))
!    g_yuk_n3_sd1_3(1) = ( - (gcc * ((2.0_omega_prec * ( - ( -  &
!      (1.0_omega_prec / 3.0_omega_prec))) * conjg (mn_31) *  &
!      (sinthw / costhw) * mix_sd312) + ((conjg (mn_33) * mass(5) * mix_sd311) /  &
!      (mass(24) * cosbe)))))
!    g_yuk_n3_sd1_3(2) = (gcc * ((1.0_omega_prec * (mn_32 + (( -  &
!      (1.0_omega_prec / 3.0_omega_prec)) *  &
!      (sinthw / costhw) * mn_31)) * mix_sd311) - ( &
!      (mn_33 * mass(5) * mix_sd312) / (mass(24) * cosbe))))
!    g_yuk_n3_sd1_3_c(1) = conjg (g_yuk_n3_sd1_3(2))
!    g_yuk_n3_sd1_3_c(2) = conjg (g_yuk_n3_sd1_3(1))
!    g_yuk_n4_sl1_3(1) = ( - (gcc * ((2.0_omega_prec * ( -  &
!      q_lep) * conjg (mn_41) * (sinthw / costhw) * mix_sl312) + ( &
!      (conjg (mn_43) * mass(15) * mix_sl311) / (mass(24) * cosbe)))))
!    g_yuk_n4_sl1_3(2) = (gcc * ((1.0_omega_prec * (mn_42 + (1.0_omega_prec *  &
!      (sinthw / costhw) * mn_41)) * mix_sl311) - ( &
!      (mn_43 * mass(15) * mix_sl312) / (mass(24) * cosbe))))
!    g_yuk_n4_sl1_3_c(1) = conjg (g_yuk_n4_sl1_3(2))
!    g_yuk_n4_sl1_3_c(2) = conjg (g_yuk_n4_sl1_3(1))
!    g_yuk_n4_su1_3(1) = ( - (gcc * ((2.0_omega_prec * ( -  &
!      q_up) * conjg (mn_41) *  &
!      (sinthw / costhw) * mix_su312) + ((conjg (mn_44) * mass(6) * mix_su311) /  &
!      (mass(24) * sinbe)))))
!    g_yuk_n4_su1_3(2) = (gcc * (((-1.0_omega_prec) * (mn_42 + ( &
!      (1.0_omega_prec / 3.0_omega_prec) *  &
!      (sinthw / costhw) * mn_41)) * mix_su311) - ( &
!      (mn_44 * mass(6) * mix_su312) / (mass(24) * sinbe))))
!    g_yuk_n4_su1_3_c(1) = conjg (g_yuk_n4_su1_3(2))
!    g_yuk_n4_su1_3_c(2) = conjg (g_yuk_n4_su1_3(1))
!    g_yuk_n4_sd1_3(1) = ( - (gcc * ((2.0_omega_prec * ( - ( -  &
!      (1.0_omega_prec / 3.0_omega_prec))) * conjg (mn_41) *  &
!      (sinthw / costhw) * mix_sd312) + ((conjg (mn_43) * mass(5) * mix_sd311) /  &
!      (mass(24) * cosbe)))))
!    g_yuk_n4_sd1_3(2) = (gcc * ((1.0_omega_prec * (mn_42 + (( -  &
!      (1.0_omega_prec / 3.0_omega_prec)) *  &
!      (sinthw / costhw) * mn_41)) * mix_sd311) - ( &
!      (mn_43 * mass(5) * mix_sd312) / (mass(24) * cosbe))))
!    g_yuk_n4_sd1_3_c(1) = conjg (g_yuk_n4_sd1_3(2))
!    g_yuk_n4_sd1_3_c(2) = conjg (g_yuk_n4_sd1_3(1))
!    g_yuk_n1_sl2_3(1) = ( - (gcc * ((2.0_omega_prec * ( -  &
!      q_lep) * conjg (mn_11) * (sinthw / costhw) * mix_sl322) + ( &
!      (conjg (mn_13) * mass(15) * mix_sl321) / (mass(24) * cosbe)))))
!    g_yuk_n1_sl2_3(2) = (gcc * ((1.0_omega_prec * (mn_12 + (1.0_omega_prec *  &
!      (sinthw / costhw) * mn_11)) * mix_sl321) - ( &
!      (mn_13 * mass(15) * mix_sl322) / (mass(24) * cosbe))))
!    g_yuk_n1_sl2_3_c(1) = conjg (g_yuk_n1_sl2_3(2))
!    g_yuk_n1_sl2_3_c(2) = conjg (g_yuk_n1_sl2_3(1))
!    g_yuk_n1_su2_3(1) = ( - (gcc * ((2.0_omega_prec * ( -  &
!      q_up) * conjg (mn_11) *  &
!      (sinthw / costhw) * mix_su322) + ((conjg (mn_14) * mass(6) * mix_su321) /  &
!      (mass(24) * sinbe)))))
!    g_yuk_n1_su2_3(2) = (gcc * (((-1.0_omega_prec) * (mn_12 + ( &
!      (1.0_omega_prec / 3.0_omega_prec) *  &
!      (sinthw / costhw) * mn_11)) * mix_su321) - ( &
!      (mn_14 * mass(6) * mix_su322) / (mass(24) * sinbe))))
!    g_yuk_n1_su2_3_c(1) = conjg (g_yuk_n1_su2_3(2))
!    g_yuk_n1_su2_3_c(2) = conjg (g_yuk_n1_su2_3(1))
!    g_yuk_n1_sd2_3(1) = ( - (gcc * ((2.0_omega_prec * ( - ( -  &
!      (1.0_omega_prec / 3.0_omega_prec))) * conjg (mn_11) *  &
!      (sinthw / costhw) * mix_sd322) + ((conjg (mn_13) * mass(5) * mix_sd321) /  &
!      (mass(24) * cosbe)))))
!    g_yuk_n1_sd2_3(2) = (gcc * ((1.0_omega_prec * (mn_12 + (( -  &
!      (1.0_omega_prec / 3.0_omega_prec)) *  &
!      (sinthw / costhw) * mn_11)) * mix_sd321) - ( &
!      (mn_13 * mass(5) * mix_sd322) / (mass(24) * cosbe))))
!    g_yuk_n1_sd2_3_c(1) = conjg (g_yuk_n1_sd2_3(2))
!    g_yuk_n1_sd2_3_c(2) = conjg (g_yuk_n1_sd2_3(1))
!    g_yuk_n2_sl2_3(1) = ( - (gcc * ((2.0_omega_prec * ( -  &
!      q_lep) * conjg (mn_21) * (sinthw / costhw) * mix_sl322) + ( &
!      (conjg (mn_23) * mass(15) * mix_sl321) / (mass(24) * cosbe)))))
!    g_yuk_n2_sl2_3(2) = (gcc * ((1.0_omega_prec * (mn_22 + (1.0_omega_prec *  &
!      (sinthw / costhw) * mn_21)) * mix_sl321) - ( &
!      (mn_23 * mass(15) * mix_sl322) / (mass(24) * cosbe))))
!    g_yuk_n2_sl2_3_c(1) = conjg (g_yuk_n2_sl2_3(2))
!    g_yuk_n2_sl2_3_c(2) = conjg (g_yuk_n2_sl2_3(1))
!    g_yuk_n2_su2_3(1) = ( - (gcc * ((2.0_omega_prec * ( -  &
!      q_up) * conjg (mn_21) *  &
!      (sinthw / costhw) * mix_su322) + ((conjg (mn_24) * mass(6) * mix_su321) /  &
!      (mass(24) * sinbe)))))
!    g_yuk_n2_su2_3(2) = (gcc * (((-1.0_omega_prec) * (mn_22 + ( &
!      (1.0_omega_prec / 3.0_omega_prec) *  &
!      (sinthw / costhw) * mn_21)) * mix_su321) - ( &
!      (mn_24 * mass(6) * mix_su322) / (mass(24) * sinbe))))
!    g_yuk_n2_su2_3_c(1) = conjg (g_yuk_n2_su2_3(2))
!    g_yuk_n2_su2_3_c(2) = conjg (g_yuk_n2_su2_3(1))
!    g_yuk_n2_sd2_3(1) = ( - (gcc * ((2.0_omega_prec * ( - ( -  &
!      (1.0_omega_prec / 3.0_omega_prec))) * conjg (mn_21) *  &
!      (sinthw / costhw) * mix_sd322) + ((conjg (mn_23) * mass(5) * mix_sd321) /  &
!      (mass(24) * cosbe)))))
!    g_yuk_n2_sd2_3(2) = (gcc * ((1.0_omega_prec * (mn_22 + (( -  &
!      (1.0_omega_prec / 3.0_omega_prec)) *  &
!      (sinthw / costhw) * mn_21)) * mix_sd321) - ( &
!      (mn_23 * mass(5) * mix_sd322) / (mass(24) * cosbe))))
!    g_yuk_n2_sd2_3_c(1) = conjg (g_yuk_n2_sd2_3(2))
!    g_yuk_n2_sd2_3_c(2) = conjg (g_yuk_n2_sd2_3(1))
!    g_yuk_n3_sl2_3(1) = ( - (gcc * ((2.0_omega_prec * ( -  &
!      q_lep) * conjg (mn_31) * (sinthw / costhw) * mix_sl322) + ( &
!      (conjg (mn_33) * mass(15) * mix_sl321) / (mass(24) * cosbe)))))
!    g_yuk_n3_sl2_3(2) = (gcc * ((1.0_omega_prec * (mn_32 + (1.0_omega_prec *  &
!      (sinthw / costhw) * mn_31)) * mix_sl321) - ( &
!      (mn_33 * mass(15) * mix_sl322) / (mass(24) * cosbe))))
!    g_yuk_n3_sl2_3_c(1) = conjg (g_yuk_n3_sl2_3(2))
!    g_yuk_n3_sl2_3_c(2) = conjg (g_yuk_n3_sl2_3(1))
!    g_yuk_n3_su2_3(1) = ( - (gcc * ((2.0_omega_prec * ( -  &
!      q_up) * conjg (mn_31) *  &
!      (sinthw / costhw) * mix_su322) + ((conjg (mn_34) * mass(6) * mix_su321) /  &
!      (mass(24) * sinbe)))))
!    g_yuk_n3_su2_3(2) = (gcc * (((-1.0_omega_prec) * (mn_32 + ( &
!      (1.0_omega_prec / 3.0_omega_prec) *  &
!      (sinthw / costhw) * mn_31)) * mix_su321) - ( &
!      (mn_34 * mass(6) * mix_su322) / (mass(24) * sinbe))))
!    g_yuk_n3_su2_3_c(1) = conjg (g_yuk_n3_su2_3(2))
!    g_yuk_n3_su2_3_c(2) = conjg (g_yuk_n3_su2_3(1))
!    g_yuk_n3_sd2_3(1) = ( - (gcc * ((2.0_omega_prec * ( - ( -  &
!      (1.0_omega_prec / 3.0_omega_prec))) * conjg (mn_31) *  &
!      (sinthw / costhw) * mix_sd322) + ((conjg (mn_33) * mass(5) * mix_sd321) /  &
!      (mass(24) * cosbe)))))
!    g_yuk_n3_sd2_3(2) = (gcc * ((1.0_omega_prec * (mn_32 + (( -  &
!      (1.0_omega_prec / 3.0_omega_prec)) *  &
!      (sinthw / costhw) * mn_31)) * mix_sd321) - ( &
!      (mn_33 * mass(5) * mix_sd322) / (mass(24) * cosbe))))
!    g_yuk_n3_sd2_3_c(1) = conjg (g_yuk_n3_sd2_3(2))
!    g_yuk_n3_sd2_3_c(2) = conjg (g_yuk_n3_sd2_3(1))
!    g_yuk_n4_sl2_3(1) = ( - (gcc * ((2.0_omega_prec * ( -  &
!      q_lep) * conjg (mn_41) * (sinthw / costhw) * mix_sl322) + ( &
!      (conjg (mn_43) * mass(15) * mix_sl321) / (mass(24) * cosbe)))))
!    g_yuk_n4_sl2_3(2) = (gcc * ((1.0_omega_prec * (mn_42 + (1.0_omega_prec *  &
!      (sinthw / costhw) * mn_41)) * mix_sl321) - ( &
!      (mn_43 * mass(15) * mix_sl322) / (mass(24) * cosbe))))
!    g_yuk_n4_sl2_3_c(1) = conjg (g_yuk_n4_sl2_3(2))
!    g_yuk_n4_sl2_3_c(2) = conjg (g_yuk_n4_sl2_3(1))
!    g_yuk_n4_su2_3(1) = ( - (gcc * ((2.0_omega_prec * ( -  &
!      q_up) * conjg (mn_41) *  &
!      (sinthw / costhw) * mix_su322) + ((conjg (mn_44) * mass(6) * mix_su321) /  &
!      (mass(24) * sinbe)))))
!    g_yuk_n4_su2_3(2) = (gcc * (((-1.0_omega_prec) * (mn_42 + ( &
!      (1.0_omega_prec / 3.0_omega_prec) *  &
!      (sinthw / costhw) * mn_41)) * mix_su321) - ( &
!      (mn_44 * mass(6) * mix_su322) / (mass(24) * sinbe))))
!    g_yuk_n4_su2_3_c(1) = conjg (g_yuk_n4_su2_3(2))
!    g_yuk_n4_su2_3_c(2) = conjg (g_yuk_n4_su2_3(1))
!    g_yuk_n4_sd2_3(1) = ( - (gcc * ((2.0_omega_prec * ( - ( -  &
!      (1.0_omega_prec / 3.0_omega_prec))) * conjg (mn_41) *  &
!      (sinthw / costhw) * mix_sd322) + ((conjg (mn_43) * mass(5) * mix_sd321) /  &
!      (mass(24) * cosbe)))))
!    g_yuk_n4_sd2_3(2) = (gcc * ((1.0_omega_prec * (mn_42 + (( -  &
!      (1.0_omega_prec / 3.0_omega_prec)) *  &
!      (sinthw / costhw) * mn_41)) * mix_sd321) - ( &
!      (mn_43 * mass(5) * mix_sd322) / (mass(24) * cosbe))))
!    g_yuk_n4_sd2_3_c(1) = conjg (g_yuk_n4_sd2_3(2))
!    g_yuk_n4_sd2_3_c(2) = conjg (g_yuk_n4_sd2_3(1))
!    g_yuk_gsu1_3(1) = ( - (mix_su312 * (gs / sqrt (2.0_omega_prec))))
!    g_yuk_gsu1_3(2) = (mix_su311 * (gs / sqrt (2.0_omega_prec)))
!    g_yuk_gsu1_3_c(1) = conjg (g_yuk_gsu1_3(2))
!    g_yuk_gsu1_3_c(2) = conjg (g_yuk_gsu1_3(1))
!    g_yuk_gsd1_3(1) = ( - (mix_sd312 * (gs / sqrt (2.0_omega_prec))))
!    g_yuk_gsd1_3(2) = (mix_sd311 * (gs / sqrt (2.0_omega_prec)))
!    g_yuk_gsd1_3_c(1) = conjg (g_yuk_gsd1_3(2))
!    g_yuk_gsd1_3_c(2) = conjg (g_yuk_gsd1_3(1))
!    g_yuk_gsu2_3(1) = ( - (mix_su322 * (gs / sqrt (2.0_omega_prec))))
!    g_yuk_gsu2_3(2) = (mix_su321 * (gs / sqrt (2.0_omega_prec)))
!    g_yuk_gsu2_3_c(1) = conjg (g_yuk_gsu2_3(2))
!    g_yuk_gsu2_3_c(2) = conjg (g_yuk_gsu2_3(1))
!    g_yuk_gsd2_3(1) = ( - (mix_sd322 * (gs / sqrt (2.0_omega_prec))))
!    g_yuk_gsd2_3(2) = (mix_sd321 * (gs / sqrt (2.0_omega_prec)))
!    g_yuk_gsd2_3_c(1) = conjg (g_yuk_gsd2_3(2))
!    g_yuk_gsd2_3_c(2) = conjg (g_yuk_gsd2_3(1))
! end subroutine setup_parameters16
!    call setup_parameters4
!    call setup_parameters5
!    call setup_parameters6
!    call setup_parameters7
!    call setup_parameters8
!    call setup_parameters10
!    call setup_parameters11
!    call setup_parameters14
!    call setup_parameters15
!    call setup_parameters16
  end subroutine import_from_whizard
end module omega_parameters_whizard

